digits = {
    0: "1111110",
    1: "0110000",
    2: "1011011",
    3: "1111001",
    4: "0110101",
    5: "1101101",
    6: "1101111",
    7: "1110000",
    8: "1111111",
    9: "1111101"
}

def can_display_as(real_digit, broken_segments, target_digit_pattern):
    digit_map = digits
    real_pattern = digit_map[real_digit]
    
    for i in range(7):
        if broken_segments[i] == '0' and real_pattern[i] == '1':
            return False
        
        if broken_segments[i] == '1' and real_pattern[i] != target_digit_pattern[i]:
            return False
    
    return True

def can_display_number_as(real_num, first_num, second_num, target_num):
    digit_map = digits
    
    if real_num < 10:
        real_ones = real_num
        if target_num >= 10:  
            return False
        return can_display_as(real_ones, second_num, digit_map[target_num])
    
    real_tens, real_ones = divmod(real_num, 10)
    
    if target_num < 10:  
        return False
    
    target_tens, target_ones = divmod(target_num, 10)
    
    return (can_display_as(real_tens, first_num, digit_map[target_tens]) and can_display_as(real_ones, second_num, digit_map[target_ones]))

def solve(first_num, second_num):
    max_illusion_length = 0
    
    for i in range(99, 1, -1):
        for j in range(1, 99):
            current_length = 0
            real_num = i
            display_num = j
            
            while (real_num >= 1 and display_num <= 98 and can_display_number_as(real_num, first_num, second_num, display_num)):
                current_length += 1
                real_num -= 1
                display_num += 1
            
            if current_length > 0:  
                max_illusion_length = max(max_illusion_length, current_length - 1)
    
    return max_illusion_length

first_num = input()
second_num = input()

ans = solve(first_num, second_num)
print(ans)