#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <future>

using namespace std;

string minimize_number(string s, long long k) {
    int n = s.length();
    
    for (int i = 0; i < n && k > 0; ++i) {
        char min_digit = s[i];
        int min_index = i;
        
        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < min_digit) {
                min_digit = s[j];
                min_index = j;
            }
        }
        
        if (min_index != i) {
            long long swaps_needed = min_index - i;
            
            if (swaps_needed <= k) {
                s.erase(s.begin() + min_index);
                s.insert(s.begin() + i, min_digit);
                
                k -= swaps_needed;
            }
        }
    }

    return s;
}

int main() {
    int t;
    cin >> t;
    vector<future<string>> results;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;

        results.push_back(async(launch::async, minimize_number, s, k));
    }

    for (auto& result : results) {
        cout << result.get() << "\n";
    }

    return 0;
}
