from functools import lru_cache

MOD = 998244353

@lru_cache(None)
def count_ways(r, g, b, last_color):
    if r == 0 and g == 0 and b == 0:
        return 1
    
    ways = 0
    
    if r > 0 and last_color != 'r':
        ways += count_ways(r - 1, g, b, 'r')
        ways %= MOD
    
    if g > 0 and last_color != 'g':
        ways += count_ways(r, g - 1, b, 'g')
        ways %= MOD
    
    if b > 0 and last_color != 'b':
        ways += count_ways(r, g, b - 1, 'b')
        ways %= MOD
    
    return ways

def calculate_arrangements(r, g, b):
    return count_ways(r, g, b, None)

r, g, b = map(int, input().split())
result = calculate_arrangements(r, g, b)
print(result)
