#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

struct Point {
    int x, y;
};

double cal(int x1, int x2, int x3, int y3) {
    return 0.5 * abs(x1 * (0 - y3) + x2 * (y3 - 0) + x3 * (0 - 0));
}

int main() {
    int n;
    cin >> n;

    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }

    vector<Point> xPoints;
    vector<Point> nonXPoints;

    for (const auto& point : points) {
        if (point.y == 0) {
            xPoints.push_back(point);
        } else {
            nonXPoints.push_back(point);
        }
    }

    sort(xPoints.begin(), xPoints.end(), [](const Point& a, const Point& b) {
        return a.x < b.x;
    });

    double maxi = 0.0;

    for (size_t i = 0; i < xPoints.size(); ++i) {
        for (size_t j = i + 1; j < xPoints.size(); ++j) {
            int x1 = xPoints[i].x;
            int x2 = xPoints[j].x;

            for (const auto& point : nonXPoints) {
                int x3 = point.x;
                int y3 = point.y;

                double area = cal(x1, x2, x3, y3);
                if (area > maxi) {
                    maxi = area;
                }
            }
        }
    }

    cout.precision(9);
    cout << fixed << maxi << endl;

    return 0;
}