#include "iostream"
#include "vector"
#include "cmath"
#include "numeric"
#include "utility"
#include "algorithm"
#include "map"
#include "string"

void solve() {

    std::string first_light, second_light;
    std::cin >> first_light >> second_light;

    std::map<int, std::string> number_to_code {
            {0, "1110111"},
            {1, "0010010"},
            {2, "1011101"},
            {3, "1011011"},
            {4, "0111010"},
            {5, "1101011"},
            {6, "1101111"},
            {7, "1010010"},
            {8, "1111111"},
            {9, "1111011"},
    };
    std::map<std::string, int> code_to_number {
            {"1110111", 0},
            {"0010010", 1},
            {"1011101", 2},
            {"1011011", 3},
            {"0111010", 4},
            {"1101011", 5},
            {"1101111", 6},
            {"1010010", 7},
            {"1111111", 8},
            {"1111011", 9},
    };

    int prev_number = -1;
    for (int tick = 99; tick > 0; --tick) {
        int first = tick/10;
        int second = tick % 10;

        if (tick >= 10) {
            std::string first_code = number_to_code[first];
            std::string second_code = number_to_code[second];

            std::string first_code_light = first_code;
            std::string second_code_light = second_code;

            for (int iter = 0; iter < 7; ++iter) {
                if (first_light[iter] == '0')
                    first_code_light[iter] = '0';
                if (second_light[iter] == '0')
                    second_code_light[iter] = '0';
            }

            if (code_to_number.find(first_code_light) != code_to_number.end() &&
                code_to_number.find(second_code_light) != code_to_number.end() ) {

                int current_number = code_to_number[first_code_light] * 10 + code_to_number[second_code_light];
                if (current_number == prev_number + 1) {
                    std::cout << 1 << '\n';
                    return;
                }
                prev_number = current_number;
            }
            else {
                prev_number = -1;
            }

        }
        else {
            std::string code = number_to_code[second];
            std::string code_light = code;
            for (int iter = 0; iter < 7; ++iter) {
                if (second_light[iter] == '0')
                    code_light[iter] = '0';
            }
            if (code_to_number.find(code_light) != code_to_number.end()) {
                int current_number = code_to_number[code_light];
                if (current_number == prev_number + 1) {
                    std::cout << 1 << '\n';
                    return;
                }
                prev_number = current_number;
            }
            else {
                prev_number = -1;
            }
        }
    }
    std::cout << 0 << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    unsigned long long t = 1;
    // std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
