#include <bits/stdc++.h>

struct edge {
    int u;
    long long w;

    edge() {}

    edge(int u, long long w) : u(u), w(w) {}
};

bool f = true;

std::vector <std::vector <edge>> g;
std::vector <std::vector <long long>> a;

void dfs(int root, int v, int p, long long dist) {
    for (auto u : g[root]) {
        if (u.u == p) {
            continue;
        }
        if (dist - u.w == a[v][u.u]) {
            dfs(u.u, v, root, dist - u.w);
            return;
        }
        else if (dist + u.w != a[v][u.u]) {
            std::cout << "No\n";
            exit(0);
        }
    }
    g[root].push_back(edge(v, dist));
    g[v].push_back(edge(root, dist));
}

void validate(int c, int v, int p, long long d) {
    if (d != a[c][v]) {
        std::cout << "No\n";
        exit(0);
    }
    for (auto u : g[v]) {
        if (u.u == p) {
            continue;
        }
        validate(c, u.u, v, d + u.w);
    }
}

void solve() {
    long long n;
    std::cin >> n;
    a.resize(n, std::vector <long long>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            std::cin >> a[i][j];
        }
    }
    g.resize(n);
    std::vector <std::pair <long long, int>> vert;
    for (int i = 1; i < n; ++i) {
        vert.push_back({a[0][i], i});
    }
    std::sort(vert.begin(), vert.end());
    for (auto i : vert) {
        dfs(0, i.second, -1, i.first);
        validate(i.second, i.second, -1, 0);
    }
    std::cout << "Yes\n";
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    unsigned long long t = 1;
    // std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
