#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <string>

using namespace std;

vector<string> find_route(int n, const vector<int>& populations, int s, int f) {
    s--;  // Преобразуем в 0-индексацию
    f--;  // Преобразуем в 0-индексацию

    deque<pair<int, vector<string>>> q;  // (текущий город, путь)
    set<int> visited;
    
    q.push_back({s, {}});
    
    while (!q.empty()) {
        auto [c, path] = q.front();
        q.pop_front();
        
        if (c == f) {
            return path;
        }
        
        if (visited.count(c)) {
            continue;
        }
        
        visited.insert(c);
        
        for (int m = 2; m <= 10; ++m) {  // Проверяем m от 2 до 10
            int l = c;
            while (l > 0 && populations[l] % m == populations[c] % m) {
                l--;
            }
            l++;  // Корректируем, чтобы не выйти за границы
            
            int r = c;
            while (r < n - 1 && populations[r] % m == populations[c] % m) {
                r++;
            }
            r--;  // Корректируем, чтобы не выйти за границы
            
            if (l <= r) {
                if (r != c) {
                    path.push_back("Kaban-" + to_string(m) + " " + to_string(c + 1) + " " + to_string(r + 1));
                    q.push_back({r, path});
                    path.pop_back();  // Удаляем последний элемент для следующей итерации
                }
            }
        }
    }

    return {"Impossible"};
}

int main() {
    int n;
    cin >> n;
    vector<int> populations(n);
    for (int i = 0; i < n; ++i) {
        cin >> populations[i];
    }
    int s, f;
    cin >> s >> f;

    vector<string> result = find_route(n, populations, s, f);

    if (result[0] == "Impossible") {
        cout << result[0] << endl;
    } else {
        cout << result.size() << endl;
        for (const string& line : result) {
            cout << line << endl;
        }
    }

    return 0;
}