
def factorial_mod(n, mod):
    f = [1] * (n + 1)
    for i in range(2, n + 1):
        f[i] = f[i - 1] * i % mod
    return f

def mod_inv(a, mod):
    return pow(a, mod - 2, mod)

def arrangements(r, g, b, mod):
    if r < 0 or g < 0 or b < 0:
        return 0

    M = max(r, g, b)
    S = r + g + b - M

    if M > S + 1:
        return 0

    total_shares = r + g + b
    fact = factorial_mod(total_shares, mod)

    return (fact[total_shares] * mod_inv(fact[r], mod) % mod * 
            mod_inv(fact[g], mod) % mod * 
            mod_inv(fact[b], mod) % mod)

r, g, b = map(int, input().split())
print(arrangements(r, g, b, 998244353))
