def grundy(piles):
    memo = {}

    def calculate_grundy(state):
        state_tuple = tuple(state)
        if state_tuple in memo:
            return memo[state_tuple]

        reachable_grundies = set()

        for i in range(len(state)):
            if state[i] > 0:
                new_state = state[:]
                new_state[i] -= 1

                reachable_grundies.add(calculate_grundy(new_state))

                for j in range(len(state)):
                    if j != i and state[j] > 0:
                        new_state = state[:]
                        new_state[i] -= 1
                        new_state[j] -= 1
                        reachable_grundies.add(calculate_grundy(new_state))

        mex_value = 0
        while mex_value in reachable_grundies:
            mex_value += 1

        memo[state_tuple] = mex_value
        return mex_value

    initial_grundy = calculate_grundy(piles)

    return initial_grundy

n = int(input())
piles = list(map(int, input().split()))

if grundy(piles) == 0:
    print("Dmitry")
else:
    print("Alice")
# 2 2 - dmitriy
# 2 2 2 - dmitriy