#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>

using namespace std;

struct Point {
    int x, y;
};

double calculate_area(const Point& p1, const Point& p2, const Point& p3) {
    return 0.5 * abs(p1.x * (p2.y - p3.y) + p2.x * (p3.y - p1.y) + p3.x * (p1.y - p2.y));
}

int main() {
    int n;
    cin >> n;
    vector<Point> points(n);

    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }

    vector<Point> on_x_axis, off_x_axis;

    for (const auto& point : points) {
        if (point.y == 0) {
            on_x_axis.push_back(point);
        } else {
            off_x_axis.push_back(point);
        }
    }

    double max_area = 0.0;

    if (on_x_axis.size() < 2 || off_x_axis.empty()) {
        cout << fixed << setprecision(9) << 0.0 << endl;
        return 0;
    }

    for (size_t i = 0; i < on_x_axis.size(); ++i) {
        for (size_t j = i + 1; j < on_x_axis.size(); ++j) {
            for (const auto& p : off_x_axis) {
                double area = calculate_area(on_x_axis[i], on_x_axis[j], p);
                max_area = max(max_area, area);
            }
        }
    }

    cout << fixed << setprecision(9) << max_area << endl;
    return 0;
}