#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

string minimize_number(string s, long long k) {
    int n = s.size();
    for (int i = 0; i < n && k > 0; ++i) {
        int pos = i;
        for (int j = i + 1; j < n && j - i <= k; ++j) {
            if (s[j] < s[pos]) {
                pos = j;
            }
        }
        int operations = pos - i;
        if (operations > k) {
            continue;
        }
        char min_digit = s[pos];
        for (int j = pos; j > i; --j) {
            s[j] = s[j - 1];
        }
        s[i] = min_digit;
        k -= operations;
    }
    return s;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        cout << minimize_number(s, k) << '\n';
    }

    return 0;
}
