#include <iostream>
#include <algorithm>

const int MOD = 998244353;

long long FactorialMod(int n) {
    if (n == 0 || n == 1)
        return 1;

    long long res = 1;
    for (int i = 2; i <= n; i++) {
        res = res * i % MOD;
    }
    return res;
}

long long InverseMod(long long a) {
    long long result = 1;
    long long exponent = MOD - 2;
    a = a % MOD;

    while (exponent > 0) {
        if (exponent & 1)
            result = result * a % MOD;
        a = a * a % MOD;
        exponent >>= 1;
    }
    return result;
}

long long CountArrangements(int r, int g, int b) {
    int maxColor = std::max(r, std::max(g, b));
    int total = r + g + b;
    int sumOthers = total - maxColor;

    if (maxColor > sumOthers + 1)
        return 0;

    long long arrangements = FactorialMod(total);
    arrangements = arrangements * InverseMod(FactorialMod(r)) % MOD;
    arrangements = arrangements * InverseMod(FactorialMod(g)) % MOD;
    arrangements = arrangements * InverseMod(FactorialMod(b)) % MOD;

    return arrangements;
}

int main() {
    int r, g, b;
    std::cin >> r >> g >> b;

    std::cout << CountArrangements(r, g, b) << std::endl;
    return 0;
}
