def max_triangle_area(points):
    base_points = [p for p in points if p[1] == 0]
    n = len(base_points)
    
    if n < 2:
        return 0.0  
    
    max_area = 0.0
    
    for i in range(n):
        for j in range(i + 1, n):
            x1, y1 = base_points[i]
            x2, y2 = base_points[j]
            base_length = abs(x2 - x1) 
            
            for p in points:
                if p[1] > 0:  
                    height = p[1]
                    area = 0.5 * base_length * height
                    max_area = max(max_area, area)
    
    return max_area

import sys

input = sys.stdin.read
data = input().strip().splitlines()
n = int(data[0])
points = [tuple(map(int, line.split())) for line in data[1:n + 1]]

result = max_triangle_area(points)

print(f"{result:.9f}")