#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

void minimizeNumber(string &s, long long k) {
    int n = s.length();

    for (int i = 0; i < n; ++i) {
        if (k <= 0) break; 

       
        char minChar = s[i];
        int minPos = i;

        
        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < minChar) {
                minChar = s[j];
                minPos = j;
            }
        }

        
        if (minPos != i) {
            
            long long movesNeeded = minPos - i;

            
            if (movesNeeded <= k) {
               
                for (int j = minPos; j > i; --j) {
                    swap(s[j], s[j - 1]);
                }
                
                k -= movesNeeded;
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    cin.ignore(); 

    while (t--) {
        string s;
        long long k;

        cin >> s >> k;
        minimizeNumber(s, k);
        cout << s << '\n';
    }

    return 0;
}