import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(reader.readLine());
        List<Point> points = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            String[] coords = reader.readLine().split(" ");
            int x = Integer.parseInt(coords[0]);
            int y = Integer.parseInt(coords[1]);
            points.add(new Point(x, y));
        }
        double maxArea = triangle(points);
        System.out.printf(Locale.US, "%.10f%n", maxArea);
    }

    private static double triangle(List<Point> points) {
        List<Point> basePoints = new ArrayList<>();
        List<Point> heightPoints = new ArrayList<>();

        for (Point point : points) {
            if (point.y == 0) {
                basePoints.add(point);
            } else {
                heightPoints.add(point);
            }
        }
        if (basePoints.size() < 2 || heightPoints.isEmpty()) {
            return 0.0;
        }
        double maxArea = 0.0;

        for (int i = 0; i < basePoints.size(); i++) {
            for (int j = i + 1; j < basePoints.size(); j++) {
                Point base1 = basePoints.get(i);
                Point base2 = basePoints.get(j);
                double baseLength = Math.abs(base2.x - base1.x);
                for (Point heightPoint : heightPoints) {
                    double height = heightPoint.y;
                    double area = Math.abs(0.5 * baseLength * height);
                    maxArea = Math.max(maxArea, area);
                }
            }
        }

        return maxArea;
    }
    static class Point {
        int x;
        int y;

        Point(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }
}