﻿#include <iostream>
#include <vector>

using namespace std;

bool isWoodenMatrix_111(const vector<vector<long long>>& d, int n) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            // Проверка неравенства треугольника с учетом k
            for (int k = 0; k < n; ++k) {
                if (d[i][j] > d[i][k] + d[k][j]) {
                    return false; // Неравенство нарушено
                }
            }
        }
    }
    return true; // Все проверки пройдены
}

int main() {
    int n;
    cin >> n;

    if (n < 1 || n > 1000) {
        cout << "No" << endl; // Выводим "No", если n вне диапазона
        return 0;
    }

    vector<vector<long long>> d(n, vector<long long>(n));

    // Чтение матрицы с проверкой на ограничения
    for (auto& row : d) {
        for (auto& elem : row) {
            cin >> elem;
            if (elem < 0 || elem > 1000000000) {
                cout << "No" << endl; // Выводим "No", если элемент вне диапазона
                return 0;
            }
        }
    }

    // Проверка, является ли матрица деревянной
    cout << (isWoodenMatrix_111(d, n) ? "Yes" : "No") << endl;

    return 0;
}
