﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;


double triangle_area(double base, double height) {
    return 0.5 * base * height;
}

int main() {
    int n;
    cin >> n;

    vector<pair<int, int>> x_axis_points;
    vector<pair<int, int>> non_x_axis_points;


    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        if (y == 0) {
            x_axis_points.emplace_back(x, y);
        }
        else {
            non_x_axis_points.emplace_back(x, y);
        }
    }


    if (x_axis_points.size() < 2 || non_x_axis_points.empty()) {
        cout << "0.0\n";
        return 0;
    }

    double max_area = 0.0;


    for (size_t i = 0; i < x_axis_points.size(); ++i) {
        for (size_t j = i + 1; j < x_axis_points.size(); ++j) {
            double base = abs(x_axis_points[i].first - x_axis_points[j].first);

            for (const auto& vertex : non_x_axis_points) {
                double height = abs(vertex.second);
                double area = triangle_area(base, height);
                max_area = max(max_area, area);
            }
        }
    }


    cout.precision(9);
    cout << fixed << max_area << '\n';

    return 0;
}
