﻿#include <iostream>
#include <string>
#include <deque>

using namespace std;

string minimizeWithSwaps(string s, long long k) {
    int n = s.size();

    for (int i = 0; i < n && k > 0; ++i) {

        deque<int> dq;

        for (int j = i; j < n && j - i <= k; ++j) {
            while (!dq.empty() && s[j] < s[dq.back()]) {
                dq.pop_back();
            }
            dq.push_back(j);
        }


        int minPos = dq.front();

        for (int j = minPos; j > i; --j) {
            swap(s[j], s[j - 1]);
        }


        k -= (minPos - i);
    }

    return s;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        cout << minimizeWithSwaps(s, k) << '\n';
    }

    return 0;
}
