﻿#include <iostream>  
#include <vector>  
#include <cmath>  

struct Point {
    int x, y;
    Point(int X, int Y) : x(X), y(Y) {}
};


static long double calculate(const Point& a, const Point& b, const Point& c) {
    return 0.5 * std::abs(a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y));
}

int main() {
    int n;
    std::cin >> n;

    int x, y;
    std::cin >> x >> y;
    Point x_min(x, y);
    Point x_max(x, y);
    std::vector<Point> yPoints;

    for (int i = 1; i < n; ++i) {
        std::cin >> x >> y;
        if (y == 0) {

            if (x < x_min.x) x_min = Point(x, y);
            if (x > x_max.x) x_max = Point(x, y);
        }
        else {

            yPoints.emplace_back(x, y);
        }
    }


    if (x_min.x == x_max.x || yPoints.empty()) {
        std::cout << 0;
        return 0;
    }

    long double maxArea = 0;


    for (const auto& el : yPoints) {
        long double area = calculate(x_min, x_max, el);
        if (area > maxArea) {
            maxArea = area;
        }
    }


    std::cout.precision(10);
    std::cout << std::fixed << maxArea << std::endl;
    return 0;
}