from collections import defaultdict

def is_tree_matrix(matrix):
    n = len(matrix)
    for i in range(n):
        if matrix[i][i] != 0:
            return "No"
    graph = defaultdict(list)
    for i in range(n):
        for j in range(i + 1, n):
            if matrix[i][j] > 0:
                graph[i].append((j, matrix[i][j]))
                graph[j].append((i, matrix[i][j]))
    visited = set()
    for start_node in range(n):
        if start_node not in visited:
            queue = [(start_node, -1)]
            visited.add(start_node)
            while queue:
                node, parent = queue.pop(0)
                for neighbor, _ in graph[node]:
                    if neighbor == parent:
                        continue
                    if neighbor in visited:
                        return "No"
                    visited.add(neighbor)
                    queue.append((neighbor, node))
    def check_distances(node, parent, distance):
        for neighbor, dist in graph[node]:
            if neighbor == parent:
                continue
            if distance + dist != matrix[node][neighbor]:
                return False
            if not check_distances(neighbor, node, distance + dist):
                return False
        return True
    return "Yes" if check_distances(0, -1, 0) else "No"
n = int(input())
matrix = []
for _ in range(n):
    row = list(map(int, input().split()))
    matrix.append(row)
print(is_tree_matrix(matrix))
