#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
#define sz(a) (int)((a).size())
using namespace __gnu_pbds;
template <class T>
using ordered_set =
    tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template <class T, class V>
ostream &operator<<(ostream &os, pair<T, V> const &p) {
  return os << "{" << p.first << "," << p.second << "}";
}
template <class T, class V, class Container>
basic_ostream<T, V> &operator<<(basic_ostream<T, V> &os, Container const &x) {
  os << "[ ";
  for (auto &y : x)
    os << y << " ";
  return os << "]";
}
template <typename T> bool chmin(T &a, T b) { return (b < a) ? a = b, 1 : 0; }
template <typename T> bool chmax(T &a, T b) { return (b > a) ? a = b, 1 : 0; }

#ifdef LOCAL
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) {
  cerr << " " << H;
  deb_out(T...);
}
#define deb(...) cerr << "(" << #__VA_ARGS__ << "):", deb_out(__VA_ARGS__)
#else
#define deb(...) 1
#endif

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
const int INF = 2e8;
struct segtree {
  vector<pair<ll, int>> tree;
  int size = 1;
  void init(int n) {
    size = 1;
    while (size < n)
      size *= 2;
    tree.assign(2 * size, {INF, -1});
  }
  void build(vector<char> &a, int x, int lx, int rx) {
    if (rx - lx == 1) {
      if (lx < a.size())
        tree[x] = {a[lx], lx};
      return;
    }
    int m = (lx + rx) / 2;
    build(a, x * 2 + 1, lx, m);
    build(a, x * 2 + 2, m, rx);
    tree[x] = min(tree[x * 2 + 1], tree[x * 2 + 2]);
  }

  void build(vector<char> &a) {
    init(a.size());
    build(a, 0, 0, size);
  }

  void set(int i, int v, int x, int lx, int rx) {
    if (rx - lx == 1) {
      tree[x] = {v, i};
      return;
    }
    int m = (lx + rx) / 2;
    if (i < m)
      set(i, v, x * 2 + 1, lx, m);
    else
      set(i, v, x * 2 + 2, m, rx);
    tree[x] = min(tree[x * 2 + 1], tree[x * 2 + 2]);
  }
  void set(int i, int v) { set(i, v, 0, 0, size); }
  pair<ll, int> sum(int l, int r, int x, int lx, int rx) {
    if (l >= rx || lx >= r) {
      return {INF, -1};
    }
    if (lx >= l && rx <= r) {
      return tree[x];
    }
    int m = (lx + rx) / 2;
    return min(sum(l, r, x * 2 + 1, lx, m), sum(l, r, x * 2 + 2, m, rx));
  }
  pair<char, int> sum(int l, int r) { return sum(l, r, 0, 0, size); }

  void print() {
    for (int i = 0; i < tree.size(); ++i)
      cout << tree[i] << ' ';
    cout << '\n';
  }
};
#define int long long

void solve_test() {
  string s;
  cin >> s;
  int n = sz(s);
  ordered_set<int> ost;
  int k;
  cin >> k;
  vector<char> a(n);
  for (int i = 0; i < n; ++i)
    a[i] = s[i];
  segtree st;
  st.build(a);
  for (int i = 0; i < n; ++i) {
    int l = -1, r = n;
    while (r > l + 1) {
      int mid = (r + l) / 2;
      auto x = ost.lower_bound(mid);
      int sub = 0;
      if (x == ost.end())
        sub += sz(ost);
      else
        sub += ost.order_of_key(*x);
      sub = mid + 1 - sub;
      (sub <= k + 1 ? l : r) = mid;
    }
    auto cur = st.sum(0, min(l + 1, n));
    auto x = ost.lower_bound(cur.second);
    int sub = 0;
    if (x == ost.end())
      sub += sz(ost);
    else
      sub += ost.order_of_key(*x);
    k -= cur.second - sub;
    cout << cur.first;
    st.set(cur.second, INF);
    ost.insert(cur.second);
  }
  cout << '\n';
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  for (int i = 1; i <= tt; ++i) {
    solve_test();
#ifdef LOCAL
    cout << "_____________________" << endl;
#endif
  }
#ifdef LOCAL
  cerr << endl << "Elapsed time: " << 1. * clock() / CLOCKS_PER_SEC << '\n';
#endif
  return 0;
}
