#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#endif
#include <bits/stdc++.h>
using namespace std;
#define sz(a) (int)((a).size())

template <class T, class V>
ostream &operator<<(ostream &os, pair<T, V> const &p) {
  return os << "{" << p.first << "," << p.second << "}";
}
template <class T, class V, class Container>
basic_ostream<T, V> &operator<<(basic_ostream<T, V> &os, Container const &x) {
  os << "[ ";
  for (auto &y : x)
    os << y << " ";
  return os << "]";
}
template <typename T> bool chmin(T &a, T b) { return (b < a) ? a = b, 1 : 0; }
template <typename T> bool chmax(T &a, T b) { return (b > a) ? a = b, 1 : 0; }

#ifdef LOCAL
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) {
  cerr << " " << H;
  deb_out(T...);
}
#define deb(...) cerr << "(" << #__VA_ARGS__ << "):", deb_out(__VA_ARGS__)
#else
#define deb(...) 1
#endif

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
#define int long long
struct DSU {
  int size;
  vector<int> p, r;
  void init(int n) {
    size = n;
    p.assign(n, 0);
    iota(p.begin(), p.end(), 0);
    r.assign(n, 1);
  }
  int get(int a) {
    if (a == p[a]) {
      return a;
    }
    p[a] = get(p[a]);
    return p[a];
  }

  void join(int _a, int _b) {
    int a = get(_a);
    int b = get(_b);
    if (r[a] > r[b]) {
      swap(a, b);
    }
    p[a] = b;
    if (r[a] == r[b]) {
      r[b]++;
    }
  }
};

void solve_test() {
  int n;
  cin >> n;
  vector<vector<int>> d(n, vector<int>(n));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      cin >> d[i][j];
    }
  }
  DSU dsu;
  dsu.init(n);
  vector<pair<int, int>> a;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      if (i != j) {
        a.push_back({i, j});
      }
    }
  }
  sort(a.begin(), a.end(), [&](auto xx, auto yy) {
    return d[xx.first][xx.second] < d[yy.first][yy.second];
  });
  for (auto p : a) {
    if (dsu.get(p.first) == dsu.get(p.second)) {
      continue;
    }
    vector<int> left, right;
    for (int i = 0; i < n; ++i) {
      if (dsu.get(i) == dsu.get(p.first)) {
        left.push_back(i);
      }
      if (dsu.get(i) == dsu.get(p.second)) {
        right.push_back(i);
      }
    }
    dsu.join(dsu.get(p.first), dsu.get(p.second));
    for (int l : left) {
      for (int r : right) {
        if (d[l][p.first] + d[p.first][p.second] + d[p.second][r] != d[l][r]) {
          cout << "No\n";
          return;
        }
      }
    }
  }
  cout << "Yes\n";
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  // cin >> tt;
  for (int i = 1; i <= tt; ++i) {
    solve_test();
#ifdef LOCAL
    cout << "_____________________" << endl;
#endif
  }
#ifdef LOCAL
  cerr << endl << "Elapsed time: " << 1. * clock() / CLOCKS_PER_SEC << '\n';
#endif
  return 0;
}
