#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>
 
using namespace std;
 
#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto b, auto c) {return b > c;})
 
ifstream fin("input.txt");
ofstream fout("output.txt");
 
using ll = long long;
using ld = long double;
using ull = unsigned long long;
 
ll const inf = 1e18;
 
template <class T>
istream& operator>> (istream& in, vector<T>& a)
{
	for (T& e : a)
		in >> e;
	return in;
}
 
template <class T>
ostream& operator<< (ostream& out, const vector<T>& a)
{
	for (const T& e : a)
		out << e << " ";
	return out;
}
 
template<class T, class N> auto min(T a, N b)
{
	return sizeof(a) > sizeof(b) ? min(a, (T)b) : min((N)a, b);
}
 
template<class T, class N> auto max(T a, N b)
{
	return sizeof(a) > sizeof(b) ? max(a, (T)b) : max((N)a, b);
}
 
const ll mod = 998244353;
 
ll bin_pow_mod(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
			res %= mod;
		}
 
		n >>= 1;
		a *= a;
		a %= mod;
	}
 
	return res;
}
 
ll bin_pow(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
		}
 
		n >>= 1;
		a *= a;
	}
 
	return res;
}
 
ll gcd(ll a, ll b)
{
	while (b)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}
 
random_device rd;
mt19937 mersenne(rd());

void solve();
 
// #define TIME
// #define ONCE
 
signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
 
	ll TT = 1;
#ifndef ONCE 
	cin >> TT;
#endif
	while (TT--)
	{
#ifdef TIME
		clock_t start, end;
 
		start = clock();
#endif
		solve();
#ifdef TIME
		end = clock();
 
		cerr << "\ntime: " << ((double)end - start) / ((double)CLOCKS_PER_SEC) << " s\n";
#endif
		cerr << '\n';
	}
	return 0;
}

ll true_mod(ll a, ll m) {
	if (m < 0) {
		m *= -1;
	}
	return ((a % m) + m) % m;
}
ll true_div(ll a, ll m) {
	return (a - true_mod(a , m)) / m;
}

void solve() 
{
	string s; ll k;
	cin >> s >> k;
	ll n = s.size();
	vector<ll> cnt(10, 0);
	ll pref = 0;
	ll sum = 0;
	ll d = s[pref] - '0';
	while (k > 0 && pref < n)
	{
		d = s[pref] - '0';
		sum = 0;
		for (int i = d + 1; i < 10; ++i)
		{
			sum += cnt[i];
		}
		if (k >= sum)
		{
			cnt[d]++;
			++pref;
			k -= sum;
		}
		else
		{
			break;
		}
	}




	ll sumall = 0;
	for (int i = 0; i < 10; ++i)
	{
		sumall += cnt[i];
	}
	ll cnti = 0;
	ll j = 0;
	while (j < sumall - k)
	{
		if (cnt[cnti] == 0)
		{
			++cnti;
		}
		else
		{
			cout << cnti;
			cnt[cnti]--;
			++j;
		}
	}
	if (pref < n)
	{
		cout << d;
	}
	while (j < sumall)
	{
		if (cnt[cnti] == 0)
		{
			++cnti;
		}
		else
		{
			cout << cnti;
			cnt[cnti]--;
			++j;
		}
	}
	for (int t = pref + 1; t < n; ++t)
	{
		cout << s[t];
	}
}
