#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>
 
using namespace std;
 
#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto b, auto c) {return b > c;})
 
ifstream fin("input.txt");
ofstream fout("output.txt");
 
using ll = long long;
using ld = long double;
using ull = unsigned long long;
 
ll const inf = 1e18;
 
template <class T>
istream& operator>> (istream& in, vector<T>& a)
{
	for (T& e : a)
		in >> e;
	return in;
}
 
template <class T>
ostream& operator<< (ostream& out, const vector<T>& a)
{
	for (const T& e : a)
		out << e << " ";
	return out;
}
 
template<class T, class N> auto min(T a, N b)
{
	return sizeof(a) > sizeof(b) ? min(a, (T)b) : min((N)a, b);
}
 
template<class T, class N> auto max(T a, N b)
{
	return sizeof(a) > sizeof(b) ? max(a, (T)b) : max((N)a, b);
}
 
const ll mod = 998244353;
 
ll bin_pow_mod(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
			res %= mod;
		}
 
		n >>= 1;
		a *= a;
		a %= mod;
	}
 
	return res;
}
 
ll bin_pow(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
		}
 
		n >>= 1;
		a *= a;
	}
 
	return res;
}
 
ll gcd(ll a, ll b)
{
	while (b)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}
 
random_device rd;
mt19937 mersenne(rd());

void solve();
 
// #define TIME
#define ONCE
 
signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
 
	ll TT = 1;
#ifndef ONCE 
	cin >> TT;
#endif
	while (TT--)
	{
#ifdef TIME
		clock_t start, end;
 
		start = clock();
#endif
		solve();
#ifdef TIME
		end = clock();
 
		cerr << "\ntime: " << ((double)end - start) / ((double)CLOCKS_PER_SEC) << " s\n";
#endif
		cerr << '\n';
	}
	return 0;
}

ll true_mod(ll a, ll m) {
	if (m < 0) {
		m *= -1;
	}
	return ((a % m) + m) % m;
}
ll true_div(ll a, ll m) {
	return (a - true_mod(a , m)) / m;
}

bool arr[400];

struct trio{
	ll s;
	ll f;
	ll mod;
};

void solve() 
{
	ll n; cin >> n;
	vector<ll> a(n + 1);
	vector<trio> ans;

	for(int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	ll st, fn;
	cin >> st >> fn;
	bool rev = fn < st;
	if(rev) {
		std::swap(fn, st);
	}
	for(ll s = st; s < fn; ){
		ll cur_gcd = 0; 
		ll f = s;
		while (abs(a[f + 1] - a[s]) == 0 && f < fn)
		{
			f += 1;
		}
		
		for(; f < fn && gcd(cur_gcd, abs(a[f + 1] - a[s])) != 1; f++) {
			cur_gcd = gcd(cur_gcd, abs(a[f + 1] - a[s]));
		}

		if (f == s) {
			cout << "Impossible\n";
			return;
		} else{
			if(cur_gcd == 0) {
				cur_gcd = 2;
			}
			ans.push_back({s, f, cur_gcd});
		}
		s = f;
	}
	if(!rev) {
		for(int i = 0; i < ans.size(); i++) {
			cout << "Kaban-" << ans[i].mod << ' ' << ans[i].s << ' ' << ans[i].f << endl;
		}
	} else {
		reverse(all(ans));

		for(int i = 0; i < ans.size(); i++) {
			cout << "Kaban-" << ans[i].mod << ' ' << ans[i].f << ' ' << ans[i].s << endl;
		}
	}
}
