#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>
 
using namespace std;
 
#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto b, auto c) {return b > c;})
 
ifstream fin("input.txt");
ofstream fout("output.txt");
 
using ll = long long;
using ld = long double;
using ull = unsigned long long;
 
ll const inf = 1e18;
 
template <class T>
istream& operator>> (istream& in, vector<T>& a)
{
	for (T& e : a)
		in >> e;
	return in;
}
 
template <class T>
ostream& operator<< (ostream& out, const vector<T>& a)
{
	for (const T& e : a)
		out << e << " ";
	return out;
}
 
template<class T, class N> auto min(T a, N b)
{
	return sizeof(a) > sizeof(b) ? min(a, (T)b) : min((N)a, b);
}
 
template<class T, class N> auto max(T a, N b)
{
	return sizeof(a) > sizeof(b) ? max(a, (T)b) : max((N)a, b);
}
 
const ll mod = 998244353;
 
ll bin_pow_mod(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
			res %= mod;
		}
 
		n >>= 1;
		a *= a;
		a %= mod;
	}
 
	return res;
}
 
ll bin_pow(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
		}
 
		n >>= 1;
		a *= a;
	}
 
	return res;
}
 
ll gcd(ll a, ll b)
{
	while (b)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}
 
random_device rd;
mt19937 mersenne(rd());

void solve();
 
// #define TIME
#define ONCE
 
signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
 
	ll TT = 1;
#ifndef ONCE 
	cin >> TT;
#endif
	while (TT--)
	{
#ifdef TIME
		clock_t start, end;
 
		start = clock();
#endif
		solve();
#ifdef TIME
		end = clock();
 
		cerr << "\ntime: " << ((double)end - start) / ((double)CLOCKS_PER_SEC) << " s\n";
#endif
		cerr << '\n';
	}
	return 0;
}

ll true_mod(ll a, ll m) {
	if (m < 0) {
		m *= -1;
	}
	return ((a % m) + m) % m;
}
ll true_div(ll a, ll m) {
	return (a - true_mod(a , m)) / m;
}

char readChars(ll cnt)
{
	char c;
	for (int i = 0; i < cnt; ++i)
	{
		cin >> c;
	}
	return c;
}

void readLine()
{
	string s;
	getline(cin, s);
}

const ll CON = 2;

void solve() 
{
	readChars(9);
	ll start; cin >> start;
	readChars(3);
	ll finish; cin >> finish;
	readLine();

	vector<ll> s, f;

	while (true)
	{
		char c = readChars(1);
		if (c == 'w')
		{
			readLine();
			break;
		}
		readChars(5);
		ll cs; cin >> cs;
		readChars(3);
		ll cf; cin >> cf;
		readLine();
		s.push_back(cs);
		f.push_back(cf);
	}
	readLine();

	ll k = s.size();

	map<ll, pair<ll, ll>> jump;
	for (int i = s.size() - 1; i >= 0; --i)
	{
		ll cs = s[i];
		ll cf = f[i];
		if (jump.find(cf) != jump.end())
		{
			jump[cs] = {jump[cf].first, jump[cf].second + 1};
		}
		else
		{
			jump[cs] = {cf, 1};
		}
	}

	set<ll> visited;
	ll path = 0;
	ll v = start;
	while (true)
	{
		if (visited.count(v))
		{
			cout << -1 << '\n';
			return;
		}
		visited.insert(v);
		auto nextIt = jump.lower_bound(v);
		if (nextIt == jump.end())
		{
			path += (finish - v) * (k + 3);
			cout << path + CON << '\n';
			return;
		}
		auto next = *nextIt;
		path += (next.first - v) * (k + 3);
		path += next.second.second + k + 3;
		v = next.second.first + 1;
	}
}
