import kotlin.math.max


fun conv(s: String): Int? {
    return when (s) {
        "1110111" -> 0
        "0010010" -> 1
        "1011101" -> 2
        "1011011" -> 3
        "0111010" -> 4
        "1101011" -> 5
        "1101111" -> 6
        "1010010" -> 7
        "1111111" -> 8
        "1111011" -> 9
        else -> null
    }
}

fun conv2(i: Int): String =
    when(i) {
        0 -> "1110111"
        1 -> "0010010"
        2 -> "1011101"
        3 -> "1011011"
        4 -> "0111010"
        5 -> "1101011"
        6 -> "1101111"
        7 -> "1010010"
        8 -> "1111111"
        9 -> "1111011"
        else -> ""
    }

fun mul(s1: String, s2: String) =
    (0..6).map { if (s1[it] == '1' && s2[it] == '1') '1' else '0' }.joinToString("")

/*
    val v = listOf("0000000",
    "0010010",
    "1011101",
    "1011011",
    "0111010",
    "1101011",
    "1101111",
    "1010010",
    "1111111",
    "1111011")
    v.forEachIndexed { i, s ->
        println
    }
*/

class Digits(
    val d1: String,
    val d2: String
) {
    val num = run {
        var a1 = conv(d1)
        val a2 = conv(d2)
        if (d1.contains('1').not()) a1 = 0
        if (a1 == null || a2 == null) null
        else a1 * 10 + a2
    }

    fun mul(d: Digits) = Digits(mul(d1, d.d1), mul(d2, d.d2))
    override fun toString() = d1 + " " + d2
}

fun main() {
    val d1 = readln()
    val d2 = readln()
    val d = Digits(d1, d2)

    val nums = (0..99).map {
        if (it <= 9)
            Digits("0000000", conv2(it))
        else
            Digits(conv2(it/10), conv2(it%10))
    }.map { it.mul(d).num }.asReversed()

    var mx = 0
    var last: Int? = -100
    var ln = 0
    for (x in nums) {
        if (last != null && last + 1 == x) {
            ln += 1
        } else {
            ln = 0
        }
        last = x
        mx = max(ln, mx)
    }
    println(mx)
}
