//#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
//#pragma GCC target("avx2,avx,sse,sse2,sse3,ssse3,sse4,abm,mmx")
//#pragma GCC march("native")

#include <iostream>
#include <cmath>
#include <vector> 
#include <string>
#include <algorithm>
#include <utility>

#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

template <typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> p) {
    os << "(" << p.first << ", " << p.second << ")";
    return os;
} 

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (T& x : v) os << x << " ";
    return os;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& os, map<T1,T2>& m) {
    for (auto& p : m) os << "{" << p.first << "," << p.second << "} ";
    return os;
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);

    int n;
    cin >> n;
    if (n < 3) {
        cout << 0<< endl;
        return 0;
    }
    int l = 1e6, r = -1e6, max_y = -1;
    for (int i = 0; i < n; i ++) {
        int x, y;
        cin >> x >> y;

        if (y == 0) {
            l = min(l, x);
            r = max(r, x);
        } else {
            max_y = max(max_y, abs(y));
        }
    }

    if (r < -10000) {
        cout << 0 << endl;
        return 0;
    }
    if (l == r || max_y <= 0)
        cout << 0 << endl;
    else 
        cout << (r - l) * max_y * 0.5L << endl;
}