
#include <iostream>
#include <cmath>
#include <vector> 
#include <string>
#include <algorithm>
#include <utility>
#include <assert.h>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

template <typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> p) {
    os << "(" << p.first << ", " << p.second << ")";
    return os;
} 

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (T& x : v) os << x << " ";
    return os;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& os, map<T1,T2>& m) {
    for (auto& p : m) os << "{" << p.first << "," << p.second << "} ";
    return os;
}

int mask1 = 0;
int mask2 = 0;

int d_to_img(int d) {
    if (d == 0)
        return 0b01110111;
    if (d == 1)
        return 0b00100100;
    if (d == 2)
        return 0b01011101;
    if (d == 3)
        return 0b01101101;
    if (d == 4)
        return 0b00101110;
    if (d == 5)
        return 0b01101011;
    if (d == 6)
        return 0b01111011;
    if (d == 7)
        return 0b00100101;
    if (d == 8)
        return 0b01111111;
    if (d == 9)
        return 0b01101111;
    assert(0);
}

int img_to_d(int img) {
    if (img == 0b01110111)
        return 0;
    if (img == 0b00100100)
        return 1;
    if (img == 0b01011101)
        return 2;
    if (img == 0b01101101)
        return 3;
    if (img == 0b00101110)
        return 4;
    if (img == 0b01101011)
        return 5;
    if (img == 0b01111011)
        return 6;
    if (img == 0b00100101)
        return 7;
    if (img == 0b01111111)
        return 8;
    if (img == 0b01101111)
        return 9;
    return -1;
}

int get(int n) {
    assert (0 <= n && n <= 99);

    int d1 = n / 10;
    int d2 = n % 10;

    int img1 = (d_to_img(d1) & mask1);
    int img2 = (d_to_img(d2) & mask2);
    //cout << img1 << " " << img2 << endl;
    int new_d1 = img_to_d(img1);
    int new_d2 = img_to_d(img2);
    //cout << new_d1 << " " << new_d2 << endl;

    if (d1 == 0) {
        return new_d2;
    }

    if (new_d1 == -1 || new_d2 == -1)
        return -1;

    return new_d1 * 10 + new_d2;
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);

    string s1, s2;
    cin >> s1 >> s2;
    for (int i = 0; i < 7; i ++) {
        int c = s1[i];
        if (c == '1') {
            mask1 |= (1 << i);
        }
        c = s2[i];
        if (c == '1') {
            mask2 |= (1 << i);
        }
    }

    //cout << (int) mask1 << " " << (int) mask2 << endl;
    for (int k = 98; k >= 0; k --) {
        for (int y = k+1; y <= 99; y ++) {
            bool res = 1;

            int x = get(y);
            for (int i = 1; i <= k; i ++) {
                if (get(y - i) != x + i) {
                    res = 0;
                }
            }
            if (res == 1) {
                cout << k << endl;
                return 0;
            }
        }
    }

    cout << 0 << endl;
    
    return 0;
}