//#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
//#pragma GCC target("avx2,avx,sse,sse2,sse3,ssse3,sse4,abm,mmx")
//#pragma GCC march("native")

#include <iostream>
#include <cmath>
#include <vector> 
#include <string>
#include <algorithm>
#include <utility>

#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

template <typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> p) {
    os << "(" << p.first << ", " << p.second << ")";
    return os;
} 

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (T& x : v) os << x << " ";
    return os;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& os, map<T1,T2>& m) {
    for (auto& p : m) os << "{" << p.first << "," << p.second << "} ";
    return os;
}

struct ans {
    int inf_count;
    int min_x;
    int min_i;

    ans(int a, int b, int c): inf_count{a}, min_x{b}, min_i{c} {}
    ans() {}
};

ans combine(ans a, ans b) {
    ans c;
    c.inf_count = a.inf_count + b.inf_count;
    if (a.min_x <= b.min_x) {
        c.min_x = a.min_x;
        c.min_i = a.min_i;
    } else {
        c.min_x = b.min_x;
        c.min_i = b.min_i;
    }
    return c;
}

struct node {
    node *left, *right;
    ans a;

    node(int i, int x): a{1, x, i} {left = nullptr; right = nullptr;}
    node(node* l, node* r) {left = l; right = r; a = combine(left->a, right->a);}

    void update() {
        if (left == nullptr) return;
        a = combine(left->a, right->a);
    }

    ans get(int l, int r, int l_q, int r_q) {
        //cout << l << " " << r << " " << l_q << " " << r_q << endl;
        if (l_q == r_q) return {0, 999, -1};
        if (l_q >= r || r_q <= l) return {0, 999, -1};
        if (l_q <= l && r_q >= r) return a;
        int m = (l + r) / 2;
        return combine(left->get(l, m, l_q, r_q), right->get(m, r, l_q, r_q));
    }

    void set(int l, int r, int i) {
        if (r - l == 1) {
            a = {0, 1000000000, l};
            return;
        }
        int m = (l + r) / 2;
        if (i < m)
            left->set(l, m, i);
        else
            right->set(m, r, i);
        update();
    }

    int find(int l, int r, int k) {
        if (r - l == 1) {
            //cout << l << " " << r << " " << k << " " << a.inf_count << endl;
            if (k == 0 && a.inf_count > 0)
                return l;
            else
                return r;
        }
        int q = left->a.inf_count;
        //cout << l << " " << r << " " << k << " " << q << endl;
        int m = (l + r) / 2;
        if (q == k)
            return m;
        if (q < k)
            return right->find(m, r, k - q);
        return left->find(l, m, k);
    }
};

node* build(string& a, int l, int r) {
    if (r - l == 1) return new node(l, a[l]);
    int m = (l + r) / 2;
    return new node(build(a, l, m), build(a, m, r));
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        long long n = s.length();
        node* root = build(s, 0, n);
        for (int i = 0; i < n; i++) {
            int x = root->find(0, n, k + 1);
            //cout << x << endl;
            ans a = root->get(0, n, 0, x);
            cout << (char) a.min_x;// << " " << a.min_i << " " << a.inf_count << endl;
            k -= root->get(0, n, 0, a.min_i).inf_count;
            root->set(0, n, a.min_i);
            
        }
        cout << endl;
    }
}