#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#define dbg(x) cerr << __LINE__ << " " << #x << " " << x << endl
#define ln cerr << __LINE__ << " fine, thanks" << endl
#else
#define dbg(x) void(0)
#define ln void(0)
#endif 

typedef long long ll;
typedef pair<int, int> pii;

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& e : a) in >> e;
    return in;
}

template <typename F, typename S>
istream& operator>>(istream& in, pair<F, S>& p)
{
    in >> p.first >> p.second;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a)
{
    for (auto &e : a)
    {
        out << e << " ";
        if (typeid(T) != typeid(int) && typeid(T) != typeid(long long))
            out << "\n";
    }
    return out;
}

template <typename F, typename S>
ostream& operator<<(ostream& out, const pair<F, S>& p)
{
    out << p.first << " " << p.second;
    return out;
}

#define forn(i, n) for (int i = 0; (i) != (n); (i)++)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())
#define safe(x, n) (0 <= (x) && (x) < (n))
#define withBit(mask, i) ((mask & (1LL << (i))) > 0)

struct DSU
{
    vector<int> root, sz;

    DSU(int n)
    {
        root.resize(n);
        sz.resize(n, 1);
        forn(i, n) root[i] = i;
    }

    int Root(int x)
    {
        if (x == root[x]) return x;
        return root[x] = Root(root[x]);
    }

    void Merge(int v, int u)
    {
        v = Root(v), u = Root(u);
        if (sz[v] < sz[u]) {
            sz[u] += sz[v];
            root[v] = u;
        } else {
            sz[v] += sz[u];
            root[u] = v;
        }
    }
};

void solve()
{
    int n;
    cin >> n;
    vector<vector<int> > d(n, vector<int>(n));
    cin >> d;

    vector<array<int, 3> > edges;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            edges.push_back({d[i][j], i, j});
        }
    }
    sort(all(edges));
    DSU D(n);

    vector<vector<pii> > g(n);
    for (auto e : edges) {
        if (D.Root(e[1]) != D.Root(e[2])) {
            D.Merge(e[1], e[2]);
            g[e[1]].push_back({e[2], e[0]});
            g[e[2]].push_back({e[1], e[0]});
        }
    }

    for (int i = 0; i < n; i++) {
        vector<ll> dist(n, -1);
        dist[i] = 0;
        vector<int> q = {i};
        for (int j = 0; j < q.size(); j++) {
            for (auto e : g[q[j]]) {
                if (dist[e.first] == -1) {
                    dist[e.first] = dist[q[j]] + e.second;
                    q.push_back(e.first);
                }
            }
        }
        for (int j = 0; j < n; j++) {
            if (dist[j] != d[i][j]) {
                cout << "No\n";
                return;
            }
        }
    }
    cout << "Yes\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    double st = clock();
    #endif 

    int t = 1;
    #ifdef tests
    cin >> t;
    #endif
    while (t--)
    {
        solve();
    }

    #ifdef LOCAL
    cerr << setprecision(5) << "Succeed in " << (clock() - st) / CLOCKS_PER_SEC << " s\n";
    #endif 
}
