const int MOD = 998'244'353;

#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#define dbg(x) cerr << __LINE__ << " " << #x << " " << x << endl
#define ln cerr << __LINE__ << " fine, thanks" << endl
#else
#define dbg(x) void(0)
#define ln void(0)
#endif 

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& e : a) in >> e;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a)
{
    for (auto &e : a)
    {
        out << e << " ";
        if (typeid(T) != typeid(int) && typeid(T) != typeid(long long))
            out << "\n";
    }
    return out;
}

template <const int mod = MOD>
struct modint
{
    int val;

    modint()
    {
        val = 0;
    }

    modint(int x)
    {
        if (x < 0 || x >= mod)
            x = x % mod;
        if (x < 0)
            x += mod;
        val = x;
    }

    modint(long long x)
    {
        if (x < 0 || x >= mod)
            x = x % mod;
        if (x < 0)
            x += mod;
        val = x;
    }

    inline modint<mod> operator+=(const modint<mod>& other)
    {
        val += other.val;
        if (val >= mod)
            val -= mod;
        return *this;
    }

    inline modint<mod> operator-=(const modint<mod>& other)
    {
        val -= other.val;
        if (val < 0)
            val += mod;
        return *this;
    }

    inline modint<mod> operator*=(const modint<mod>& other)
    {
        val = 1ll * val * other.val % mod;
        return *this;
    }

    inline modint<mod> operator/=(const modint<mod>& other)
    {
        *this *= inv(other);
        return *this;
    }

    inline bool operator==(const modint<mod>& other)
    {
        return val == other.val;
    }
};

template <const int mod>
inline modint<mod> operator+(modint<mod> x, const modint<mod>& y)
{
    x += y;
    return x;
}

template <const int mod>
inline modint<mod> operator+(modint<mod> x, const long long& y)
{
    x += y;
    return x;
}

template <const int mod>
inline modint<mod> operator+(const long long& x, modint<mod> y)
{
    y += x;
    return y;
}

template <const int mod>
inline modint<mod> operator-(modint<mod> x, const modint<mod>& y)
{
    x -= y;
    return x;
}

template <const int mod>
inline modint<mod> operator-(modint<mod> x, const long long& y)
{
    x -= y;
    return x;
}

template <const int mod>
inline modint<mod> operator-(const long long& x, const modint<mod>& y)
{
    return modint<mod>(x - y.val);
}

template <const int mod>
inline modint<mod> operator*(modint<mod> x, const modint<mod>& y)
{
    x *= y;
    return x;
}

template <const int mod>
inline modint<mod> operator*(modint<mod> x, const long long& y)
{
    x *= y;
    return x;
}

template <const int mod>
inline modint<mod> operator*(const long long& x, modint<mod> y)
{
    y *= x;
    return y;
}

template <const int mod>
inline modint<mod> binpow(const modint<mod>& x, long long d)
{
    modint<mod> res = 1, f = x;
    while (d >= 1)
    {
        if (d % 2) res *= f;
        f *= f;
        d /= 2;
    }
    return res;
}

template <const int mod>
inline modint<mod> inv(const modint<mod>& x)
{
    return binpow(x, mod - 2);
}

template <const int mod>
inline modint<mod> operator/(modint<mod> x, const modint<mod>& y)
{
    x /= y;
    return x;
}

template <const int mod>
inline modint<mod> operator/(modint<mod> x, const long long& y)
{
    x /= y;
    return x;
}

template <const int mod>
inline modint<mod> operator/(const long long& x, const modint<mod>& y)
{
    return (modint<mod>(x) / y);
}

template <const int mod>
istream& operator>>(istream& in, modint<mod>& a)
{
    in >> a.val;
    return in;
}

template <const int mod>
ostream& operator<<(ostream& out, const modint<mod>& a)
{
    out << a.val;
    return out;
}

inline long long binpow(long long x, long long d, long long mod)
{
    long long res = 1 % mod, f = x % mod;
    while (d >= 1)
    {
        if (d % 2) res = res * f % mod;
        f = f * f % mod;
        d /= 2;
    }
    return res;
}

const int _ifact_limit = 5e6;

template <const int mod = MOD>
struct _ifact_storage_
{
    vector<modint<mod> > fact, ifact, inv;

    inline void touch(int n)
    {
        if (n < 2) n = 2;
        if (fact.size() > size_t(n)) return;
        int pn = fact.size();
        fact.resize(n); ifact.resize(n); inv.resize(n);
        if (pn == 0)
        {
            inv[1] = 1;
            fact[0] = 1;
            fact[1] = 1;
            ifact[0] = 1;
            ifact[1] = 1;
            pn = 2;
        }
        for (int i = pn; i < n; i++)
        {
            inv[i] = mod - inv[mod % i] * (mod / i);
            fact[i] = fact[i - 1] * i;
            ifact[i] = ifact[i - 1] * inv[i];
        }
    }
};

_ifact_storage_<MOD> _ifact_storage;

template <const int mod = MOD>
inline modint<mod> fact(const int& n, _ifact_storage_<mod>& st = _ifact_storage)
{
    st.touch(n + 1);
    return st.fact[n];
}

template <const int mod = MOD>
inline modint<mod> invmem(const int& n, _ifact_storage_<mod>& st = _ifact_storage)
{
    st.touch(n + 1);
    return st.inv[n];
}

template <const int mod = MOD>
inline modint<mod> ifact(const int& n, _ifact_storage_<mod>& st = _ifact_storage)
{
    st.touch(n + 1);
    return st.ifact[n];
}

template <const int mod = MOD>
inline modint<mod> cnk2(const int& n, int k, _ifact_storage_<mod>& st = _ifact_storage)
{
    modint<mod> res = 1;
    k = min(k, n - k);
    for (int i = 1; i <= k; i++)
    {
        res *= (n + 1 - i);
        if (i < _ifact_limit)
            res *= invmem(i, st);
        else
            res /= i;
    }
    return res;
}

template <const int mod = MOD>
inline modint<mod> cnk(const int& n, const int& k, _ifact_storage_<mod>& st = _ifact_storage)
{
    if (k < 0 || k > n)
        return 0;
    if (n > _ifact_limit)
        return cnk2(n, k, st);
    st.touch(n + 1);
    return fact(n, st) * ifact(k, st) * ifact(n - k, st);
}

#define forn(i, n) for (int i = 0; (i) != (n); (i)++)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())
#define safe(x, n) (0 <= (x) && (x) < (n))
#define withBit(mask, i) ((mask & (1LL << (i))) > 0)

using mint = modint<MOD>;

void solve()
{
    int r, g, b;
    cin >> r >> g >> b;

    if (max({r, g, b}) > r + g + b - max({r, g, b}) + 1) {
        cout << 0 << "\n";
        return;
    }

    mint ans = 0;

    for (int ngaps = r - 1; ngaps <= r + 1; ngaps++) {
        for (int y = 0; y <= ngaps; y++) {
            
            
            

            int A = ngaps - y;
            int B = g - b;
            if (abs(A) % 2 != abs(B) % 2) {
                continue;
            }

            int x = (A + B) / 2;
            int z = (A - B) / 2;

            if (x < 0 || z < 0) {
                continue;
            }

            if (x + y + z != ngaps) {
                continue;
            }

            int m = g + b - y;
            int k = ngaps;
            if (m % 2 != k % 2 || m < k) {
                continue;
            }

            mint res = cnk((m - k) / 2 + k - 1, k - 1);
            mint two = 2;
            res *= cnk(x + y + z, y);
            res *= binpow(two, y);
            res *= cnk(x + z, x);
            ans += res;
            if (ngaps == r) ans += res;
        }
    }
    cout << ans << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    double st = clock();
    #endif 

    int t = 1;
    #ifdef tests
    cin >> t;
    #endif
    while (t--)
    {
        solve();
    }

    #ifdef LOCAL
    cerr << setprecision(5) << "Succeed in " << (clock() - st) / CLOCKS_PER_SEC << " s\n";
    #endif 
}
