
#include <bits/stdc++.h>

// #define FSTREAM
// #define MULTITEST

using namespace std;

typedef long long ll;
typedef long double ld;

void dfs(size_t v, const vector<set<pair<ll, size_t>>> &g, vector<bool> &used, size_t start, ll dist, vector<vector<ll>> &d) {
    used[v] = true;
    for (auto edge : g[v]) {
        ll w = edge.first;
        size_t u = edge.second;
        if (used[u]) {
            continue;
        }
        d[start][u] = dist + w;
        dfs(u, g, used, start, dist + w, d);
    }
}

void solve() {
    size_t n;
    cin >> n;
    vector<vector<ll>> d(n);
    vector<set<pair<ll, size_t>>> g(n);
    for (size_t i = 0; i < n; ++i) {
        d[i].resize(n);
        for (size_t j = 0; j < n; ++j) {
            cin >> d[i][j];
        }
        if (i < n - 1) {
            size_t idx = i + 1;
            for (size_t j = 0; j < n; ++j) {
                if (j == i)  {
                    continue;
                }
                if (g[i].find({d[i][j], j}) != g[i].end()) {
                    continue;
                }
                if (d[i][j] < d[i][idx]) {
                    idx = j;
                }
            }
            g[i].insert({d[i][idx], idx});
            g[idx].insert({d[i][idx], i});
        }
    }
    vector<vector<ll>> ans(n);
    vector<bool> used(n);
    for (size_t i = 0; i < n; ++i) {
        for (size_t j = 0; j < n; ++j) {
            used[j] = false;
        }
        ans[i].resize(n);
        dfs(i, g, used, i, 0, ans);
    }
    for (size_t i = 0; i < n; ++i) {
        for (size_t j = 0; j < n; ++j) {
            if (ans[i][j] != d[i][j]) {
                cout << "No";
                return;
            };
        }
    }
    cout << "Yes";
}

signed main() {
#ifdef FSTREAM
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
#ifdef MULTITEST
    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}