
#include <bits/stdc++.h>

// #define FSTREAM
// #define MULTITEST

using namespace std;

typedef long long ll;
typedef long double ld;

void dfs(size_t v, const vector<set<pair<ll, size_t>>> &g, vector<bool> &used, size_t start, ll dist, vector<vector<ll>> &d) {
    used[v] = true;
    for (auto edge : g[v]) {
        ll w = edge.first;
        size_t u = edge.second;
        if (used[u]) {
            continue;
        }
        d[start][u] = dist + w;
        dfs(u, g, used, start, dist + w, d);
    }
}

void solve() {
    size_t n;
    cin >> n;
    vector<vector<ll>> d(n);
    vector<set<pair<ll, size_t>>> g(n);
    for (size_t i = 0; i < n; ++i) {
        d[i].resize(n);
        for (size_t j = 0; j < n; ++j) {
            cin >> d[i][j];
        }
    }
    set<pair<ll, pair<size_t, size_t>>> q;
    q.insert({0, {0, 0}});
    vector<bool> used(n);
    while (!q.empty()) {
        auto cur = *q.begin();
        ll w = cur.first;
        size_t v = cur.second.first;
        size_t u = cur.second.second;
        q.erase(q.begin());
        if (used[v]) {
            continue;
        }
        used[v] = true;
        if (v != u) {
            g[u].insert({w, v});
            g[v].insert({w, u});
        }
        for (size_t k = 0; k < n; ++k) {
            if (k == v) {
                continue;
            }
            q.insert({d[k][v], {k, v}});
        }
    }
    vector<vector<ll>> ans(n);
    for (size_t i = 0; i < n; ++i) {
        for (size_t j = 0; j < n; ++j) {
            used[j] = false;
        }
        ans[i].resize(n);
        dfs(i, g, used, i, 0, ans);
    }
    for (size_t i = 0; i < n; ++i) {
        for (size_t j = 0; j < n; ++j) {
            if (ans[i][j] != d[i][j]) {
                cout << "No";
                return;
            };
        }
    }
    cout << "Yes";
}

signed main() {
#ifdef FSTREAM
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
#ifdef MULTITEST
    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}