#include <bits/stdc++.h>
using namespace std;
using ll = long long;


ll mod = 998244353ll;

ll binpow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = binpow(a, n / 2);
        return t * t % mod;
    }
    return a * binpow(a, n - 1) % mod;
}

ll inv(ll a) {
    return binpow(a, mod - 2);
}

vector<ll> p2, F;

ll C(ll n, ll k) {
    return (inv(F[k]) * inv(F[n - k]) % mod) * F[n] % mod;
}

ll C3(ll n, ll k, ll l) {
    return ((inv(F[k]) * inv(F[l]) % mod) * inv(F[n - k - l]) % mod) * F[n] % mod;
}


ll solve(ll n, ll b, ll g) {
    if (n <= 0) return 0;
    if (b + g < n) return 0;
    ll k = b - g;
    ll ans = 0;
    for (ll cg = 0; cg <= g; cg++) {
        ll cb = k + cg;
        ll co = n - cb - cg;
        if (cb < 0 || co < 0) continue;
        ll free = g - cg - co;
        ans += C(free, n + free) * p2[co] % mod * C3(n, cb, cg) % mod;
        ans %= mod;
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    ll maxn = 100005;
    vector<ll> a(3);
    for (ll& i : a) cin >> i;
    ranges::sort(a);
    ll r, g, b;
    r = a[2];
    b = a[1];
    g = a[0];
    ll ans = 0;
    p2.resize(maxn);
    F.resize(maxn);
    p2[0] = 1;
    F[0] = 1;
    for (int i = 1; i < maxn; i++) {
        p2[i] = p2[i - 1] * 2 % mod;
        F[i] = F[i - 1] * i % mod;
    }
    ans += solve(r - 1, b, g);
    ans %= mod;
    ans += solve(r, b, g);
    ans %= mod;
    ans += solve(r, b, g);
    ans %= mod;
    ans += solve(r + 1, b, g);
    ans %= mod;
    cout << ans << "\n";
}
