

// === HEAD === 

#ifndef HEAD_H
#define HEAD_H

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &itrnjvtntrbr : x) cin >> itrnjvtntrbr; }
#define out(x); { for (auto &itrnjvtntrbr : x) cout << itrnjvtntrbr << ' '; cout << endl; }
#define sz(x) ((int)x.size())

#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, a, b) for (int i = a; i <= b; ++i)
#define per(i, n) for (int i = n -1; i >= 0; i--)
#define perr(i, a, b) for (int i = b; i >= a; --i)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef vector <pair <int, int>> vii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
const int INF = 2e9;
const long long INFll = 1e18;
const long double eps = 1e-6;
const long double pi = acos(-1);

template<typename T>
T input() {
    T obj;
    cin >> obj;
    return obj;
}

template<typename T>
vector<T> input(int count) {
    vector<T> vec(count);
    for (T& obj : vec)
        obj = input<T>();
    return vec;
}

template<typename T>
T divup(T a, T b) {
    return (a + b - 1) / b;
}

template<typename T, typename F = bool(*)(T)>
T binary_search(F check, T left, T right) {
    while (right - left > 1) {
        T mid = left + (right - left) / 2;
        if (check(mid)) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return right;
}

#endif // HEAD_H




// === MAIN === 

#ifndef MAIN_H
#define MAIN_H


void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;

#ifdef MULTITEST_H
    cin >> t;
#endif // MULTITEST_H

    while (t--) {
        solve();
    }
}

#endif // MAIN_H


// === SOLVE === 


struct path {
    int m, from, to;
};

void solve() {
    int n = input<int>();
    auto a = input<int>(n);

    vector<int> diff(n - 1);
    for (int i = 0; i < n - 1; i++)
        diff[i] = abs(a[i + 1] - a[i]);
    
    int s = input<int>() - 1;
    int f = input<int>() - 1;

    vector<path> ans;
    for (int g = 0, prev = s; s < f; s++) {
        if (diff[s] == 1) {
            cout << "Impossible" << "\n";
            return;
        }
        int g1 = gcd(g, diff[s]);
        if (g1 == 1) {
            ans.emplace_back(g, prev, s);
            prev = s;
            g = diff[s];
        } else {
            g = g1;
        }
        if (s + 1 == f) {
            ans.emplace_back(g, prev, f);
        }
    }

    for (int g = 0, prev = s; s > f; s--) {
        if (diff[s - 1] == 1) {
            cout << "Impossible" << "\n";
            return;
        }
        int g1 = gcd(g, diff[s - 1]);
        if (g1 == 1) {
            ans.emplace_back(g, prev, s);
            prev = s;
            g = diff[s - 1];
        } else {
            g = g1;
        }
        if (s - 1 == f) {
            ans.push_back(path{g, prev, f});
        }
    }

    for (auto p : ans)
        cout << "Kaban-" << (p.m ? p.m : 2) << ' ' << p.from + 1 << ' ' << p.to + 1 << '\n';
}
