#include <iostream>
#include <map>

using namespace std;

using ll = long long;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  const char ZERO = 0b1110111, ONE = 0b0010010, TWO = 0b1011101,
             THREE = 0b1011011, FOUR = 0b0111010, FIVE = 0b1101011,
             SIX = 0b1101111, SEVEN = 0b1010010, EIGHT = 0b1111111,
             NINE = 0b1111011;

  map<char, int> numByChar = {
      {ZERO, 0}, {ONE, 1}, {TWO, 2},   {THREE, 3}, {FOUR, 4},
      {FIVE, 5}, {SIX, 6}, {SEVEN, 7}, {EIGHT, 8}, {NINE, 9},
  };
  map<int, char> charByNum;
  for (auto &p : numByChar) {
    charByNum[p.second] = p.first;
  }

  string s1, s2;
  cin >> s1 >> s2;

  int n1 = stoi(s1, 0, 2), n2 = stoi(s2, 0, 2);

  int d1, d2, sec, prev, illusion = 0, maxIllusion = 0;
  bool prevValid = false;
  char c1, c2;

  for (int i = 99; i > 0; i--) {
    c1 = charByNum[i / 10] & n1;
    c2 = charByNum[i % 10] & n2;
    if (numByChar.find(c1) != numByChar.end() &&
        numByChar.find(c2) != numByChar.end()) {
      d1 = numByChar[c1];
      d2 = numByChar[c2];

      sec = d1 * 10 + d2;

      if (prevValid && sec == prev + 1) {
        illusion++;
        maxIllusion = max(illusion, maxIllusion);
      } else {
        illusion = 0;
      }

      prev = sec;
      prevValid = true;
    } else {
      prevValid = false;
    }
  }

  cout << maxIllusion;
}