def find(x):
    if v_id[x] == x:
        return x
    v_id[x] = find(v_id[x])
    return v_id[x]


def merge(x, y):
    rx = find(x)
    ry = find(y)

    if v_sz[rx] < v_sz[ry]:
        v_id[rx] = ry
        v_sz[ry] += v_sz[rx]
    else:
        v_id[ry] = rx
        v_sz[rx] += v_sz[ry]


def connected(x, y):
    return find(x) == find(y)


# ---


def bfs(st):
    d_b[st][st] = 0
    q = [st]
    q0 = 0
    while len(q) > q0:
        v = q[q0]
        q0 += 1
        for i in u[v]:
            if d_b[st][i] > d_b[st][v] + s[v][i]:
                d_b[st][i] = d_b[st][v] + s[v][i]
                q.append(i)


# --


n = int(input())

v_id = []
v_sz = []

for i in range(n):
    v_id.append(i)
    v_sz.append(1)

s = []
u = []

dst = []
d_b = []

inf = 10**12

for i in range(n):
    s.append(list(map(int, input().split())))
    u.append([])
    d_b.append([inf] * n)
    for j in range(i + 1, n):
        dst.append((i, j, s[i][j]))


dst.sort(key=lambda z: z[-1])

e_cnt = 0
for p in dst:
    i, j, d = p
    if connected(i, j):
        continue
    e_cnt += 1
    u[i].append(j)
    u[j].append(i)
    merge(i, j)

if e_cnt > n - 1:
    print('No')
else:
    for i in range(n):
        bfs(i)
        if d_b[i] != s[i]:
            print('No')
            break
    else:
        print('Yes')
