#include <bits/stdc++.h>
    

using   std::cin, std::cout, std::sqrt, std::exp, std::sin, std::cos, std::pow, std::endl, std::flush,
        std::vector, std::set, std::map, std::unordered_set, std::unordered_map, std::pair, std::string,
        std::sort, std::unique, std::find, std::count, std::lower_bound, std::upper_bound, std::memcpy, std::memset;

template<typename T>
std::istream& operator>>(std::istream& is, vector<T>& vec)
{
    for (T& elem : vec)
        is >> elem;
    return is;
}

template<typename T>
std::ostream& operator<<(std::ostream& os, const vector<T>& vec)
{
    for (const T& elem : vec)
	    os << elem << ' ';
    return os;
}

template<typename T>
const T& max(const T& arg1, const T& arg2)
{
    if (arg1 > arg2)
        return arg1;
    return arg2;
}

template<typename T, typename... Args>
const T& max(const T& arg1, const T& arg2, Args... args)
{
    return max(max(arg1, arg2), args...);
}

template<typename T>
const T& min(const T& arg1, const T& arg2)
{
    if (arg1 < arg2)
        return arg1;
    return arg2;
}

template<typename T, typename... Args>
const T& min(const T& arg1, const T& arg2, Args... args)
{
    return min(min(arg1, arg2), args...);
}


namespace std
{
    template<typename T1, typename T2>
    struct hash<std::pair<T1,T2>>
    {
        size_t operator()(const std::pair<T1,T2>& pr) const
        {
            std::hash<T1> h1;
            std::hash<T2> h2;
            return h1(pr.first) ^ h2(pr.second);
        }
    };
}

using pii = pair<int,int>;
using pll = pair<long long, long long>;
using pdd = pair<double, double>;
#ifndef SEGTREE_H 
#define SEGTREE_H

template<class T, class BinaryOp, T IdentityElem>
class SegmentTree
{
public:

    // tree[0] is uninitialized
    std::vector<T> tree;

    template<class Iter>
    SegmentTree(Iter begin, Iter end) : tree(2 * std::distance(begin, end))
    {
        static_assert(std::is_same<T, typename std::iterator_traits<Iter>::value_type>::value, "types are not the same");

        int n = tree.size() / 2;
        std::copy(begin, end, tree.begin() + n);
        
        BinaryOp op;
        for (int i = n-1; i > 0; i--)
            tree[i] = op(tree[2*i], tree[2*i+1]);
    }

    // semi-open interval [left, right)
    T query(int left, int right)
    {
        int n = tree.size() / 2;
        left += n; right += n;

        T left_res  = IdentityElem;
        T right_res = IdentityElem;

        BinaryOp op;
        for (; left < right; left /= 2, right /= 2)
        {
            if (left % 2)
                left_res = op(left_res, tree[left++]);
            
            if (right % 2)
                right_res = op(tree[--right], right_res);
        }
        return op(left_res, right_res);
    }

    // assigns arr[idx] to the new_value
    void update(int idx, T new_value)
    {
        int n = tree.size() / 2;
        idx += n;
        tree[idx] = new_value;

        BinaryOp op;
        for (int i = idx/2; i > 0; i /= 2)
            tree[i] = op(tree[2*i], tree[2*i+1]);
    }
};

#endif
int main()
{
    std::ios::sync_with_stdio(0);
    cin.tie(0);
    
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int s, f;
    cin >> s >> f;
    s--; f--;
    bool rever = 0;
    if (s > f)
    {
        rever = 1;
        std::swap(s, f);
    }

    vector<int> diff(n-1);
    for (int i = 0; i < n-1; i++)
        diff[i] = a[i] - a[i+1];
    SegmentTree<int, decltype([](int a, int b){return std::gcd(a,b);}), 0> st(diff.begin(), diff.end());

    vector<int> rights(n);
    for (int i = 0; i < n; i++)
    {
        int l = i;
        int r = n;
        while (r - l > 1)
        {
            int m = (r + l) / 2;
            if (st.query(i, m) != 1)
                l = m;
            else
                r = m;
        }
        rights[i] = l;
    }

    vector<vector<int>> res;
    while (s < f)

    {
        if (rights[s] == s)
        {
            cout << "Impossible\n";
            return 0;
        }
        int to = min(f, rights[s]);
        int m = st.query(s, to);
        if (!m)
            m = 42;
        res.push_back({m, s+1, to+1});
        s = to;
    }
    if (!rever)
        for (auto& vec : res)
            cout << "kaban-" << vec << '\n';
    else
    {
        for (auto it = res.rbegin(); it < res.rend(); ++it)
        {
            auto& vec = *it;
            int m = vec[0];
            int from = vec[2];
            int to = vec[1];
            cout << "Kaban-" << m << ' ' << from << ' ' << to << '\n';
        }
    }
    return 0;
}
