#include <bits/stdc++.h>
    

using   std::cin, std::cout, std::sqrt, std::exp, std::sin, std::cos, std::pow, std::endl, std::flush,
        std::vector, std::set, std::map, std::unordered_set, std::unordered_map, std::pair, std::string,
        std::sort, std::unique, std::find, std::count, std::lower_bound, std::upper_bound, std::memcpy, std::memset;

template<typename T>
std::istream& operator>>(std::istream& is, vector<T>& vec)
{
    for (T& elem : vec)
        is >> elem;
    return is;
}

template<typename T>
std::ostream& operator<<(std::ostream& os, const vector<T>& vec)
{
    for (const T& elem : vec)
	    os << elem << ' ';
    return os;
}

template<typename T>
const T& max(const T& arg1, const T& arg2)
{
    if (arg1 > arg2)
        return arg1;
    return arg2;
}

template<typename T, typename... Args>
const T& max(const T& arg1, const T& arg2, Args... args)
{
    return max(max(arg1, arg2), args...);
}

template<typename T>
const T& min(const T& arg1, const T& arg2)
{
    if (arg1 < arg2)
        return arg1;
    return arg2;
}

template<typename T, typename... Args>
const T& min(const T& arg1, const T& arg2, Args... args)
{
    return min(min(arg1, arg2), args...);
}


namespace std
{
    template<typename T1, typename T2>
    struct hash<std::pair<T1,T2>>
    {
        size_t operator()(const std::pair<T1,T2>& pr) const
        {
            std::hash<T1> h1;
            std::hash<T2> h2;
            return h1(pr.first) ^ h2(pr.second);
        }
    };
}

using pii = pair<int,int>;
using pll = pair<long long, long long>;
using pdd = pair<double, double>;
int main()
{
    std::ios::sync_with_stdio(0);
    cin.tie(0);
    
    int n;
    cin >> n;
    vector<vector<int>> A(n, vector<int>(n));
    cin >> A;

    struct trip
    {
        int weight;
        int from;
        int to;
    };
    struct cmp
    {
        bool operator () (const trip& l, const trip& r) const
        {
            if (l.weight < r.weight) return true;
            if (l.weight > r.weight) return false;
            if (l.from < r.from) return true;
            if (l.from > r.from) return false;
            if (l.to < r.to) return true;
            if (l.to > r.to) return false;
            return false;
        }
    };

    set<int> visited {0};
    set<trip, cmp> sosedi;

    for (int j = 0; j < n; ++j)
        if (A[0][j] != 0) sosedi.insert({A[0][j], 0 , j});

    vector<vector<int>> B (n, vector<int>(n,0));

    for (int k = 0; k < n-1; ++k)
    {
        trip near;

        bool f = false;

        while (!sosedi.empty())
        {
            near = *sosedi.begin();
            sosedi.erase(sosedi.begin());

            if (!visited.count(near.to)) {
                f = true;
                break;
            }
        }

        if (!f) {
            cout << "No\n";
            return 0;
        }

        for (auto i : visited)
        {
            if (i == near.from) {
                B[i][near.to] = near.weight;
                B[near.to][i] = near.weight;
            } else {
                B[i][near.to] = B[i][near.from] + near.weight;
                B[near.to][i] = B[i][near.from] + near.weight;
            }
        }

        for (int j = 0; j < n; ++j)
        {
            if (near.to != j && A[near.to][j] != 0) {
                sosedi.insert({A[near.to][j], near.to, j});
            }
        }          

        visited.insert(near.to);
        
    }

    for (int i = 0; i < n; ++i)
    for (int j = 0; j < n; ++j)
        if (A[i][j] != B[i][j]) {
            cout << "No\n";
            return 0;
        }

    cout << "Yes\n";

    return 0;
}
