import heapq

def is_wooden(matrix):
    n = len(matrix)

    for i in range(n):
        if matrix[i][i] != 0:
            return False
        for j in range(i + 1, n):
            if matrix[i][j] <= 0:
                return False

    mst = []
    visited = set()
    edges = [(matrix[i][j], i, j) for i in range(n) for j in range(i + 1, n)]
    heapq.heapify(edges)

    while len(visited) < n:
        weight, u, v = heapq.heappop(edges)
        if u in visited and v in visited:
            continue
        visited.add(u)
        visited.add(v)
        mst.append((u, v, weight))

    for i in range(n):
        for j in range(i + 1, n):
            distance_in_matrix = matrix[i][j]
            distance_in_mst = 0
            current_vertex = i
            visited_vertices = set()
            while current_vertex != j:
                visited_vertices.add(current_vertex)
                for u, v, weight in mst:
                    if current_vertex == u and v not in visited_vertices:
                        distance_in_mst += weight
                        current_vertex = v
                        break
            if distance_in_matrix != distance_in_mst:
                return False

    return True

n = int(input())
matrix = []
for _ in range(n):
    row = list(map(int, input().split()))
    matrix.append(row)

if is_wooden(matrix):
    print("Yes")
else:
    print("No")