#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int inf = (int)2e9;
const ll linf = (ll)1e18;

const ll mod = (ll)1e9 + 7ll;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int num_from_vector(vector<int> a) {
	if (a == vector<int>({ 1, 1, 1, 0, 1, 1, 1 })) return 0;
	if (a == vector<int>({ 0, 0, 1, 0, 0, 1, 0 })) return 1;
	if (a == vector<int>({ 1, 0, 1, 1, 1, 0, 1 })) return 2;
	if (a == vector<int>({ 1, 0, 1, 1, 0, 1, 1 })) return 3;
	if (a == vector<int>({ 0, 1, 1, 1, 0, 1, 0 })) return 4;
	if (a == vector<int>({ 1, 1, 0, 1, 0, 1, 1 })) return 5;
	if (a == vector<int>({ 1, 1, 0, 1, 1, 1, 1 })) return 6;
	if (a == vector<int>({ 1, 0, 1, 0, 0, 1, 0 })) return 7;
	if (a == vector<int>({ 1, 1, 1, 1, 1, 1, 1 })) return 8;
	if (a == vector<int>({ 1, 1, 1, 1, 0, 1, 1 })) return 9;
	return -1;
}

vector<int> vector_from_num(int a) {
	if (a == 0) return vector<int>({ 1, 1, 1, 0, 1, 1, 1 });
	if (a == 1) return vector<int>({ 0, 0, 1, 0, 0, 1, 0 });
	if (a == 2) return vector<int>({ 1, 0, 1, 1, 1, 0, 1 });
	if (a == 3) return vector<int>({ 1, 0, 1, 1, 0, 1, 1 });
	if (a == 4) return vector<int>({ 0, 1, 1, 1, 0, 1, 0 });
	if (a == 5) return vector<int>({ 1, 1, 0, 1, 0, 1, 1 });
	if (a == 6) return vector<int>({ 1, 1, 0, 1, 1, 1, 1 });
	if (a == 7) return vector<int>({ 1, 0, 1, 0, 0, 1, 0 });
	if (a == 8) return vector<int>({ 1, 1, 1, 1, 1, 1, 1 });
	if (a == 9) return vector<int>({ 1, 1, 1, 1, 0, 1, 1 });
}

vector<int> And(vector<int> a, vector<int> b) {
	for (int i = 0; i < 7; ++i) {
		if (b[i] == 0) a[i] = 0;
	}
	return a;
}


void solve() {
	string s;
	cin >> s;
	vector<int> first(7, 0);
	for (int i = 0; i < 7; ++i) {
		if (s[i] == '1') first[i] = 1;
	}

	cin >> s;
	vector<int> second(7, 0);
	for (int i = 0; i < 7; ++i) {
		if (s[i] == '1') second[i] = 1;
	}

	vector<int> v(100, -1);
	for (int x = 0; x < 100; x++) {
		int n1 = x / 10; int n2 = x % 10;
		int new_n1 = num_from_vector(And(vector_from_num(n1), first));
		int new_n2 = num_from_vector(And(vector_from_num(n2), second));
		if (new_n1 >= 0 && new_n2 >= 0) {
			v[x] = 10 * new_n1 + new_n2;
		}
	}

	vector<int> ps(100, 1);
	for (int i = 0; i < 100; ++i) {
		if (v[i] == -1) ps[i] = 0;
		else if (i == 1) ps[i] = 1;
		else if (ps[i - 1] == 0) ps[i] = 1;
		else if (v[i - 1] == v[i] + 1) ps[i] = ps[i - 1] + 1;
		else ps[i] = 1;
	}

	int m = 0;
	for (int i = 0; i < 100; ++i) m = max(m, ps[i]);
	if (m > 0) m--;
	cout << m;


}


signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
	//freopen("test.in", "r", stdin);
	//freopen("test.in", "w", stdout);
	//cout << fixed << setprecision(7);

	//clock_t start = clock();
	
	int tests = 1;
	//cin >> tests;
	for (int test = 1; test <= tests; ++test) {
		solve();
	}

	//clock_t end = clock();
	//ld seconds = (ld)(end - start) / CLOCKS_PER_SEC;
	//cout << seconds << "\n";
}