#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int inf = (int)2e9;
const ll linf = (ll)2e18;

const ll mod = (ll)1e9 + 7ll;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll gcd(ll a, ll b) {
	while (b != 0) {
		swap(a %= b, b);
	}
	return a;
}

ll C(ll n, ll k) {
	if (k > n) {
		return 0ll;
	}

	ll ans = 1ll;

	int m = n - k + 1;
	for (int i = 1; i <= k; ++i, ++m) {
		int j = i / gcd(ans, i);
		ans /= gcd(ans, i);
		ll l = m / j;

		if (ans >= (linf) / l) {
			return linf;
		}
		else {
			ans *= l;
		}
	}

	return ans;
}

void solve() {

	ll n, k;
	
	cin >> n >> k;

	int log_n = 0;

	while ((1ll << (log_n)) < n) {
		++log_n;
	}

	if (2 * k >= log_n + 1) {
		cout << log_n << "\n";
	}
	else {
		ll l = 0;
		ll r = n;

		while (r - l > 1) {
			ll m = l + r >> 1;

			ll ans = 0ll;

			for (int i = 0; i <= 2 * k; ++i) {
				ll t = C(m, i);

				if (t == linf || ans + t >= linf) {
					ans = linf;
				}
				else {
					ans += t;
				}
			}

			if (ans >= n) {
				r = m;
			}
			else {
				l = m;
			}
		}
		cout << r << "\n";
	}
}


signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
	//freopen("test.in", "r", stdin);
	//freopen("test.in", "w", stdout);
	//cout << fixed << setprecision(7);

	//clock_t start = clock();
	
	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; ++test) {
		solve();
	}

	//clock_t end = clock();
	//ld seconds = (ld)(end - start) / CLOCKS_PER_SEC;
	//cout << seconds << "\n";
}