#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int inf = (int)2e9;
const ll linf = (ll)1e18;

const ll mod = (ll)1e9 + 7ll;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct DSU {
	int size;
	vector<int> rank;
	vector<int> parent;

	void build(int n) {
		size = n;
		rank.resize(n, 0);
		parent.resize(n);
		for (int i = 0; i < n; ++i) {
			parent[i] = i;
		}
	}

	int find_set(int v) {
		if (v == parent[v]) {
			return v;
		}
		return parent[v] = find_set(parent[v]);
	}

	void unite(int a, int b) {
		a = find_set(a);
		b = find_set(b);

		if (a != b) {

			if (rank[a] < rank[b]) {
				swap(a, b);
			}

			if (rank[a] == rank[b]) {
				++rank[a];
			}

			parent[b] = a;
		}
	}
};

void solve() {
	int n;
	cin >> n;

	vector<vector<int>> d(n, vector<int>(n));

	set < pair<int, pair<int, int>>> edges;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> d[i][j];

			if (i < j) {
				edges.emplace(d[i][j], make_pair(i, j));
			}
		}
	}

	DSU lol;
	lol.build(n);

	vector<vector<int>> graph(n);
	for (auto el : edges) {
		if (lol.find_set(el.second.first) != lol.find_set(el.second.second)) {
			graph[el.second.first].push_back(el.second.second);
			graph[el.second.second].push_back(el.second.first);
			lol.unite(el.second.first, el.second.second);
		}
	}
	
	for (int i = 0; i < n - 1; ++i) {
		if (lol.find_set(i) != lol.find_set(i + 1)) {
			cout << "No";
			return;
		}
	}
	//cout << "lol\n";
	vector<vector<int>> dist(n, vector<int>(n));

	vector<bool> used(n);
	int i = 0;
	function<void(int, int)> dfs = [&](int v, int p) {
		used[v] = true;
		dist[i][v] = dist[i][p] + d[v][p];

		for (int u : graph[v]) {
			if (!used[u]) {
				dfs(u, v);
			}
		}
	};

	for (; i < n; ++i) {
		for (int v = 0; v < n; ++v) {
			used[v] = false;
		}
		dist[i][i] = 0;
		dfs(i, i);
	}

	if (d == dist) {
		cout << "Yes";
	}
	else {
		cout << "No";
	}
}


signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
	//freopen("test.in", "r", stdin);
	//freopen("test.in", "w", stdout);
	//cout << fixed << setprecision(7);

	//clock_t start = clock();
	
	int tests = 1;
	//cin >> tests;
	for (int test = 1; test <= tests; ++test) {
		solve();
	}

	//clock_t end = clock();
	//ld seconds = (ld)(end - start) / CLOCKS_PER_SEC;
	//cout << seconds << "\n";
}