#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>

#include <queue>

using namespace std;
using ll = long long;
using vl = vector<ll>;

istream &operator>>(istream &os, vl &a) {
    for (auto &x: a) cin >> x;
    return os;
}

#define int long long

struct FenwickTree {
    int n;
    vector<int> f;

    explicit FenwickTree(int _n) : n(_n), f(vector<int>(_n + 1, 0)) {};

    int sum(int r) {
        int ans = 0;
        for (; r > 0; r -= r & -r) ans += f[r];
        return ans;
    }

    int sum(int l, int r) {
        if (l > r) return 0;
        return sum(r) - sum(l - 1);
    }

    void add(int pos, int x) {
        for (; pos <= n; pos += pos & -pos) {
            f[pos] += x;
        }
    }

    void build(vector<int> &a) {
        for (int i = 1; i <= n; i++) {
            add(i, a[i - 1]);
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        int kk;
        cin >> kk;

        vector<queue<int>> q(9);
        for (int i = 0; i < s.size(); i++) {
            q[(int)s[i] - '1'].push(i);
        }
        int n = s.size();

        FenwickTree F(n);
        vector<char> ans(n);

        for (int i = 0; i < n; i++) {
            for (int k = 0; k<9;k++) {
                if (q[k].empty()) continue;
                int cur_pos = q[k].front() + F.sum(1, q[k].front() + 1);
                int pos = q[k].front();
                if (cur_pos - i <= kk) {
                    kk -= cur_pos - i;
                    q[k].pop();
                    F.add(pos + 1, -1);
                    F.add(i + 1, 1);
                    ans[i] = k + '1';
                    break;
                }
            }
        }

        for (char c : ans) cout << c;
        cout << "\n";
    }
}
