#include <iostream>
#include <vector>
#include <string>
#include <unordered_set>
#include <algorithm>

using namespace std;

const vector<int> validSegments = {
        0b1110111, // 0
        0b0100100, // 1
        0b1011101, // 2
        0b1101101, // 3
        0b0101110, // 4
        0b1101011, // 5
        0b1111011, // 6
        0b0100101, // 7
        0b1111111, // 8
        0b1101111  // 9
};

unordered_set<int> getPossibleDigits(int brokenSegment) {
    unordered_set<int> possibleDigits;
    for (int digit = 0; digit <= 9; ++digit) {
        if ((brokenSegment & validSegments[digit]) == brokenSegment) {
            possibleDigits.insert(digit);
        }
    }
    return possibleDigits;
}

int findMaxSequence(int brokenTens, int brokenUnits) {
    int maxSequenceLength = 0;

    unordered_set<int> possibleTens = getPossibleDigits(brokenTens);
    unordered_set<int> possibleUnits = getPossibleDigits(brokenUnits);

    for (int start = 1; start <= 99; ++start) {
        int currentLength = 0;
        bool validSequence = true;

        for (int num = start; num <= 99 && validSequence; ++num) {
            int tens = num / 10;
            int units = num % 10;

            if (possibleTens.count(tens) == 0 || possibleUnits.count(units) == 0) {
                validSequence = false;
            } else {
                currentLength++;
            }
        }

        maxSequenceLength = max(maxSequenceLength, currentLength);
    }

    return maxSequenceLength;
}

int main() {
    string firstSegment, secondSegment;
    cin >> firstSegment >> secondSegment;

    int brokenTens = stoi(firstSegment, nullptr, 2);
    int brokenUnits = stoi(secondSegment, nullptr, 2);

    int result = findMaxSequence(brokenTens, brokenUnits);
    cout << result << endl;

    return 0;
}