#include <iostream>
#include "vector"
#include "algorithm"
using namespace std;
const int MOD = 998244353;
const int MAXN = 3000005;

vector<long long> fact(MAXN, 1), inv_factorial(MAXN, 1);

long long power(long long base, long long exp, long long mod) {
    long long result = 1;
    while (exp > 0) {
        if (exp % 2 == 1) result = result * base % mod;
        base = base * base % mod;
        exp /= 2;
    }
    return result;
}

void prec() {
    for (int i = 1; i < MAXN; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    inv_factorial[MAXN - 1] = power(fact[MAXN - 1], MOD - 2, MOD);
    for (int i = MAXN - 2; i >= 0; --i) {
        inv_factorial[i] = inv_factorial[i + 1] * (i + 1) % MOD;
    }
}

long long comb(int n, int k) {
    if (k < 0 || k > n) return 0;
    return fact[n] * inv_factorial[k] % MOD * inv_factorial[n - k] % MOD;
}

int main() {
    prec();

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int r, g, b;
    cin >> r >> g >> b;

    vector<int> counts = {r, g, b};
    sort(counts.rbegin(), counts.rend());
    int c0 = counts[0], c1 = counts[1], c2 = counts[2];
    int s = r + g + b;

    if (c0 > s - c0 + 1) {
        cout << "0\n";
        return 0;
    }

    if (c1 - c2 > 1) {
        cout << "0\n";
        return 0;
    }

    if (c1 > 1 && c2 == 0) {
        cout << "0\n";
        return 0;
    }

    long long W1 = (c1 == c2 && c1 > 0) ? 2 : 1;

    if (c1 == 0 && c2 == 0) {
        cout << (c0 == 1 ? 1 : 0) << "\n";
        return 0;
    }

    int k = c1 + c2 + 1;
    long long W2 = comb(k, c0);

    long long total_ways = W1 * W2 % MOD;
    cout << total_ways << "\n";

    return 0;
}