fun main() {
    val s1 = readln()
    val s2 = readln()
    val sem = Semaphore()
    for (i in s1.indices) {
        sem.base1[i] = s1[i].toString().toInt()
        sem.base2[i] = s2[i].toString().toInt()
    }

    var max = 0
    for (i in 99 downTo 0) {
        var start = sem.getFakeState()
        var count = 0
        while (true) {
            val next = sem.next()
            start++
            if (next == start) {
                count++
                max = maxOf(max, count)
            } else {
                break
            }
        }
        sem.setState(i)
    }

    println(max)
}

class Semaphore {
    companion object {
        val numToState = mapOf(
            Pair(0, intArrayOf(0, 0, 0, 0, 0, 0, 0)),
            Pair(1, intArrayOf(0, 0, 1, 0, 0, 1, 0)),
            Pair(2, intArrayOf(1, 0, 1, 1, 1, 0, 1)),
            Pair(3, intArrayOf(1, 0, 1, 1, 0, 1, 1)),
            Pair(4, intArrayOf(0, 1, 1, 1, 0, 1, 0)),
            Pair(5, intArrayOf(1, 1, 0, 1, 0, 1, 1)),
            Pair(6, intArrayOf(1, 1, 0, 1, 1, 1, 1)),
            Pair(7, intArrayOf(1, 0, 1, 0, 0, 1, 0)),
            Pair(8, intArrayOf(1, 1, 1, 1, 1, 1, 1)),
            Pair(9, intArrayOf(1, 1, 1, 1, 0, 1, 1)),
        )
        val stateToNum = mapOf(
            Pair(intArrayOf(0, 0, 0, 0, 0, 0, 0).contentToString(), 0),
            Pair(intArrayOf(0, 0, 1, 0, 0, 1, 0).contentToString(), 1),
            Pair(intArrayOf(1, 0, 1, 1, 1, 0, 1).contentToString(), 2),
            Pair(intArrayOf(1, 0, 1, 1, 0, 1, 1).contentToString(), 3),
            Pair(intArrayOf(0, 1, 1, 1, 0, 1, 0).contentToString(), 4),
            Pair(intArrayOf(1, 1, 0, 1, 0, 1, 1).contentToString(), 5),
            Pair(intArrayOf(1, 1, 0, 1, 1, 1, 1).contentToString(), 6),
            Pair(intArrayOf(1, 0, 1, 0, 0, 1, 0).contentToString(), 7),
            Pair(intArrayOf(1, 1, 1, 1, 1, 1, 1).contentToString(), 8),
            Pair(intArrayOf(1, 1, 1, 1, 0, 1, 1).contentToString(), 9),
        )
    }

    val base1 = IntArray(7)
    val base2 = IntArray(7)
    private var stateLeft = intArrayOf(1, 1, 1, 1, 0, 1, 1)
    private var stateRight = intArrayOf(1, 1, 1, 1, 0, 1, 1)
    private var stateNum = 99

    fun next(): Int {
        stateNum--
        numToStateTrans(stateNum.toString())
        val newNum = getBasedNum()
        return newNum
    }

    fun setState(state: Int) {
        numToStateTrans(state.toString())
        stateNum = state
    }

    fun getFakeState(): Int {
        return getBasedNum()
    }

    private fun stateToNumTrans(one: IntArray, two: IntArray): Int {
        if (one.contentToString() !in stateToNum.keys || two.contentToString() !in stateToNum.keys) {
            return -1
        }
        val f = stateToNum[one.contentToString()]!!
        val s = stateToNum[two.contentToString()]!!
        return if (f == 0) {
            s.toString().toInt()
        } else {
            (f.toString() + s.toString()).toInt()
        }
    }

    private fun numToStateTrans(num: String) {
        var f = 0
        var s = 0
        if (num.length == 1) {
            s = num[0].toString().toInt()
        } else {
            f = num[0].toString().toInt()
            s = num[1].toString().toInt()
        }
        stateLeft = numToState[f]!!
        stateRight = numToState[s]!!
    }

    private fun getBasedNum(): Int {
        val newState1 = IntArray(7)
        val newState2 = IntArray(7)
        for (i in 0..6) {
            newState1[i] = base1[i] and stateLeft[i]
            newState2[i] = base2[i] and stateRight[i]
        }
        return stateToNumTrans(newState1, newState2)
    }
}