MOD = 998244353
def factorial_and_inv(n, MOD):
    fact = [1] * (n + 1)
    inv_fact = [1] * (n + 1)
    for i in range(2, n + 1):
        fact[i] = fact[i - 1] * i % MOD
    inv_fact[n] = pow(fact[n], MOD - 2, MOD)
    for i in range(n - 1, 0, -1):
        inv_fact[i] = inv_fact[i + 1] * (i + 1) % MOD
    return fact, inv_fact

def binom(n, k, fact, inv_fact, MOD):
    if n < k or k < 0:
        return 0
    return fact[n] * inv_fact[k] % MOD * inv_fact[n - k] % MOD


def count_ways(r, g, b):
    max_n = r + g + b
    fact, inv_fact = factorial_and_inv(max_n, MOD)
    if r > g + b + 1 or g > r + b + 1 or b > r + g + 1:
        return 0

    total_ways = fact[r + g + b] * inv_fact[r] % MOD * inv_fact[g] % MOD * inv_fact[b] % MOD

    return total_ways


r, g, b = map(int, input().split())
print(count_ways(r, g, b))
