#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

//       
const vector<int> code = {
    119, // 0
    18,  // 1
    93,  // 2
    91,  // 3
    58,  // 4
    107, // 5
    111, // 6
    82,  // 7
    127, // 8
    123  // 9
};

//        
int getDisplayedDigit(const string& broken, int digit_code) {
    int broken_code = stoi(broken, nullptr, 2);
    return digit_code & broken_code;
}

int main() {
    string first, second;
    cin >> first >> second;

    vector<int> fto(10, -1);
    vector<int> sto(10, -1);

    for (int i = 0; i < 10; ++i) {
        int displayed_digit = getDisplayedDigit(first, code[i]);
        auto it = find(code.begin(), code.end(), displayed_digit);
        if (it != code.end()) {
            fto[i] = distance(code.begin(), it);
        }
    }

    for (int i = 0; i < 10; ++i) {
        int displayed_digit = getDisplayedDigit(second, code[i]);
        auto it = find(code.begin(), code.end(), displayed_digit);
        if (it != code.end()) {
            sto[i] = distance(code.begin(), it);
        }
    }

    int max_streak = 0, streak = 0;
    int illusion = -1;

    for (int num = 99; num > 0; --num) {
        int a = num % 10;
        int b = num / 10;
        int new_illusion = -1;

        if (sto[a] != -1) {
            new_illusion = sto[a];
        }
        if (b && new_illusion != -1) {
            if (fto[b] != -1) {
                new_illusion += fto[b] * 10;
            } else {
                new_illusion = -1;
            }
        }

        if (new_illusion == -1) {
            max_streak = max(max_streak, streak);
            streak = 0;
            illusion = -1;
            continue;
        }

        if (illusion == -1) {
            illusion = new_illusion;
            streak = 0;
            continue;
        }

        if (illusion + 1 == new_illusion) {
            streak += 1;
        } else {
            max_streak = max(max_streak, streak);
            streak = 0;
        }
        illusion = new_illusion;
    }

    max_streak = max(max_streak, streak);

    cout << max_streak << endl;

    return 0;
}