#include <iostream>
#include <vector>
#include <queue>

using namespace std;
struct Edge {
    int to;
    long long cost;
};

bool isWoodenMatrix(const vector<vector<int> >& matrix, int n) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j && matrix[i][j] != matrix[j][i]) {
                return false; 
            }
        }
    }

    vector<long long> sum(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sum[i] += matrix[i][j];
        }
    }

    for (int i = 0; i < n; i++) {
        if (sum[i] % 2 != 0) {
            return false; 
        }
    }


    vector<bool> visited(n, false);
    queue<int> q;
    visited[0] = true;
    int visitedCount = 1;

    q.push(0);
    
    while (!q.empty()) {
        int node = q.front();
        q.pop();

        for (int neighbor = 0; neighbor < n; neighbor++) {
            if (matrix[node][neighbor] > 0 && !visited[neighbor]) {
                visited[neighbor] = true;
                visitedCount++;
                q.push(neighbor);
            }
        }
    }

    return visitedCount == n;
}

int main() {
    int n;
    cin >> n; 
    vector<vector<int> > matrix(n, vector<int>(n));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matrix[i][j];
        }
    }

    // ?????????, ???????? ?? ??????? ??????????
    if (isWoodenMatrix(matrix, n)) {
        cout << "Yes" << endl; // ??????? ???????? ??????????
    } else {
        cout << "No" << endl; // ??????? ?? ???????? ??????????
    }

    return 0;
}

