#include <iostream>
#include <vector>
#include <cctype>

bool isRACIValid(const std::vector<std::vector<char>>& matrix) {
    for (const auto& row : matrix) {
        int a_count = 0;
        for (char cell : row) {
            if (std::toupper(cell) == 'A') {
                a_count++;
            }
        }
        if (a_count != 1) {
            return false;
        }
    }
    return true;
}

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<std::vector<char>> matrix(n, std::vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> matrix[i][j];
        }
    }

    if (isRACIValid(matrix)) {
        std::cout << "Yes" << std::endl;
    }
    else {
        std::cout << "No" << std::endl;
    }

    return 0;
}
