#include <iostream>
#include <algorithm>
using namespace std;

bool isPossibleToArrange(int red, int green, int blue) {
    int total = red + green + blue;
    int maxColor = max({red, green, blue});
    return maxColor <= (total + 1) / 2;
}

void countArrangements(int red, int green, int blue, char last, int& count) {
    if (red == 0 && green == 0 && blue == 0) {
        count++;
        return;
    }

    if (red > 0 && last != 'R') {
        countArrangements(red - 1, green, blue, 'R', count);
    }

    if (green > 0 && last != 'G') {
        countArrangements(red, green - 1, blue, 'G', count);
    }

    if (blue > 0 && last != 'B') {
        countArrangements(red, green, blue - 1, 'B', count);
    }
}

void countArrangements(int red, int green, int blue, int& count) {
    countArrangements(red, green, blue, ' ', count);
}

int main() {
    int red, green, blue;
    cin >> red >> green >> blue;

    if (!isPossibleToArrange(red, green, blue)) {
        cout << 0 << endl;
    } else {
        int count = 0;
        countArrangements(red, green, blue, count);
        cout << count << endl;
    }

    return 0;
}