#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MOD = 998244353;

vector<long long> factorials(int n) {
    vector<long long> fact(n + 1, 1);
    for (int i = 2; i <= n; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    return fact;
}

long long mod_inverse(long long a) {
    long long res = 1, p = MOD - 2;
    while (p) {
        if (p & 1) {
            res = res * a % MOD;
        }
        a = a * a % MOD;
        p >>= 1;
    }
    return res;
}

int main() {
    int r, g, b;
    cin >> r >> g >> b;

    int max_color = max({r, g, b});
    int sum = r + g + b;

    if (max_color > sum - max_color + 1) {
        cout << 0 << endl;
        return 0;
    }

    auto fact = factorials(sum);

    long long result = fact[sum] * mod_inverse(fact[r]) % MOD;
    result = result * mod_inverse(fact[g]) % MOD;
    result = result * mod_inverse(fact[b]) % MOD;

    cout << result << endl;
    return 0;
}