#include <cstdint>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ios>

int to_bin(const std::string &num)
{
        int bin = 0;

	for (int i = 0; i < 7; ++i)
	{
		bin <<= 1;
		bin |= num[i] - '0';
	}

	return bin & 0x7f;
}

int main()
{
	std::vector<std::int32_t> digits(128, -1);
	digits[0b1110111] = 0;
	digits[0b0010010] = 1;
	digits[0b1011101] = 2;
	digits[0b1011011] = 3;
	digits[0b0111010] = 4;
	digits[0b1101011] = 5;
	digits[0b1101111] = 6;
	digits[0b1010010] = 7;
	digits[0b1111111] = 8;
	digits[0b1111011] = 9;
	const std::vector<std::int32_t> masks = {
		0b1110111,
		0b0010010,
		0b1011101,
		0b1011011,
		0b0111010,
		0b1101011,
		0b1101111,
		0b1010010,
		0b1111111,
		0b1111011
	};

	std::ios_base::sync_with_stdio(false);
	std::string a, b;

	std::cin >> a >> b;
	std::int32_t mask1 = to_bin(a);
	std::int32_t mask2 = to_bin(b);

	std::int32_t last_num = -1;
	std::int32_t k = 0;
	std::int32_t answer = 0;

	for (int i = 99; i > 0; --i)
	{
		std::int32_t dh = digits[masks[i / 10] & mask1];
		std::int32_t dl = digits[masks[i % 10] & mask2];

		if (dh == -1 || dl == -1)
		{
			last_num = -1;
			k = 0;
			continue;
		}

		std::int32_t num = dh * 10 + dl;
		if (last_num == -1)
		{
			last_num = num;
			k = 0;
                        continue;
		}

		if (last_num + 1 == num)
		{
			++k;
			answer = std::max(answer, k);
		}
		else
		{
			k = 0;
		}
	}

	std::cout << answer;
	return 0;
}
