#include <cstdint>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ios>

#define INVALID 1000
std::vector<std::int32_t> digits(128, -1);

const std::vector<std::int32_t> masks = {
	0b1110111,
	0b0010010,
	0b1011101,
	0b1011011,
	0b0111010,
	0b1101011,
	0b1101111,
	0b1010010,
	0b1111111,
	0b1111011
};


int to_bin(const std::string &num)
{
        int bin = 0;

	for (int i = 0; i < 7; ++i)
	{
		bin <<= 1;
		bin |= num[i] - '0';
	}

	return bin & 0x7f;
}

int fixed(int num, int mask1, int mask2)
{
	std::int32_t dh = digits[masks[num / 10] & mask1];
	std::int32_t dl = digits[masks[num % 10] & mask2];
	std::int32_t ret = INVALID;

	if (num >= 10)
	{
		if (dh == -1 || dl == -1)
		{
			ret = INVALID;
		}
		else
		{
			ret = dh * 10 + dl;
		}
	}
	else
	{
		if (dl == -1)
		{
			ret = INVALID;
		}
		else
		{
			ret = dl;
		}
	}

	return ret;
}

int main()
{
	digits[0b1110111] = 0;
	digits[0b0010010] = 1;
	digits[0b1011101] = 2;
	digits[0b1011011] = 3;
	digits[0b0111010] = 4;
	digits[0b1101011] = 5;
	digits[0b1101111] = 6;
	digits[0b1010010] = 7;
	digits[0b1111111] = 8;
	digits[0b1111011] = 9;

	std::ios_base::sync_with_stdio(false);
	std::string a, b;

	std::cin >> a >> b;
	std::int32_t mask1 = to_bin(a);
	std::int32_t mask2 = to_bin(b);

	std::int32_t last_num = -1;
	std::int32_t l = 0;
	std::int32_t r = 0;
	std::int32_t answer = 0;

	for (int l = 0, r = 1; r < 100; ++r)
	{
		std::int32_t num = fixed(100 - r, mask1, mask2);

		if (num == INVALID || r > 1 && num != 1 + fixed(100 - (r - 1), mask1, mask2))
		{
			l = r;
		}

		answer = std::max(answer, r - l - 1);
	}

	std::cout << answer;
	return 0;
}
