#include <cstdint>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ios>


std::string solve(std::string &s, std::int64_t k)
{
	if (k == 0)
	{
		return s;
	}

	for (std::int64_t insert_position = 0; insert_position < s.size(); ++insert_position)
	{
		char min_elem = s[insert_position];
		std::int64_t position = insert_position;
		std::int64_t left = insert_position;
		std::int64_t right = std::min<std::int64_t>(insert_position + k + 1, s.size());

		for (std::size_t j = left; j < right; ++j)
		{
			if (s[j] < min_elem)
			{
				min_elem = s[j];
				position = j;
			}
		}

		if (position == insert_position)
		{
			continue;
		}

		std::int64_t rev_size = std::min(k, position - insert_position);
		std::int64_t start = position - rev_size;
		std::reverse(s.begin() + start, s.begin() + position);
		std::reverse(s.begin() + start, s.begin() + position + 1);
		k -= rev_size;

		if (k == 0)
		{
			break;
		}
	}

	return s;
}


int main()
{
	std::ios_base::sync_with_stdio(false);
	std::int64_t t;
	std::string s;
	std::int64_t k;


	std::cin >> t;
	for (std::int64_t i = 0; i < t; ++i)
	{
		std::cin >> s >> k;
		std::cout << solve(s, k) << '\n';
	}

	return 0;
}
