#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...)
#endif

using ll = long long;
using db = long double;

struct segtree {
 
    int size;
    vector<ll> tree;
 
    inline void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
    }
 
    void add(int l, int r, int v, int x, int lx, int rx) {
        if (lx >= r || rx <= l) {
            return;
        } else if (lx >= l && rx <= r) {
            tree[x] += v;
        } else {
            int m = (lx + rx) / 2;
            add(l, r, v, x * 2 + 1, lx, m);
            add(l, r, v, x * 2 + 2, m, rx);
        }
    }
 
    void add(int l, int r, int v) {
        add(l, r, v, 0, 0, size);
    }
 
    ll get(int i, int x, int lx, int rx) {
        if (rx - lx == 1) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            return tree[x] + get(i, x * 2 + 1, lx, m);
        } else {
            return tree[x] + get(i, x * 2 + 2, m, rx);
        }
    }
 
    ll get(int i) {
        return get(i, 0, 0, size);
    }
 
};
 

void test_case() {
    string s;
    ll k;
    cin >> s >> k;
    int n = s.size();
    vector<vector<int>> ids(9);
    for (int i = 0; i < n; i++) {
        s[i] -= '1';
        ids[s[i]].push_back(i);
    }
    for (int i = 0; i < 9; i++) {
        reverse(ids[i].begin(), ids[i].end());
    }
    segtree st;
    st.init(n);
    set<int> ss;
    for (int i = 0; i < n; i++) ss.insert(i);
    while (!ss.empty()) {
        int q = *ss.begin();
        int real = q + st.get(q);
        // debug(real, q, int(s[q]));
        bool f = true;
        while (f) {
            for (int j = 0; j < 9; j++) {
                if (ids[j].empty()) {
                    continue;
                }
                if (j >= s[q]) {
                    f = false;
                    break;
                }
                int pos = ids[j].back();
                int realp = pos + st.get(pos);
                // debug(j, pos, realp);
                if (realp - real <= k) {
                    cout << j + 1;
                    k -= realp - real;
                    ss.erase(pos);
                    st.add(0, ids[j].back(), 1);
                    ids[j].pop_back();
                    real++;
                    break;
                } else {
                    continue;
                }
            }
        }
        cout << (int)s[q] + 1;
        ids[s[q]].pop_back();
        ss.erase(q);
    }
    cout << '\n';
}

signed main() {
    #ifdef LOCAL    
    freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        test_case();
    }
    return 0;
}