#include <bits/stdc++.h>

using namespace std;

template <typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2> p)
{
    out << p.first << " " << p.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& i : a) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T> a)
{
    for (auto i : a)
        out << i << (std::is_same_v<T, vector<int>> ? "\n" : " ");
    return out;
}

#pragma GCC optimize("Ofast,unroll-loops")

// #define int long long
#define pii pair<int, int>
#define ss second
#define ff first
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define deb(x) cerr << (#x) << " is " << (x) << endl;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
class Decart_tree;

signed main()
{
#ifndef LOCAL_STDOUT
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int n;
    cin >> n;
    map<int, pair<int, int>> ys;
    map<int, int> tmp;
    int max_y = -1e9;
    int min_y = 1e9;
    for (int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        max_y = max(max_y, y);
        min_y = min(min_y, y);
        if (tmp.find(y) == tmp.end())
        {
            tmp[y] = x;
        } else if (ys.find(y) == ys.end())
        {
            pair<int, int> temp = {x, tmp[y]};
            if (temp.first > temp.second) swap(temp.first, temp.second);
            ys[y] = temp;
        } else
        {
            pair<int, int>& temp = ys[y];
            if (temp.first > x) temp.first = x;
            else if (temp.second < x) temp.second = x;
        }
    }
    long double answer = 0;
    for (auto [key, x_side] : ys)
    {
        int sz = x_side.second - x_side.first;
        long double temp = 0.5 * sz * max(abs(max_y - key), abs(min_y - key));
        answer = max(answer, temp);
    }
    cout.precision(10);
    cout << answer << endl;
}


class Decart_tree
{
public:
    struct Node
    {
        int x, y;
        int sum;
        int sz;
        Node* l = nullptr;
        Node* r = nullptr;

        Node()
        {
        }

        Node(int x) : x(x), sum(x)
        {
            y = rnd();
            sz = 1;
        }
    };

    Decart_tree()
    {
    }

    bool exist(int x)
    {
        return find(Root, x) != nullptr;
    }

    void insert(int x)
    {
        if (exist(x)) return;

        auto [t1, t2] = split(Root, x);
        Node* nw = new Node(x);

        Root = merge(merge(t1, nw), t2);
    }

    void erase(int x)
    {
        if (!exist(x)) return;

        auto [t1, tt] = split(Root, x);
        auto [t2, t3] = split(tt, x + 1);

        Root = merge(t1, t3);
    }

    int prev(Node* root, int x)
    {
        if (root == nullptr) return -INF;
        auto [t1, t2] = split(Root, x);

        int res = max(t1);

        Root = merge(t1, t2);
        return res;
    }

    int next(Node* root, int x)
    {
        if (root == nullptr) return INF;
        auto [t1, tt] = split(root, x);
        auto [t2, t3] = split(tt, x + 1);

        int res = min(t3);

        Root = merge(t1, merge(t2, t3));
        return res;
    }

    Node* find(Node* root, int x)
    {
        if (root == nullptr) return nullptr;
        if (root->x == x) return root;

        if (root->x > x) return find(root->l, x);
        return find(root->r, x);
    }

    int min(Node* root)
    {
        if (root == nullptr) return INF;
        if (root->l == nullptr) return root->x;
        return min(root->l);
    }

    int max(Node* root)
    {
        if (root == nullptr) return -INF;
        if (root->r == nullptr) return root->x;
        return max(root->r);
    }

    int get_sum(Node* root, int l, int r)
    {
        if (root == nullptr) return 0;

        auto [t1, tt] = split(root, l);
        auto [t2, t3] = split(tt, r + 1);

        int res = get_sum(t2);

        root = merge(t1, merge(t2, t3));

        return res;
    }

    int get_kth(Node* root, int k)
    {
        if (root == nullptr) return INF;

        if (get_size(root->l) >= k) return get_kth(root->l, k);
        if (get_size(root->l) == k - 1) return root->x;
        return get_kth(root->r, k - get_size(root->l) - 1);
    }

    int size() { return get_size(Root); }
    int sum() { return get_sum(Root); }
    int get_kth(int k) { return get_kth(Root, k); }
    int get_sum(int l, int r) { return get_sum(Root, l, r); }
    int prev(int x) { return prev(Root, x); }
    int next(int x) { return next(Root, x); }
    int max() { return max(Root); }
    int min() { return min(Root); }

private:
    Node* Root = nullptr;
    const int INF = 2e9;

    int get_sum(Node* root)
    {
        if (root == nullptr) return 0;
        return root->sum;
    }

    int get_size(Node* root)
    {
        if (root == nullptr) return 0;
        return root->sz;
    }

    void recalc(Node* root)
    {
        if (root == nullptr) return;
        root->sum = get_sum(root->l) + get_sum(root->r) + root->x;
        root->sz = get_size(root->l) + get_size(root->r) + 1;
    }

    Node* merge(Node* tl, Node* tr)
    {
        if (tl == nullptr) return tr;
        if (tr == nullptr) return tl;

        if (tl->y > tr->y)
        {
            tl->r = merge(tl->r, tr);
            recalc(tl);
            return tl;
        }
        tr->l = merge(tl, tr->l);
        recalc(tr);
        return tr;
    }

    pair<Node*, Node*> split(Node* root, int x)
    {
        if (root == nullptr) return {nullptr, nullptr};

        if (root->x >= x)
        {
            auto [t1, t2] = split(root->l, x);
            root->l = t2;
            recalc(root);
            return {t1, root};
        }
        auto [t1, t2] = split(root->r, x);
        root->r = t1;
        recalc(root);
        return {root, t2};
    }
};
