#include <algorithm>
#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return bin_pow(a, n - 1) * a;
    ll b = bin_pow(a, n / 2);
    return b * b;
}

ll gcd(ll a, ll b) {
    while (a && b) {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

struct point {
    ll x, y;
};

point get(point a, point b) {
    return {b.x - a.x, b.y - a.y};
}

ll operator*(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

void solve() {
    string s;
    ll k;
    cin >> s >> k;
    vector <vector <int>> ind(10), mn(10), sum(10);
    vector <int> index(10, 0);
    for (int i = 0; i < s.size(); i++) {
        ind[s[i] - '0'].push_back(i);
        mn[s[i] - '0'].push_back(0);
        sum[s[i] - '0'].push_back(0);
    }
    int curind = 0;
    string ans;
    while (curind < s.size()) {
        for (int i = 1; i <= 9; i++) {
            if (index[i] == ind[i].size()) continue;
            sum[i][index[i]] = ((index[i] > 0) ? sum[i][index[i] - 1] : 0) + mn[i][index[i]];
        }
        int indnow;
        for (int i = 1; i <= 9; i++) {
            if (index[i] == ind[i].size()) continue;
            if (k >= ind[i][index[i]] + sum[i][index[i]]) {
                k -= ind[i][index[i]] + sum[i][index[i]];
                indnow = ind[i][index[i]];
                index[i]++;
                break;
            }
        }
        for (int i = 1; i <= 9; i++) {
            if (index[i] == ind[i].size()) continue;
            int ind1 = upper_bound(ind[i].begin(), ind[i].end(), indnow) - ind[i].begin();
            if (ind1 == ind[i].size()) continue;
            mn[i][ind1]--;
        }
        ans.push_back(s[indnow]);
        curind++;
    }
    cout << ans << "\n";
}

int main() {
    int t = 1;
    cin >> t;
    while (t--) solve();
}
