#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<long long> vll;
typedef map<int, int> mii;
typedef priority_queue<int> pqi;
typedef pair<int, int> pii;

#define mod(A, B) (((A) % (B) + B) % (B))

const int MOD1 = 998244353;
const int MOD2 = 1000013011;
const int BASE1 = 100003;
const int BASE2 = 31;
const ll LINF = 2e18;
const int INF = 2e9;
const int SIZE = 1e7;
const ld EPS = 5e-10;

struct segment_tree {
  int n;
  vi t;

  segment_tree(int _n) {
    n = _n;
    t = vi(4 * n);
  }

  int sum(int v, int vl, int vr, int l, int r) {
    if(vl > r || vr < l) {
      return 0;
    }
    if(l <= vl && vr <= r) {
      return t[v];
    }
    int vm = (vl + vr) / 2;
    return sum(2 * v + 1, vl, vm, l, r) + sum(2 * v + 2, vm + 1, vr, l, r);
  }

  void modify(int v, int vl, int vr, int i, int x) {
    if(vl > i || vr < i) {
      return;
    }
    if(vl == i && i == vr) {
      t[v] = x;
      return;
    }
    int vm = (vl + vr) / 2;
    modify(2 * v + 1, vl, vm, i, x);
    modify(2 * v + 2, vm + 1, vr, i, x);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
  }
};

void solve() {
  string s; cin >> s;
  ll k; cin >> k;
  int n = s.size();

  segment_tree st(n);
  for(int i=0; i<n; ++i) {
    st.modify(0, 0, n - 1, i, 1);
  }

  vector<deque<int>> v(10);
  for(int i=0; i<n; ++i) {
    v[s[i] - '0'].push_back(i);
  }

  for(int i=0; i<n; ++i) {
    for(int x=1; x<=9; ++x) {
      if(v[x].empty()) {
        continue;
      }
      int moves = st.sum(0, 0, n - 1, 0, v[x].front()) - 1;
      if(k >= moves) {
        cout << x;
        k -= moves;
        st.modify(0, 0, n - 1, v[x].front(), 0);
        v[x].pop_front();
        break;
      }
    }
  }
  cout << "\n";
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  int tt = 1;
  cin >> tt;
  for (int i = 0; i < tt; ++i)
    solve();
}