#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<long long> vll;
typedef map<int, int> mii;
typedef priority_queue<int> pqi;
typedef pair<int, int> pii;

#define mod(A, B) (((A) % (B) + B) % (B))

const int MOD1 = 998244353;
const int MOD2 = 1000013011;
const int BASE1 = 100003;
const int BASE2 = 31;
const ll LINF = 2e18;
const int INF = 2e9;
const int SIZE = 1e7;
const ld EPS = 5e-10;

int n;
vector<vector<pii>> g;
vector<ll> dist;
vector<bool> used;

bool tree = true;

void dfs(int v) {
  if (used[v]) {
    return;
  }
  used[v] = true;
  for (auto [u, w] : g[v]) {
    if (dist[u] > dist[v] + w) {
      dist[u] = dist[v] + w;
      dfs(u);
    }
  }
}

void check_graph(int v, int p) {
  if (used[v]) {
    tree = false;
    return;
  }
  used[v] = true;
  for (auto [u, w] : g[v]) {
    if (u != p) {
      check_graph(u, v);
    }
  }
}

void solve() {
  cin >> n;
  vector<vector<ll>> m(n, vector<ll>(n));
  vector<vector<bool>> edges(n, vector<bool>(n, true));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      cin >> m[i][j];
    }
  }
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      for (int k = j + 1; k < n; ++k) {
        if (m[i][j] + m[j][k] < m[i][k]) {
          cout << "No\n";
          return;
        }
        if (m[i][j] + m[j][k] == m[i][k]) {
          edges[i][k] = false;
          edges[k][i] = false;
        }
      }
    }
  }
  g = vector<vector<pii>>(n);
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      if (edges[i][j]) {
        g[i].emplace_back(j, m[i][j]);
        g[j].emplace_back(i, m[i][j]);
      }
    }
  }
  used = vector<bool>(n);
  check_graph(0, -1);
  for (int i = 0; i < n; ++i) {
    if (!used[i]) {
      tree = false;
    }
  }
  if (!tree) {
    cout << "No\n";
    return;
  }

  dist = vector<ll>(n);
  used = vector<bool>(n);
  for (int i = 0; i < n; ++i) {
    fill(dist.begin(), dist.end(), LINF);
    fill(used.begin(), used.end(), 0);
    dist[i] = 0;
    dfs(i);
    for (int j = 0; j < n; ++j) {
      if (m[i][j] != dist[j]) {
        cout << "No\n";
        return;
      }
    }
  }
  cout << "Yes\n";
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  int tt = 1;
  // cin >> tt;
  for (int i = 0; i < tt; ++i)
    solve();
}