#include <algorithm>
#include <bitset>
#include <cctype>
#include <cstdio>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <vector>
using namespace std;
#define int long long
#define M9 2286661337LL
#define mod 998244353
#define INF (M9 * M9)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define eps 1e-6

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
// int get_rnd(int l, int r) { return rnd() % (r - l + 1) + l; }

void solve() {

  int n;
  cin >> n;
  vector<vector<int>> g(n, vector<int>(n));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      cin >> g[i][j];
    }
  }

  vector<bool> used(n);

  vector<int> min_e(n, M9);
  min_e[0] = 0;

  vector<vector<int>> ans(n, vector<int>());
  vector<int> sel_e(n, -1);

  for (int i = 0; i < n; ++i) {
    int v = -1;
    for (int j = 0; j < n; ++j)
      if (!used[j] && (v == -1 || min_e[j] < min_e[v])) {
        v = j;
      }

    used[v] = true;
    if (sel_e[v] != -1) {
      ans[v].push_back(sel_e[v]);
      ans[sel_e[v]].push_back(v);
//      ans += sqrt(dist(g[v], g[sel_e[v]]));
    }

    for (int to = 0; to < n; ++to) {
      if (to == v)
        continue;

      if (g[v][to] < min_e[to]) {
        min_e[to] = g[v][to];
        sel_e[to] = v;
      }
    }
  }

//  for (int i = 0; i < n; i++) {
//    std::cout << i << '\t';
//    for (auto &j : ans[i]) {
//      std::cout << j << " ";
//    }
//    std::cout << '\n';
//  }

  for (int i = 0; i < n; i++) {
    vector<int> dist(n, INF);
    dist[i] = 0;

    queue<int> q;
    q.push(i);

    while(!q.empty()) {
      int now = q.front(); q.pop();
      for (auto &to : ans[now]) {
        if (dist[to] > dist[now] + g[now][to]) {
          dist[to] = dist[now] + g[now][to];
          q.push(to);
        }
      }
    }

    for (int j = 0; j < n; j++) {
      if (g[i][j] != dist[j]) {
        std::cout << "No";
        return;
      }
    }
  }
  std::cout << "Yes";
}

signed main() {
#ifdef LOCAL_ARTEM
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int t = 1;
  //  cin >> t;
  while (t--)
    solve();

#ifdef LOCAL_ARTEM
  cout << '\n'
       << fixed << setprecision(3) << 1. * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
  return 0;
}
