#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <iomanip>
#include <string>
#include <random>
#include <typeinfo>
#include <map>
#include <set>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <cstddef>
#include <unordered_map>
#include <array>
#include <ranges>

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,popcnt,tune=native")

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define debug(x) cerr << #x << ": " << x << endl
#define debugvec(x) ({cerr << #x << ":\n"; for (const auto& e :x) cerr << '\t' << e << '\n';})
#else
#define debug(x) ;
#define debugvec(x) ;
#endif

using std::cout;
using std::cin;
using std::cerr;
using std::endl;
using std::ostream;
using std::istream;
using std::vector;
using std::pair;
using std::string;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
std::mt19937 rnd(459);

template<typename T>
istream &operator>>(istream &in, vector<T> &vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        in >> vec[i];
    }
    return in;
}

ostream &operator<<(ostream &out, const vector<bool> &vec) {
    for (bool i: vec) {
        if (i)
            out << '1';
        else
            out << '0';
    }
    return out;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, const pair<T, U> &p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &vec) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T &a, const T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool maxi(T &a, const T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */


struct index {
    vector<int> xs;

    index() {
    }

    void add(int i) {
        xs.push_back(i);
    }

    void build() {
        std::sort(all(xs));
        xs.resize(std::unique(all(xs)) - xs.begin());
    }

    int get_true_x(int i) {
        return xs[i];
    }

    int get_ind(int x) {
        return std::lower_bound(all(xs), x) - xs.begin();
    }

    size_t size() {
        return xs.size();
    }

    int find(int x) {
        int r = get_ind(x);
        if (r == size() || xs[r] != x) {
            return -1;
        }
        return r;
    }

};

void solve() {
    int n;
    string s;
    std::getline(cin, s);
    sscanf(s.c_str(), "for (int i = 0; i < %d; i++) {", &n);
    vector<pair<int, int> > ifs;
    index unusual;
    while (true) {
        std::getline(cin, s);
        if (s == "    work (i);") {
            continue;
        }
        if (s == "}") {
            break;
        }
        int a, b;
        sscanf(s.c_str(), "    if (i == %d) i = %d;", &a, &b);
        ifs.emplace_back(a, b);
        unusual.add(a);
    }
    // if (ifs.empty()) {
    //     ll ans = 3 * static_cast<ll>(n) + 2;
    //     cout << ans;
    //     return;
    // }
    unusual.build();
    vector<pair<int, int> > jump(unusual.size(), {-1, 0});
    for (int i = ifs.size() - 1; i >= 0; --i) {
        auto [cur, nxt] = ifs[i];
        int cur_i = unusual.find(cur);
        int nxt_i = unusual.find(nxt);
        if (nxt_i == -1 || jump[nxt_i].first == -1) {
            jump[cur_i] = {nxt, 1};
        } else {
            jump[cur_i] = {jump[nxt_i].first, jump[nxt_i].second + 1};
        }
    }
    ll usual_cycle = ifs.size() + 3;
    vector<bool> used(unusual.size(), false);
    ll ans = 2;
    int cur = 0;

    while (true) {
        int nxt_unusual = unusual.get_ind(cur);
        if (nxt_unusual == unusual.size()) {
            ans += (n - cur) * usual_cycle;
            break;
        }
        if (used[nxt_unusual]) {
            cout << -1;
            return;
        }
        used[nxt_unusual] = true;
        int x_nxt = unusual.get_true_x(nxt_unusual);
        ans += (x_nxt - cur + 1) * usual_cycle;
        ans += jump[nxt_unusual].second;
        cur = jump[nxt_unusual].first;
        ++cur;
    }

    cout << ans;
}

signed main() {
    // std::ios_base::sync_with_stdio(false);
    // cin.tie(nullptr);
    // cout.tie(nullptr);

#ifdef DUDE
    freopen("./../inputf.in", "r", stdin);
    freopen("./../outputf.out", "w", stdout);
#endif

    solve();
    cout << '\n';

    //
    //     // stress();
    //
    //     // #define DUDE
    //     int test = 1;
    // #ifdef DUDE
    //     cin >> test;
    // #endif
    //     while (test--) {
    //         solve();
    //         cout << '\n';
    //     }
    //     return 0;
};
