#ifdef LOCAL  // -DLOCAL

#include "debug.h"
#include "headers.h"

// #define debug(...) 42

std::ifstream in("test.in");
auto _ = std::cin.rdbuf(in.rdbuf());

#else

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#define debug(...) 42
#define assert(...) 42

#endif

using std::array;
using std::bitset;
using std::cin;
using std::cout;
using std::deque, std::priority_queue;
using std::endl;
using std::fstream, std::ifstream, std::ofstream;
using std::get;
using std::ios;
using std::iterator;
using std::list, std::forward_list;
using std::lower_bound, std::upper_bound;
using std::map, std::multimap, std::unordered_map;
using std::pair, std::make_pair;
using std::queue;
using std::set, std::multiset, std::unordered_set;
using std::sort;
using std::stack;
using std::string;
using std::swap;
using std::tie;
using std::tuple, std::make_tuple;
using std::vector;

using ll = long long;
using ld = long double;
using ul = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;
using vi = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vb = vector<bool>;
using vpi = vector<pi>;
using vpll = vector<pll>;
using vvi = vector<vi>;
using vvll = vector<vll>;
using vvb = vector<vb>;
using vvpi = vector<vpi>;
using vvpll = vector<vpll>;

#define all(obj) obj.begin(), obj.end()

void precalc() {
  
}

const ll INF = 100;
 
inline ll log2(ll n) {
	ll res = 1;
	while ((1 << res) < n) {
		++res;
	}
	return res;
}
 
ll max_n;
 
struct Solution {
	ll k;
	vll d;
 
	Solution() : k(1) {}
 
	Solution(const Solution &prev) : k(prev.k + 1), d((k > 20 ? 0 : std::max(0ll, max_n - (1 << k)))) {
		ll rn = 1 << k;
		ll r = k;
		for (ll i = 0; i < d.size(); ++i) {
			ll l = prev.get((1 << k) + 1 + i - rn);
			d[i] = std::max(l, r) + 1;
			if (l > r) {
				rn = (1 << k) + i;
				++r;
			}
		}
	}
 
	ll get(ll n) const {
		if (n == 1) {
			return 0;
		}
		if(k == 0) {
			return INF;
		}
		if(k == 1) {
			return n - 1;
		}
		if (log2(n) <= k) {
			return log2(n);
		}
		return d[n - 1 - (1 << k)];
	}
 
};

void solve() {
  ll k;
 
	cin >> max_n >> k;

  k *= 2;
 
	if(max_n == 1) {
		cout << 0 << '\n';
		return;
	}
	if(k == 0) {
		cout << -1 << '\n';
		return;
	}
	if(k == 1) {
		cout << max_n - 1 << '\n';
		return;
	}
	if (log2(max_n) <= k) {
		cout << log2(max_n) << '\n';
		return;
	}
 
	Solution s;
 
 
	for (ll i = 2; i <= std::min(k, ll(1e6 + 10)); ++i) {
		s = Solution(s);
	}
 
	cout << s.get(max_n)  << '\n';
}

int main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);

  std::cout.precision(15);

  precalc();
  int t = 1;
  std::cin >> t;
  while (t--) {
    solve();
  }

  return 0;
}