#include <iomanip>
#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cstdint>
#include <bitset>

using namespace std;

map<int, uint8_t> numToBin = {
    {0, 0b01110111},
    {1, 0b00010010},
    {2, 0b01011101},
    {3, 0b01011011},
    {4, 0b00111010},
    {5, 0b01101011},
    {6, 0b01101111},
    {7, 0b01010010},
    {8, 0b01111111},
    {9, 0b01111011},
    {-1, 0b00000000}
};

uint8_t toBin(const string& s) {
    cerr << s << endl;
    uint8_t res = 0;
    for (char c: s) {
        res |= (uint8_t)(c == '1');
        res <<= 1;
    }
    res >>= 1;
    return res;
}

void out(uint8_t n) {
    std::bitset<8> bs(n);
    cout << bs << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    string s1, s2;
    cin >> s1 >> s2;
    auto mask1 = toBin(s1);
    auto mask2 = toBin(s2);

    map<uint8_t, int> binToNum;
    for (const auto [num, bin]: numToBin) {
        binToNum[bin] = num;
    }

    int ans = 0;

    for (int i = 99; i >= 1; i--) {
        int cur = i;
        int curAns = 0;
        int prev = -1;
        while (cur > 0) {
            uint8_t curBin1, curBin2;
            curBin1 = numToBin[cur / 10];
            curBin2 = numToBin[cur % 10];
            if (cur < 10) {
                curBin1 = numToBin[-1];
            }

            uint8_t curBinBroken1 = curBin1 & mask1;
            uint8_t curBinBroken2 = curBin2 & mask2;

            auto it1 = binToNum.find(curBinBroken1);
            auto it2 = binToNum.find(curBinBroken2);

            if (it1 == binToNum.end() || it2 == binToNum.end()) {
                break;
            }

            int curBroken;
            if (it1->second == -1) {
                curBroken = it2->second;
            } else {
                curBroken = it1->second * 10 + it2->second;
            }

            if (curBroken < 0) {
                break;
            } 

            if (prev == -1 || curBroken == prev + 1) {
                curAns++;
                prev = curBroken;
                cur--;
            } else {
                break;
            }
        }
        ans = max(ans, curAns);
    }

    cout << max(ans - 1, 0) << endl;

    return 0;
}
