#include <iomanip>
#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cstdint>
#include <bitset>
#include <numeric>
#include <sstream>
#include <cassert>

using namespace std;

struct Ans {
    long long m, s, f;
};

long long gcd (long long a, long long b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

signed main() {
    ios_base::sync_with_stdio(false);

    long long n;
    cin >> n;
    vector<long long> a(n);
    for (long long i = 0; i < n; ++i) {
        cin >> a[i];
    }
    long long s, f;
    cin >> s >> f;
    --s;
    --f;
    vector<Ans> ans;

    long long start = s;
    long long end   = f;
    long long step  = (s < f) ? 1 : -1;

    long long curS = start;
    long long commonGcd = -1;
    for (long long i = start + step; i != end + step; i += step) {
        long long diff = llabs(a[i] - a[i - step]);
        if (diff == 1) {
            cout << "Impossible" << endl;
            return 0;
        }
        if (diff == 0) {
            continue;
        } 

        if (commonGcd == -1) {
            commonGcd = diff;
        } else {
            long long curGcd = gcd(commonGcd, diff);
            if (curGcd == 1) {
                ans.push_back({commonGcd, curS, i - step});
                curS = i - step;
                commonGcd = diff;
            }
        }
    }

    if (commonGcd == -1) {
        commonGcd = a[end];
    }

    ans.push_back({commonGcd, curS, end});

    stringstream ss;

    for (auto& [num, from, to]: ans) {
        assert(num != -1);
        if (num < 2 || from == to) {
            cout << "Impossible" << endl;
            return 0;
        }
        ss << "Kaban-" << num << " " << from + 1 << " " << to + 1 << endl;
    }

    cout << ss.str();

    return 0;
}
