#include <bits/stdc++.h>

using namespace std;

constexpr int64_t INF = 1e13;

void solve() {
  int n;
  cin >> n;
  vector<vector<int64_t>> dist(n, vector<int64_t>(n));
  for (auto& v : dist) {
    for (auto& x : v) cin >> x;
  }
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      if (dist[i][j] == 0) {
        cout << "No\n";
        return;
      }
    }
  }
  vector<vector<int64_t>> dist2(n, vector<int64_t>(n, INF));
  for (int i = 0; i < n; ++i) dist2[i][i] = 0;
  vector<bool> used(n);
  vector<int64_t> min_edge(n, INF);
  vector<int> best_edge(n, -1);
  min_edge[0] = 0;
  for (int i = 0; i < n; i++) {
    int v = -1;
    for (int u = 0; u < n; u++)
      if (!used[u] && (v == -1 || min_edge[u] < min_edge[v]))
        v = u;

    used[v] = true;
    if (v != 0) {
      int u = best_edge[v];
      int64_t w = min_edge[v];
      for (int k = 0; k < n; ++k) {
        if (dist2[v][k] != INF) {
          dist2[u][k] = dist2[v][k] + w;
          dist2[k][u] = dist2[v][k] + w;
        } else if (dist2[u][k] != INF) {
          dist2[v][k] = dist2[u][k] + w;
          dist2[k][v] = dist2[u][k] + w;
        }
      }
    }

    for (int e = 0; e < n; ++e) {
      if (e == v) continue;
      int u = e;
      int64_t w = dist[v][e];
      if (w < min_edge[u]) {
        min_edge[u] = w;
        best_edge[u] = v;
      }
    }
  }

  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      if (dist[i][j] != dist2[i][j]) {
        cout << "No\n";
        return;
      }
    }
  }
  cout << "Yes\n";
}

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }

  return 0;
}
