#include <bits/stdc++.h>

using namespace std;

int INF = INT32_MAX;

struct Edge {
    int f = -1;
    int s = -1;
    int len = -1;
    Edge() = default;
};

bool operator<(Edge a, Edge b) {
    return a.len < b.len;
}

int dijkstra(int s, int f, vector<vector<pair<int, int>>> &g) {
    vector<int> d(g.size(), INF);
    d[s] = 0;
    set< pair<int, int> > q;
    q.insert({0, s});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto [u, w] : g[v]) {
            if (d[u] > d[v] + w) {
                q.erase({d[u], u});
                d[u] = d[v] + w;
                q.insert({d[u], u});
            }
        }
    }
    return d[f];
}

bool dfs(vector<vector<pair<int, int>>> &g, vector<int> &used, int v, int p, int it) {
    used[v] = it;
    bool ret = true;
    for (auto [u, w] : g[v]) {
        if (u == p) continue;
        if (used[u] == it) {
            //cout << u << " " << v << "\n";
            return false;
        }
        ret = ret && (dfs(g, used, u, v, it));
    }
    return ret;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> matr(n, vector<int> (n));
    vector<vector<pair<int, int>>> graph(n);
    vector <int> used(n);
    vector<Edge> edges;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matr[i][j];
            if(j > i) edges.push_back({i, j, matr[i][j]});
        }
    }
    sort(edges.begin(),  edges.end());

    int it = 1;
    for (auto i :  edges) {
        int dist = dijkstra(i.f, i.s, graph);
        dist = min (dist, dijkstra(i.s, i.f, graph));
        if (dist < i.len) {
            cout << "No";
            return 0;
        }
        if (dist > i.len) {
            //cout << i.f << " " << i.s << " " << i.len << "\n";
            graph[i.f].push_back({i.s, i.len});
            graph[i.s].push_back({i.f, i.len});
        }
        if (!dfs(graph, used, 0, -1, it)){
            cout << "No";
            return 0;
        }
        it++;
    }
    cout << "Yes";
}