#pragma GCC optimize("O3,unroll-loops")
 
#include <iostream>
#include <vector>
#include <cstdint>
#include <queue>
#include <algorithm>
  
using namespace std;
  
int INF = INT32_MAX;

  
int distance(int s, int f, vector<vector<pair<int, int>>> &g) {
    vector<int> dists (g.size(), INF);
    vector<int> distf (g.size(), INF);
    queue<tuple<int, int, int>> q;
    dists[s] = 0;
    distf[f] = 0;
    q.push({s, s, 0});
    q.push({f, f, 0});
    while (!q.empty()) {
        int p, v, deep;
        tie (p, v, deep) = q.front();
        q.pop();
        if (p == s){
            for (auto [u, w] : g[v]) {
                if (dists[u] != INF) continue;
                dists[u] = deep + w;
                if (distf[u] != INF) {
                    return dists[u] + distf[u];
                }
                  
                q.push({p, u, deep + w});
            }
        }
        else if (p == f){
            for (auto [u, w] : g[v]) {
                if (distf[u] != INF) continue;
                distf[u] = deep + w;
                if (dists[u] != INF) {
                    //cout << s << " " << u << " " << f <<  " " << dists[u] << " " << distf[u] << "\n";
                    return dists[u] + distf[u];
                }
                q.push({p, u, deep + w});
            }
        }
    }
    return INF;
}
  
int main() {
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> matr(n, vector<int> (n));
    vector<vector<pair<int, int>>> graph(n);
    vector <int> used(n);
    vector<tuple<int, int, int>> edges;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matr[i][j];
            if(j > i) edges.push_back({i, j, matr[i][j]});
        }
    }
    sort(edges.begin(), edges.end(), [](auto &v1, auto &v2)
    {
        return 
            std::tie(std::get<2>(v1), std::get<0>(v1), std::get<1>(v1)) <
            std::tie(std::get<2>(v2), std::get<0>(v2), std::get<1>(v2));
    });
  
    int it = 1;
    for (auto [f, s, len] :  edges) {
        //cout << len << "\n";
        int dist = distance(f, s, graph);
        if (dist != len && dist != INF) {
            //cout << dist << " " << len << "\n";
            cout << "No";
            return 0;
        }
        else if (dist == INF){
            //cout << f << " " << s << " " << len << "\n";
            graph[f].push_back({s, len});
            graph[s].push_back({f, len});
        }
 
        it++;
    }
    cout << "Yes";
}