#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct SegTree {
    vector<int> a, tree;
    int n;

    void build(int l, int r, int ind) {
        if (l == r - 1) {
            tree[ind] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(l, mid, ind * 2 + 1);
        build(mid, r, ind * 2 + 2);
        tree[ind] = gcd(tree[ind * 2 + 1], tree[ind * 2 + 2]);
    }

    SegTree(vector<int> &_a) {
        a = _a;
        n = (int) a.size();
        tree.resize(4 * n, 0);
        build(0, n, 0);
    }

    int get(int l, int r, int ql, int qr, int ind) {
        if (l >= qr || r <= ql) return 0;
        if (l >= ql && r <= qr) return tree[ind];
        int mid = (l + r) / 2;
        return gcd(get(l, mid, ql, qr, ind * 2 + 1), get(mid, r, ql, qr, ind * 2 + 2));
    }

    int ask(int l, int r) {
        return get(0, n, l, r, 0);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i: a) cin >> i;
    vector<int> b(n, 0);
    for (int i = 0; i < n - 1; i++) b[i] = abs(a[i + 1] - a[i]);
    SegTree SegT(b);
    int l, r;
    cin >> l >> r;
    l--, r--;
    bool fl = false;
    if (l > r) {
        swap(l, r);
        fl = true;
    }
    for (int i = l; i < r; i++) {
        if (b[i] == 1) {
            cout << "Impossible";
            return;
        }
    }
    vector<int> dp(n, 0);
    vector<pair<int, int>> last(n);
    for (int i = l + 1; i < n; i++) {
        int lf = -1, rg = i;
        while (rg - lf > 1) {
            int mid = (lf + rg) / 2;
            if (SegT.ask(mid, i) != 1) rg = mid;
            else lf = mid;
        }
        dp[i] = dp[rg] + 1;
        last[i] = {SegT.ask(rg, i), rg};
    }
    vector<int> ans1;
    vector<pair<int, int>> ans2;
    int cur = r;
    while (cur > l) {
        ans1.push_back(last[cur].first);
        if (ans1.back() == 0) ans1.back() = 2;
        ans2.emplace_back(last[cur].second, cur);
        if (ans2.back().first < l) ans2.back().first = l;
        cur = last[cur].second;
    }
    reverse(ans1.begin(), ans1.end());
    reverse(ans2.begin(), ans2.end());
    if (fl) {
        reverse(ans1.begin(), ans1.end());
        reverse(ans2.begin(), ans2.end());
        for (auto &i : ans2) swap(i.first, i.second);
    }
    for (int i = 0; i < dp[r]; i++) {
        cout << "Kaban-" << ans1[i] << " " << ans2[i].first + 1 << " " << ans2[i].second + 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}
