// #
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#endif

// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <type_traits>
#include <typeindex>
#include <unordered_map>
#include <unordered_set>
#endif
/*
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

using namespace __gnu_pbds;
using namespace __gnu_cxx;
*/

using namespace std;

using ll = long long;
using db = long double; // or double, if TL is tight
using str = string;     // yay python!

// pairs
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<db, db>;
#define pb push_back
#define mp make_pair
#define fi first
#define se second

template <class T> using V = vector<T>;
template <class T, size_t SZ> using AR = array<T, SZ>;
using vi = V<int>;
using vvi = V<vi>;
using vb = V<bool>;
using vll = V<ll>;
using vd = V<db>;
using vs = V<str>;
using vpii = V<pii>;
using vpll = V<pll>;
using vpd = V<pd>;

template <class T> using pair2 = pair<T, T>;

// vectors
// oops size(x), rbegin(x), rend(x) need C++17

template <class T> int sz(const T &a) { return a.size(); }

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sor(x) sort(all(x))

template <class T> int lwb(V<T> &a, const T &b) {
  return int(lower_bound(all(a), b) - bg(a));
}
template <class T> int upb(V<T> &a, const T &b) {
  return int(upper_bound(all(a), b) - bg(a));
}

template <class T> using pqg = priority_queue<T, vector<T>, greater<T>>;
template <class T> using pql = priority_queue<T, vector<T>, less<T>>;

// loops
#define rep(a) for (int _ = 0; _ < (a); ++_)
#define each(a, x) for (auto &a : x)

const int MOD = 998244353;
const int MX = 2e5 + 5;
const ll BIG = 1e18; // not too close to LLONG_MAX
const db PI = acos((db)-1);
const int dx[4]{1, 0, -1, 0}, dy[4]{0, 1, 0, -1}; // for every grid problem!!
mt19937 rng((uint32_t)chrono::steady_clock::now().time_since_epoch().count());

namespace kirkon {}
using namespace kirkon;

namespace kirkon_helpers {
  // bitwise ops
  // also see https://gcc.gnu.org/onlinedocs/gcc/Other-Builtins.html
  constexpr long long pct(long long x) {
    return __builtin_popcount(x);
  } // # of bits set
  constexpr long long bits(long long x) { // assert(x >= 0); // make C++11
                                         // compatible until USACO updates ...
    return x == 0 ? 0 : 31 - __builtin_clz(x);
  } // floor(log2(x))
  constexpr long long p2(long long x) { return 1 << x; }
  constexpr long long msk2(long long x) { return p2(x) - 1; }

  ll cdiv(ll a, ll b) {
    return a / b + ((a ^ b) > 0 && a % b);
  } // divide a by b rounded up
  ll fdiv(ll a, ll b) {
    return a / b - ((a ^ b) < 0 && a % b);
  } // divide a by b rounded down

  template <class T> bool ckmin(T &a, const T &b) {
    return b < a ? a = b, 1 : 0;
  } // set a = min(a,b)
  template <class T> bool ckmax(T &a, const T &b) {
    return a < b ? a = b, 1 : 0;
  } // set a = max(a,b)

  template <class T, class U> bool ckmin(T &a, const U &b) {
    return b < a ? a = b, 1 : 0;
  } // set a = min(a,b)
  template <class T, class U> bool ckmax(T &a, const U &b) {
    return a < b ? a = b, 1 : 0;
  } // set a = max(a,b)

  template <class T, class U> T fstTrue(T lo, T hi, U f) {
    ++hi;
    assert(lo <= hi); // assuming f is increasing
    while (lo < hi) { // find first index such that f is true
      T mid = lo + (hi - lo) / 2;
      f(mid) ? hi = mid : lo = mid + 1;
    }
    return lo;
  }
  template <class T, class U> T lstTrue(T lo, T hi, U f) {
    --lo;
    assert(lo <= hi); // assuming f is decreasing
    while (lo < hi) { // find first index such that f is true
      T mid = lo + (hi - lo + 1) / 2;
      f(mid) ? lo = mid : hi = mid - 1;
    }
    return lo;
  }

  template <class T> void remDup(vector<T> &v) { // sort and remove duplicates
    sort(all(v));
    v.erase(unique(all(v)), end(v));
  }
  template <class T, class U> void erase(T &t, const U &u) { // don't erase
    auto it = t.find(u);
    assert(it != end(t));
    t.erase(it);
  } // element that doesn't exist from (multi)set

  ll myRand(ll B) { return (unsigned long long)rng() % B; }

  // http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2016/p0200r0.html
  template <class Fun> class y_combinator_result {
    Fun fun_;

public:
    template <class T>
    explicit y_combinator_result(T &&fun) : fun_(std::forward<T>(fun)) {}
    template <class... Args> decltype(auto) operator()(Args &&...args) {
      return fun_(std::ref(*this), std::forward<Args>(args)...);
    }
  };

  template <class Fun> decltype(auto) y_combinator(Fun &&fun) {
    return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun));
  }

  template <class T, class U> istream &operator>>(istream &in, pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
  }

  template <class T, class U> ostream &operator<<(ostream &out, pair<T, U> &a) {
    out << a.first << ' ' << a.second << '\n';
    return out;
  }

  template <class T, size_t SZ> istream &operator>>(istream &in, array<T, SZ> &a) {
    each(i, a) { in >> i; }
    return in;
  }

  template <class T, size_t SZ> ostream &operator<<(ostream &out, array<T, SZ> &a) {
    each(i, a) { out << i << ' '; }
    out << '\n';
    return out;
  }

  template <class T> istream &operator>>(istream &in, vector<T> &a) {
    each(i, a) { in >> i; }
    return in;
  }

  template <class T> ostream &operator<<(ostream &out, vector<T> &a) {
    each(i, a) { out << i << ' '; }
    out << '\n';
    return out;
  }

} // namespace kirkon_helpers

using namespace kirkon_helpers;

struct custom_int_hash {
  static uint64_t splitmix64(uint64_t x) {
    // http://xorshift.di.unimi.it/splitmix64.c
    x += 0x9e3779b97f4a7c15;
    x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
    x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
    return x ^ (x >> 31);
  }

  size_t operator()(uint64_t x) const {
    static const uint64_t FIXED_RANDOM =
            chrono::steady_clock::now().time_since_epoch().count();
    return splitmix64(x + FIXED_RANDOM);
  }
} hasher;


/*
namespace advanced_structures {
template <class T>
using Tree =
    tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

namespace mapOp {
const int tmp = chrono::high_resolution_clock::now().time_since_epoch().count();

template <class T> struct hsh {
  size_t operator()(const T &x) const {
    return hash<T>{}(x) ^ tmp; // avoid anti-hash tests?
  }
};

template <> struct hsh<int> {
  size_t operator()(const int &x) const {
    return hasher(x); // avoid anti-hash tests?
  }
};

template <class a, class b> using um = gp_hash_table<a, b, hsh<a>>;

template <class a, class b> b get(um<a, b> &u, a x) {
  if (u.find(x) == u.end())
    return 0;
  return u[x];
}
} // namespace mapOp
using namespace mapOp;
} // namespace advanced_structures

using namespace advanced_structures;
*/

/*
  function<void(const vector<int>&)> solver = [&](const vector<int>& subtree) {
  	if (subtree.size() <= 1) {
  		return;
  	}

  	int mn_x = 0, mn_y = 1;
  	vector<int> left_subtree;
  	vector<int> right_subtree;
  	for (int i = 0; i < subtree.size(); ++i) {
  		for (int j = i + 1; j < subtree.size(); ++j) {
  			if (matrix[subtree[i]][subtree[j]] < matrix[subtree[mn_x]][subtree[mn_y]]) {
  				mn_x = i;
  				mn_y = j;
  			}
  		}
  	}

  	gr[subtree[mn_x]].push_back({subtree[mn_y], matrix[subtree[mn_x]][subtree[mn_y]]});
  	gr[subtree[mn_y]].push_back({subtree[mn_x], matrix[subtree[mn_x]][subtree[mn_y]]});

  	if (!left_subtree.empty()) {
  		int best = 0;
	  	for (int left : left_subtree) {
	  		if (matrix[subtree[left]][subtree[mn_x]] < matrix[subtree[best]][subtree[mn_x]]) {
	  			best = left;
	  		}
	  	}

	  	gr[subtree[best]].push_back({subtree[mn_x], matrix[subtree[best]][subtree[mn_x]]});
	  	gr[subtree[mn_x]].push_back({subtree[best], matrix[subtree[best]][subtree[mn_x]]});
	  	solver(left_subtree);
  	}

  	if (!right_subtree.empty()) {
			int best = 0;
	  	for (int right : right_subtree) {
	  		if (matrix[subtree[right]][subtree[mn_y]] < matrix[subtree[best]][subtree[mn_y]]) {
	  			best = right;
	  		}
	  	}

	  	gr[subtree[best]].push_back({subtree[mn_y], matrix[subtree[best]][subtree[mn_y]]});
	  	gr[subtree[mn_y]].push_back({subtree[best], matrix[subtree[best]][subtree[mn_y]]});
	  	solver(right_subtree);
  	}
  };*/

void solve() {
  int n; cin >> n;
  vector<vector<int>> matrix(n, vector<int>(n)); cin >> matrix;
  vector<vector<array<int, 2>>> gr(n);

  vector<int> alive(n); iota(all(alive), 0);

  auto add_edge = [&](int i, int j) {
    int w = matrix[i][j];
    gr[i].push_back({j, w});
    gr[j].push_back({i, w});
  };

  while(alive.size() >= 2) {
    int mx_i = 0, mx_j = 1;
    for (int i = 0; i < alive.size(); ++i) {
      for (int j = i + 1; j < alive.size(); ++j) {
        auto x = alive[i];
        auto y = alive[j];
        if (matrix[x][y] > matrix[alive[mx_i]][alive[mx_j]]) {
          mx_i = i;
          mx_j = j;
        }
      }
    }

    //current diam is from i to j, so those are the leafs!
    int best_for_i = -1;
    for (int i = 0; i < alive.size(); ++i) {
      if (i == mx_i) {
        continue;
      }
      if (best_for_i == -1 || matrix[alive[mx_i]][alive[i]] < matrix[alive[mx_i]][alive[best_for_i]]) {
        best_for_i = i;
      }
    }
    add_edge(alive[mx_i], alive[best_for_i]);


    int best_for_j = -1;
    for (int j = 0; j < alive.size(); ++j) {
      if (j == mx_j) {
        continue;
      }
      if (best_for_j == -1 || matrix[alive[mx_j]][alive[j]] < matrix[alive[mx_j]][alive[best_for_j]]) {
        best_for_j = j;
      }
    }
    add_edge(alive[mx_j], alive[best_for_j]);

    int was_v = alive[mx_i], was_u = alive[mx_j];
    alive.erase(find(all(alive), was_u));
    alive.erase(find(all(alive), was_v));
  }
  //graph is built in ~1e8 operations. should be fast enough

  vector<vector<int>> real_distances;
  function<void(int, int)> dfs1 = [&](int v, int par) {
    for (auto [u, w] : gr[v]) {
      if (u == par) {
        continue;
      }
      real_distances.back()[u] = real_distances.back()[v] + w;
      dfs1(u, v);
    }
  };

  for (int i = 0; i < n; ++i) {
    real_distances.emplace_back(n, 2e9);
    real_distances[i][i] = 0;
    dfs1(i, -1);
  }

//  cout << gr;
//  cout << real_distances;
  cout << (real_distances == matrix ? "Yes\n" : "No\n");
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.precision(30);
  // setIO();
  int tt = 1;
  // cin >> tt;
  rep(tt) solve();
  // you should actually read the stuff at the bottom
}

/* stuff you should look for
 * long long overflow, array bounds
 * special cases (n=1?)
 * do smth instead of nothing and stay organized
 * WRITE STUFF DOWN
 * DON'T GET STUCK ON ONE APPROACH
 */
