#include <iostream>
#include <vector>
#include <map>
#include <cstdint>
#include <cassert>
#include <algorithm>

#define int long long

using namespace std;

const int MOD = 998244353;
const int N = 5e5 + 5;
int fac[N], inv[N];

int binpow(int a, int p) {
    if (p < 0) return 0;
    if (!p) return 1;
    if (p & 1) return a * binpow(a, p - 1) % MOD;
    auto t = binpow(a, p >> 1);
    return t * t % MOD;
}

int C(int n, int k) {
    if (n < 0 || k < 0 || n < k) return 0;
    return fac[n] * inv[k] % MOD * inv[n - k] % MOD;
}

int C(int n, int a, int b, int c) {
    assert(a + b + c == n);
    if (n < 0 || a < 0 || b < 0 || c < 0) return 0;
    return fac[n] * inv[a] % MOD * inv[b] % MOD * inv[c] % MOD;
}

int f(int n, int m, int c, int l) { // n = a1 + ... + am. a1, a2, ... ac >= l
    n -= l * c;
    if (n < 0)
        return 0;
    return C(n + m - 1, m - 1);
}

void solve() {
    int x, y, z; cin >> x >> y >> z;
    int res = 0;
    for (int l = 0; l < 4; ++l) {
        for (int r = 0; r < 4; ++r) {
            for (int a = 0; a <= x + 1; ++a) {
                int b = a - y + z;
                if (b < 0 || a + b > x + 1) continue;
                int inner_a = a, inner_b = b;
                if (l == 1) inner_a--;
                if (r == 1) inner_a--;
                if (l == 2) inner_b--;
                if (r == 2) inner_b--;
                int add = 1;
                add = add * C(x - 1, inner_a, inner_b, x - 1 - inner_a - inner_b) % MOD;
                add = add * binpow(2, x - 1 - inner_a - inner_b + (l == 3) + (r == 3)) % MOD;
                int cnt = x - 1 + (l > 0) + (r > 0);
                int must = x - 1 - inner_b + (l == 1 || l == 3) + (r == 1 || r == 3);
                add = add * f(y, cnt, must, 1) % MOD;
                res = (res + add) % MOD;
            }
        }
    }

    cout << res << "\n";
}

int dp[50][50][50][3];
void stupid() {
//    int r, g, b; cin >> r >> g >> b;
//    dp[1][0][0][0] = 1;
//    dp[0][1][0][0] = 1;
//    dp[0][0][1][0] = 1;
//    for (int i = 1; i < r + g + b; ++i) {
//        for (int x = 0; x <= i; ++x) {
//            for (int y = 0; x + y <= i; ++y) {
//                int z = i - x - y;
//                for (int f = 0; f < 3; ++f) {
//                    for (int t = 0; t < 3; ++t) {
//                        if (t == f) continue;
//                        dp[x][y][z]
//                    }
//                }
//            }
//        }
//    }
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.precision(20);

    fac[0] = inv[0] = 1;
    for (int i = 1; i < N; ++i) {
        fac[i] = fac[i - 1] * i % MOD;
        inv[i] = binpow(fac[i], MOD - 2);
    }
    solve();
}