#include <iostream>
#include <vector>
#include <cmath>
#include <tuple>
#include <algorithm>

using namespace std;

vector<int> roads;
vector<int> t;
int mm;

int gcd(int a, int b) {
	while (b) {
		a %= b;
		swap (a, b);
	}
	return a;
}


void treeBuild(int i, int tl, int tr) {
    //printf("i: %d, tl: %d, tr: %d\n", i, tl, tr);
    if (tr - tl == 1) {
        t[i] = roads[tl];
    } else {
        int tm = (tl + tr)/2;
        treeBuild(2*i + 1, tl, tm);
        treeBuild(2*i + 2, tm, tr);
        t[i] = gcd(t[2*i + 1], t[2*i + 2]);
    }
}



int query (int i, int tl, int tr, int pl, int pr) {
    //printf("i: %d, tl: %d, tr: %d, pl: %d, pr: %d\n", i, tl, tr, pl, pr);
    if (tl >= pr || tr <= pl) {
        return 0;
    }
    if (pl <= tl && tr <= pr) {
        return t[i];
    }
    int tm = (tl + tr)/2;
    return gcd(query(2*i+1, tl, tm, pl, pr), query(2*i+2, tm, tr, pl, pr));
}


bool check_gcd(int l, int r) {
    return query(0, 0, mm, l, r) != 1;
}


int bin_search(int start, int finish) {
    int l = start, r = finish;

    while (r-l > 1) {
        int m = (l+r)/2;
        if (check_gcd(start, m+1)) {
            l = m;
        } else {
            r = m;
        }
    }

    return l;
}



int main()
{
    ios_base::sync_with_stdio(0);


    int n;
    cin >> n;
    mm = n-1;


    vector<int> counts(n);
    for (int i = 0; i < n; i++) {
        cin >> counts[i];
    }


    roads.resize(n-1);
    t.resize(4*n);
    for (int i = 1; i < n; i++) {
        roads[i-1] = abs(counts[i]-counts[i-1]);
    }

    treeBuild(0, 0, mm);


    int curr, finish;
    cin >> curr >> finish;
    curr--;
    finish--;

    bool flag_rev = false;
    if (curr > finish) {
        flag_rev = true;
        swap(curr, finish);
    }

    vector<tuple<int, int, int>> answer;

    while (curr != finish) {
        if (roads[curr] == 1) {
            cout << "Impossible";
            return 0;
        }
        int nxt = bin_search(curr, finish);
        int ans = query(0, 0, mm, curr, nxt+1);
        answer.push_back({ans == 0 ? 239 : ans, curr, nxt+1});
        curr = nxt+1;
    }

    if (flag_rev) {
        reverse(answer.begin(), answer.end());

        for (int i = 0; i < (int)answer.size(); i++) {
            swap(get<1>(answer[i]), get<2>(answer[i]));
        }



    }

    for (auto i : answer) {
        cout << "Kaban-" << get<0>(i) << ' ' << get<1>(i)+1 << ' ' << get<2>(i)+1 << '\n';
    }







    /*for (int i = 0; i < mm; i++) {
        for (int j = i; j < mm; j++) {
            cout << i << ' ' << j << ' ' << bin_search(i, j+1) << '\n';
        }
    }*/





















    return 0;
}
