#include <bits/stdc++.h>

using namespace std;

template<class T>
ostream& operator<<(ostream& out, const vector<T>& a) {
  for (auto& i : a) {
    out << i << " ";
  }
  return out;
}

template<class T>
T read() {
  T t;
  cin >> t;
  return t;
}

template<class T>
void operator>>(istream& in, vector<T>& a) {
  for (auto& i : a) {
    in >> i;
  }
}

template<class T>
void operator>>(istream& in, vector<vector<T>>& a) {
  for (auto& i : a) {
    in >> i;
  }
}

#define ll long long
#define ull unsigned ll
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define X first
#define Y second
constexpr ll MOD = 1e9 + 9;
constexpr ll inf = 1e10;

struct Edge {
  ll u, v;
  Edge(ll u, ll v) : u(u), v(v) {}
};

struct Dsu {
  vector<ll> p;
  vector<ll> r;
  int n;

  Dsu (size_t n_) {
    n = n_;
    p = vector<ll>(n);
    iota (p.begin (), p.end (), 0);
    r = vector<ll>(n, 0);
  }

  ll root (ll v) {
    if (p[v] == v) {
      return v;
    }

    return p[v] = root(p[v]);
  }

  void unite (ll u, ll v) {
    u = root (u);
    v = root (v);
    if (u != v) {
      if (r[u] > r[v]) {
        swap (u, v);
      }

      p[u] = v;
      if (r[u] == r[v]) {
        r[v] += 1;
      }
    }
  }
};

bool comparator(pair<Edge, ll> o1, pair<Edge, ll> o2) {
  return o1.second < o2.second;
}

void solution() {
  int n = read<int>();
  vector<vector<ll>> a(n, vector<ll>(n));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      a[i][j] = read<ll>();
    }
  }

  vector<pair<Edge, ll>> edges;
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      edges.push_back({Edge(i, j), a[i][j]});
    }
  }

  sort(all(edges), comparator);
  Dsu d(n);
  vector<Edge> ost_edges;
  for (auto&& [e, c] : edges) {
    if (d.root(e.u) != d.root(e.v)) {
      ost_edges.push_back(e);
      d.unite(d.root(e.u), d.root(e.v));
    }
  }

  vector<vector<ll>> adj(n, vector<ll>());
  for (int i = 0; i < ost_edges.size(); i++) {
    adj[ost_edges[i].u].push_back(ost_edges[i].v);
    adj[ost_edges[i].v].push_back(ost_edges[i].u);
  }

  vector<vector<ll>> dist(n, vector<ll>(n, inf));
  for (int i = 0; i < n; ++i) {
    dist[i][i] = 0;
    priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<>> q;
    q.push({0, i});
    while (!q.empty()) {
      auto [current_dist, v] = q.top();
      q.pop();

      if (current_dist > dist[i][v]) continue;

      for (auto u : adj[v]) {
        ll new_dist = dist[i][v] + a[v][u];
        if (new_dist < dist[i][u]) {
          dist[i][u] = new_dist;
          q.push({new_dist, u});
        }
      }
    }
  }

  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      if (dist[i][j] != a[i][j]) {
        cout << "No";
        return;
      }
    }
  }

  cout << "Yes";
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  auto ttt = 1;
  while (ttt--) {
    solution();
  }
}
