#include <iostream>
#include <unordered_map>
#include <tuple>

const int MOD = 998244353;

struct TuplH {
    template <class T1, class T2, class T3, class T4>
    std::size_t operator () (const std::tuple<T1, T2, T3, T4>& tuple) const {
        auto h1 = std::hash<T1>{}(std::get<0>(tuple));
        auto h2 = std::hash<T2>{}(std::get<1>(tuple));
        auto h3 = std::hash<T3>{}(std::get<2>(tuple));
        auto h4 = std::hash<T4>{}(std::get<3>(tuple));
        return h1 ^ h2 ^ h3 ^ h4;
    }
};

std::unordered_map<std::tuple<int, int, int, char>, int, TuplH> dp;

int countW(int r, int g, int b, char lastColor) {
    if (r == 0 && g == 0 && b == 0) {
        return 1;
    }

    auto state = std::make_tuple(r, g, b, lastColor);
    if (dp.find(state) != dp.end()) {
        return dp[state];
    }

    int way = 0;
    if (r > 0 && lastColor != 'R') {
        way = (way + countW(r - 1, g, b, 'R')) % MOD;
    }
    if (g > 0 && lastColor != 'G') {
        way = (way + countW(r, g - 1, b, 'G')) % MOD;
    }
    if (b > 0 && lastColor != 'B') {
        way = (way + countW(r, g, b - 1, 'B')) % MOD;
    }

    dp[state] = way;
    return way;
}

int main() {
    int r, g, b;
    std::cin >> r >> g >> b;

    int result = countW(r, g, b, '\0');
    std::cout << result << std::endl;

    return 0;
}
