#include <bits/stdc++.h>

using namespace std;
using ll = long long int;

struct DSU {
    vector<int> p, sz;

    DSU(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        sz.assign(n, 1);
    }

    int get(int v) {
        if(p[v] == v) {
            return v;
        }
        return p[v] = get(p[v]);
    }

    void unite(int x, int y) {
        x = get(x);
        y = get(y);
        if(x != y) {
            if(sz[x] > sz[y]) {
                swap(x, y);
            }
            p[x] = y;
            sz[y] += sz[x];
        }
    }
};

int main() {
    int n; cin >> n;
    struct e {
        ll w;
        int x, y;

        bool operator<(const e &o) const {
            return w < o.w;
        }
    };
    vector<e> es;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            ll w; cin >> w;
            if(i < j) {
                es.push_back(e { w, i, j });
            }
        }
    }
    sort(es.begin(), es.end());
    vector<vector<pair<int, ll>>> g(n);
    DSU dsu(n);
    for(auto i : es) {
        if(dsu.get(i.x) != dsu.get(i.y)) {
            dsu.unite(i.x, i.y);
            g[i.x].push_back(make_pair(i.y, i.w));
            g[i.y].push_back(make_pair(i.x, i.w));
        }
    }
    vector<vector<int>> up(n, vector<int>(20));
    vector<int> tin(n), tout(n);
    vector<ll> ws(n);
    int timer = 0;
    function<void(int, int, ll)> build_lca = [&](int v, int p, ll w) {
        up[v][0] = p;
        for(int i = 1; i < 20; i++) {
            up[v][i] = up[up[v][i - 1]][i - 1];
        }
        ws[v] = w;
        tin[v] = timer++;
        for(auto i : g[v]) {
            if(i.first != p) {
                build_lca(i.first, v, w + i.second);
            }
        }
        tout[v] = timer++;
    };
    auto is_parent = [&](int x, int y) {
        return tin[x] <= tin[y] && tout[y] <= tout[x];
    };
    auto lca = [&](int x, int y) {
        if(is_parent(x, y)) {
            return x;
        }
        if(is_parent(y, x)) {
            return y;
        }
        for(int i = 19; i >= 0; i--) {
            if(!is_parent(up[x][i], y)) {
                x = up[x][i];
            }
        }
        return up[x][0];
    };
    auto dist = [&](int x, int y) {
        return ws[x] + ws[y] - ws[lca(x, y)] * 2;
    };
    build_lca(0, 0, 0);
    bool ok = true;
    for(auto i : es) {
        // cout << i.x << ' ' << i.y << ' ' << i.w << " = " << dist(i.x, i.y) << '\n';
        if(dist(i.x, i.y) != i.w) {
            ok = false;
        }
    }
    cout << (ok ? "Yes" : "No");
    return 0;
}
