//  ____________
// < Shizerland >
//  ------------
//         \   ^__^
//          \  (oo)\_______
//             (__)\       )\/\
//                 ||----w |
//                 ||     ||

#include <algorithm>
#include <array>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <set>
#include <vector>

using namespace std;

// #define int long long
typedef long long ll;
typedef long double ld;

struct SegmentTree {
    vector<int> data, t;
    SegmentTree(vector<int> &_data) {
        data = _data;
        t.resize(data.size() * 4);
        build(0, 0, data.size());
    }

    void build(int v, int l, int r) {
        if (r - l == 1) {
            t[v] = data[l];
            return;
        }
        int m = (r + l) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    void set(int v, int l, int r, int q, int val) {
        if (l > q || r <= q) return;
        if (r - l == 1) t[v] = val;
        int m = (r + l) / 2;
        set(2 * v + 1, l, m, q, val);
        set(2 * v + 2, m, r, q, val);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (r <= ql || l >= qr) return 0;
        if (ql <= l && r <= qr) return t[v];
        int m = (r + l) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
};

void solve() {
    long long n;
    cin >> n;
    vector<pair<long long, long long>> diff;
    long long mn = 1e9, mx = -1e9;
    for (int i = 0; i < n; ++i) {
        long long x, y;
        cin >> x >> y;
        if (y == 0) {
            mn = min(mn, x);
            mx = max(mx, x);
        } else {
            diff.push_back({x, y});
        }
    }
    if (mn == 1e9) {
        cout << "0";
        return;
    }
    long long mxS = 0;
    for (auto [x, y] : diff) {
        mxS = max(mxS, abs(-(mn - x) * y + y * (mx - x)));
    }
    cout << setprecision(1) << fixed;
    cout << mxS / 2.0l;
}

signed main() {
    cin.tie(0)->sync_with_stdio(false);
    cout.tie(0)->sync_with_stdio(false);
    int t = 1; // cin >> t;
    while (t-- > 0) {
        solve();
        cout << '\n';
    }
    return 0;
}
