//  ____________
// < Shizerland >
//  ------------
//         \   ^__^
//          \  (oo)\_______
//             (__)\       )\/\
//                 ||----w |
//                 ||     ||

#include <algorithm>
#include <array>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <set>
#include <vector>

using namespace std;

// #define int long long
typedef long long ll;
typedef long double ld;

struct SegmentTree {
    vector<int> data, t;
    SegmentTree(vector<int> &_data) {
        data = _data;
        t.resize(data.size() * 4);
        build(0, 0, data.size());
    }

    void build(int v, int l, int r) {
        if (r - l == 1) {
            t[v] = data[l];
            return;
        }
        int m = (r + l) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    void set(int v, int l, int r, int q, int val) {
        if (l > q || r <= q) return;
        if (r - l == 1) t[v] = val;
        int m = (r + l) / 2;
        set(2 * v + 1, l, m, q, val);
        set(2 * v + 2, m, r, q, val);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (r <= ql || l >= qr) return 0;
        if (ql <= l && r <= qr) return t[v];
        int m = (r + l) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
};

array<int, 2> mask;
array<int, 10> numbers{0b1110111, 0b0010010, 0b1011101, 0b1011011, 0b0111010,
                       0b1101011, 0b1101111, 0b1010010, 0b1111111, 0b1111011};
map<int, int> back = {{0b1110111, 0}, {0b0010010, 1}, {0b1011101, 2}, {0b1011011, 3},
                      {0b0111010, 4}, {0b1101011, 5}, {0b1101111, 6}, {0b1010010, 7},
                      {0b1111111, 8}, {0b1111011, 9}};

void solve() {
    int x, y;
    cin >> x >> y;
    for (int i = 0; i < 7; ++i) {
        mask[0] |= (x % 10) << (i);
        x /= 10;
    }
    for (int i = 0; i < 7; ++i) {
        mask[1] |= (y % 10) << (i);
        y /= 10;
    }
    array<int, 100> a;
    for (int i = 0; i < 100; ++i) {
        int n1 = i / 10, n2 = i % 10;
        if (n1 == 0) {
            n1 = 0;
        } else {
            if (back.find(numbers[n1] & mask[0]) == back.end()) {
                n1 = -2;
            } else {
                n1 = back[numbers[n1] & mask[0]];
            }
        }

        if (back.find(numbers[n2] & mask[1]) == back.end()) {
            n2 = -2;
        } else {
            n2 = back[numbers[n2] & mask[1]];
        }

        if (n1 == -2 || n2 == -2) {
            a[i] = -2;
        } else {
            a[i] = n1 * 10 + n2;
        }
    }

    int counter = 0;
    int ans = 0;
    for (int i = 99; i > 1; --i) {
        // cout << a[i] << ' ';
        if (a[i] == a[i - 1] + 1) {
            counter++;
        } else {
            counter = 0;
        }
        ans = max(ans, counter);
    }
    cout << ans << '\n';
}

signed main() {
    cin.tie(0)->sync_with_stdio(false);
    cout.tie(0)->sync_with_stdio(false);
    int t = 1; // cin >> t;
    while (t-- > 0) {
        solve();
        cout << '\n';
    }
    return 0;
}
