//  ____________
// < Shizerland >
//  ------------
//         \   ^__^
//          \  (oo)\_______
//             (__)\       )\/\
//                 ||----w |
//                 ||     ||

#include <algorithm>
#include <array>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <set>
#include <sstream>
#include <vector>

using namespace std;

// #define int long long
typedef long long ll;
typedef long double ld;

int timer = 1;
vector<vector<pair<int, int>>> g;
vector<vector<int>> dist;
vector<int> vis;

void dfs(int v, int st, int d = 0) {
    vis[v] = timer;
    dist[v][st] = d;
    dist[st][v] = d;
    for (auto [u, w] : g[v]) {
        if (vis[u] != timer) {
            dfs(u, st, d + w);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    set<array<int, 3>> mst;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            mst.insert({a[i][j], i, j});
        }
    }

    g.resize(n);
    while (!mst.empty()) {
        array<int, 3> mx = *prev(mst.end());
        for (int v = 1; v < 3; v++) {
            int mn = 1e9 + 1, pos = 0;
            for (int i = 0; i < n; i++) {
                if (mx[v] != i && a[mx[v]][i] < mn &&
                    mst.find({a[mx[v]][i], mx[v], i}) != mst.end()) {
                    mn = a[mx[v]][i];
                    pos = i;
                }
            }
            g[mx[v]].push_back({pos, mn});
            g[pos].push_back({mx[v], mn});
        }
        for (int i = 0; i < n; i++) {
            mst.erase({a[i][mx[1]], i, mx[1]});
            mst.erase({a[mx[1]][i], mx[1], i});
            mst.erase({a[i][mx[2]], i, mx[2]});
            mst.erase({a[mx[2]][i], mx[2], i});
        }
    }

    dist.assign(n, vector<int>(n, 0));
    vis.resize(n, 0);
    for (int i = 0; i < n; i++) {
        dfs(i, i);
        timer++;
    }

    cout << (a == dist ? "Yes" : "No");
}

signed main() {
    cin.tie(0)->sync_with_stdio(false);
    cout.tie(0)->sync_with_stdio(false);
    int t = 1; // cin >> t;
    while (t-- > 0) {
        solve();
        cout << '\n';
    }
    return 0;
}
