#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <utility>
#include <math.h>
#include <queue>
#include <fstream>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")

using namespace std;
using ll = long long;
using ld = long double;
const ll mod = 998244353;
const ll mx = 1e10;
const ld pog = 1e-12;

vector <pair<ll, ll> > tree1;
vector <ll> tree2;
ll sz1, sz2;

void init(ll n, vector <ll>& a) {
    sz1 = 1;
    while (sz1 < n) sz1 *= 2;
    sz2 = sz1;
    tree1.clear();
    tree2.clear();
    tree1.resize(sz1 * 2, { mx, -1 });
    tree2.resize(sz2 * 2, 0);
    for (int i = 0; i < a.size(); i++) {
        tree1[i + sz1] = { a[i], i };
    }
    
    for (int i = sz1 - 1; i > 0; i--) {
        if (tree1[i * 2].first <= tree1[i * 2 + 1].first) tree1[i] = tree1[i * 2];
        else tree1[i] = tree1[i * 2 + 1];
    }
}

pair<ll, ll> mn(ll v, ll tl, ll tr, ll l, ll r) {
    if (r < tl || l > tr) return { mx, -1 };
    if (tl == l && tr == r) return tree1[v];
    ll mid = (tl + tr) / 2;
    pair <ll, ll> p1 = mn(v * 2, tl, mid, l, min(mid, r));
    pair <ll, ll> p2 = mn(v * 2 + 1, mid+1, tr, max(mid+1, l), r);
    if (p1.first < p2.first) return p1;
    else if (p1.first == p2.first && p1.second < p2.second) return p1;
    else return p2;
}

void rebuild1(ll x) {
    ll v = sz2 + x;
    while (v > 0) {
        tree2[v]++;
        v /= 2;
    }
}

void rebuild2(ll v, ll tl, ll tr, ll l, ll r) {
    if (r < tl || l > tr) return;
    if (tl == l && tr == r) {
        tree1[v] = { mx, -1 };
        return;
    }
    ll mid = (tl + tr) / 2;
    rebuild2(v * 2, tl, mid, l, min(mid, r));
    rebuild2(v * 2 + 1, mid + 1, tr, max(mid + 1, l), r);
    if (tree1[v * 2].first <= tree1[v * 2 + 1].first) tree1[v] = tree1[v * 2];
    else tree1[v] = tree1[v * 2 + 1];
}

ll sm(ll v, ll tl, ll tr, ll l, ll r) {
    if (l > tr || r < tl) return 0;
    if (tl == l && tr == r) return tree2[v];
    ll mid = (tl + tr) / 2;
    ll s1 = sm(v * 2, tl, mid, l, min(mid, r));
    ll s2 = sm(v * 2 + 1, mid + 1, tr, max(l, mid + 1), r);
    return s1 + s2;
}

void solve() {
    ll i, k, n, l, r, mid, ind;
    string s;
    cin >> s >> k;
    n = s.size();
    vector <ll> a(n);
    for (i = 0; i < n; i++) a[i] = s[i] - '0';
    init(n, a);
    vector <ll> ans;
    vector <ll> used(n);

    for (i = 0; i < n; i++) {
        l = -1;
        r = n;
        while (r - l > 1) {
            mid = (l + r) / 2;
            ind = mid - sm(1, 0, sz2 - 1, 0, mid - 1);
            if (ind <= k) l = mid;
            else r = mid;
        }
        r = l;
        pair <ll, ll> x = mn(1, 0, sz1 - 1, 0, r);
        rebuild1(x.second);
        rebuild2(1, 0, sz1 - 1, x.second, x.second);
        used[x.second] = 1;
        ans.push_back(x.first);
        k -= x.second - sm(1, 0, sz2 - 1, 0, x.second - 1);
        if (k == 0) break;
    }
    for (i = 0; i < n; i++) {
        if (used[i] == 0) ans.push_back(a[i]);
    }
    for (i = 0; i < n; i++) {
        cout << ans[i];
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    ll t = 1;
    cin >> t;
    while (t--) solve();
}