#include <algorithm>
#include <array>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

using ll = long long;

vector<array<bool, 7>> digit_to_bits = {
        {1, 1, 1, 0, 1, 1, 1}, {0, 0, 1, 0, 0, 1, 0}, {1, 0, 1, 1, 1, 0, 1},
        {1, 0, 1, 1, 0, 1, 1}, {0, 1, 1, 1, 0, 1, 0}, {1, 1, 0, 1, 0, 1, 1},
        {1, 1, 0, 1, 1, 1, 1}, {1, 0, 1, 0, 0, 1, 0}, {1, 1, 1, 1, 1, 1, 1},
        {1, 1, 1, 1, 0, 1, 1}};

map<array<bool, 7>, int> get_bits_to_digit() {
    map<array<bool, 7>, int> result;
    for (int i = 0; i < 10; ++i) {
        result[digit_to_bits[i]] = i;
    }
    return result;
}

map<array<bool, 7>, int> bits_to_digit = get_bits_to_digit();

array<bool, 14> number_to_bits(int number) {
    array<bool, 14> result;
    if (number / 10 == 0) {
        fill(result.begin(), result.begin() + 7, 0);
    } else {
        array<bool, 7> bits = digit_to_bits[number / 10];
        for (int i = 0; i < 7; ++i) {
            result[i] = bits[i];
        }
    }
    array<bool, 7> bits = digit_to_bits[number % 10];
    for (int i = 0; i < 7; ++i) {
        result[i + 7] = bits[i];
    }
    return result;
}

int bits_to_number(array<bool, 14> bits) {
    int result = 0;
    array<bool, 7> bits1, bits2;
    copy(bits.begin(), bits.begin() + 7, bits1.begin());
    copy(bits.begin() + 7, bits.begin() + 14, bits2.begin());
    if (bits_to_digit.count(bits1) && bits_to_digit[bits1] != 0) {
        result += bits_to_digit[bits1] * 10;
    } else {
        for (int i = 0; i < 7; ++i) {
            if (bits1[i]) {
                return -1;
            }
        }
    }
    if (bits_to_digit.count(bits2)) {
        result += bits_to_digit[bits2];
    } else {
        return -1;
    }
    return result;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    string s1, s2;
    cin >> s1 >> s2;
    array<bool, 14> bits;
    for (int i = 0; i < 7; ++i) {
        bits[i] = s1[i] == '1';
        bits[i + 7] = s2[i] == '1';
    }
    int prev_number = -1;
    int cnt = 0;
    int mx = 0;
    for (int i = 99; i > 0; --i) {
        array<bool, 14> cur_bits = number_to_bits(i);
        for (int i = 0; i < 14; ++i) {
            cur_bits[i] &= bits[i];
        }
        int cur_number = bits_to_number(cur_bits);
        if (cur_number == prev_number + 1) {
            ++cnt;
            mx = max(cnt, mx);
        } else {
            cnt = 0;
        }
        prev_number = cur_number;
    }
    cout << mx << endl;
    return 0;
}
