#include <algorithm>
#include <array>
#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

#define INF 1'000'000'000'000'000ll

void dfs(int v, const vector<vector<int>> &adj,
         const vector<vector<ll>> &old_mat, vector<vector<ll>> &mat, int from,
         ll dist, int prev) {
    mat[from][v] = dist;
    for (int u : adj[v]) {
        if (u != prev)
            dfs(u, adj, old_mat, mat, from, dist + old_mat[v][u], v);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    vector<vector<ll>> mat(n);
    for (int i = 0; i < n; ++i) {
        mat[i] = vector<ll>(n);
        for (int j = 0; j < n; ++j) {
            cin >> mat[i][j];
        }
    }
    vector<ll> dist(n, INF);
    vector<int> prev(n, -1);
    dist[0] = 0;
    vector<bool> in_tree(n, false);
    vector<vector<int>> adj(n);
    for (int i = 0; i < n; ++i) {
        ll d = INF;
        int v = -1;
        for (int j = 0; j < n; ++j) {
            if (dist[j] < d) {
                d = dist[j];
                v = j;
            }
        }
        in_tree[v] = true;
        dist[v] = INF;
        if (i != 0) {
            adj[v].push_back(prev[v]);
            adj[prev[v]].push_back(v);
        }
        for (int j = 0; j < n; ++j) {
            if (!in_tree[j] && mat[i][j] < dist[j]) {
                dist[j] = mat[v][j];
                prev[j] = v;
            }
        }
    }
    vector<vector<ll>> new_mat(n);
    for (int i = 0; i < n; ++i) {
        new_mat[i] = vector<ll>(n);
        dfs(i, adj, mat, new_mat, i, 0, -1);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (mat[i][j] != new_mat[i][j]) {
                cout << "No" << endl;
                return 0;
            }
        }
    }
    cout << "Yes" << endl;
    return 0;
}
