#include <bits/stdc++.h>
#include <vector>

using namespace std;
using i64 = int64_t;
using ll = int64_t;

#define all(x) x.begin(), x.end()

struct DSU {
    vector<int> p;
    DSU(int n) : p(n) {
        iota(all(p), 0);
    }
    
    int get_parent(int v) {
        if (p[v] == v) return v;
        return p[v] = get_parent(p[v]);
    }
 
    bool is_joined(int v, int u) {
        return get_parent(v) == get_parent(u);
    }
 
    void join(int v, int u) {
        if (!is_joined(v, u)) {
            p[get_parent(u)] = v;
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector m(n, vector<i64>(n));
    vector<tuple<int, int, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int w;
            cin >> w;
            m[i][j] = w;
            if (i <= j) continue;
            edges.push_back({ w, i, j });
        }
    }

    DSU dsu(n);
    vector<vector<pair<int, int>>> g(n);
    sort(all(edges));
    for (auto [w, v, u] : edges) {
        if (dsu.is_joined(v, u)) { continue; }
        dsu.join(v, u);
        g[v].push_back({ u, w });
        g[u].push_back({ v, w });
    }

    auto dfs_dist = [&](int v) -> vector<i64> {
        vector<i64> d(n);
        auto dfs = [&](int v, int p, i64 sum, auto& dfs) -> void {
            d[v] = sum;
            for (auto [u, w] : g[v]) {
                if (u == p) continue;
                dfs(u, v, sum + w, dfs);
            }
        };

        dfs(v, -1, 0, dfs);
        return d;
    };

    for (int i = 0; i < n; ++i) {
        auto d = dfs_dist(i);
        if (m[i] != d) {
            cout << "No"; return 0;
        }
    }
    cout << "Yes";

    return 0;
}



















