#include <ctime>
#include <iostream>
#include <random>
#include <vector>
#include <map>
#define ll long long

using namespace std;

constexpr ll MOD = 998'244'353;

std::mt19937_64 rnd(time(0));
constexpr ll N = 200005;

ll fact[N], infact[N];

ll binpow(ll h, ll r) {
  ll l = 1;
  while (r) {
    if (r & 1) {
      l = l * h % MOD;
    }
    h = h * h % MOD;
    r /= 2;
  }
  return l;
}

std::map<pair<pair<ll ,ll>, bool>, ll> mm;

ll get_ans(ll n, ll k, bool f) {
  if (mm[{{n, k}, f}]) {
    return mm[{{n, k}, f}];
  }
  if (n == 1) {
    // cerr << n << " " << k << " " << f << " " << 0 << endl;
    return 0;
  }
  if (f == true) {
    if (k < 1) {
      // cerr << n << " " << k << " " << f << " " << 1e18 << endl;
      return 1e18;
    }
    ll left1 = get_ans(n / 2, k, true);
    ll right1 = get_ans((n + 1) / 2, k - 1, false);
    ll left2 = get_ans((n + 1) / 2, k, true);
    ll right2 = get_ans(n / 2, k - 1, false);
    // cerr << n << " " << k << " " << f << " : " << left <<" " << right << " " << 1 + max(left, right) << endl;
    mm[{{n, k}, f}] = 1 + min(max(left1, right1), max(left2, right2));
    return mm[{{n, k}, f}];
  } else {
    ll left1 = get_ans(n / 2, k, true);
    ll right1 = get_ans((n + 1) / 2, k, false);
    ll left2 = get_ans((n + 1) / 2, k, true);
    ll right2 = get_ans(n / 2, k, false);
    // cerr << n << " " << k << " " << f << " " << 1 + max(left, right) << endl;
    mm[{{n, k}, f}] = 1 + min(max(left1, right1), max(left2, right2));
    return mm[{{n, k}, f}];
  }
}

void solve() {
  ll n, k;
  cin >> n >> k;
  if (get_ans(n, k, true) == 1e18) {
    while (min(n, k) <= max(n, k)) {
      k++;
    }
  }
  cout << get_ans(n, k, true) << endl;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  ll t = 1;
  cin >> t;
  while (t--) {
    solve();
  }
}

/*
 */