#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF64 = 1e18;

struct TSegmentTree {
    vector<pair<int, int>> t;
    int sz;

    void build(int v, int l, int r, vector<int>& a) {
        if (r - l == 1) {
            if (l < a.size()) {
                t[v] = {a[l], l};
            }

            return;
        }

        int mid = (l + r) >> 1;

        build(v << 1, l, mid, a);
        build(v << 1 | 1, mid, r, a);

        t[v] = min(t[v << 1], t[v << 1 | 1]);
    }

    TSegmentTree(vector<int>& a) {
        sz = 1;
        while (sz < a.size()) {
            sz <<= 1;
        }

        t.resize(sz << 1, {INF64, -1});
        build(1, 0, sz, a);
    }

    pair<int, int> get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return {INF64, -1};
        }

        if (ql <= l && r <= qr) {
            return t[v];
        }

        int mid = (l + r) >> 1;

        return min(get(v << 1, l, mid, ql, qr), get(v << 1 | 1, mid, r, ql, qr));
    }

    void upd(int v, int l, int r, int k, int x) {
        if (r - l == 1) {
            t[v].first = x;
            return;
        }

        int mid = (l + r) >> 1;

        if (k < mid) {
            upd(v << 1, l, mid, k, x);
        } else {
            upd(v << 1 | 1, mid, r, k, x);
        }

        t[v] = min(t[v << 1], t[v << 1 | 1]);
    }

    pair<int, int> get(int l, int r) {
        return get(1, 0, sz, l, r + 1);
    }

    void upd(int i, int x) {
        upd(1, 0, sz, i, x);
    }
};

void solve(int cntTest) {
    string s;
    cin >> s;
    int k; cin >> k;

    string result = "";

    vector<int> a(s.size());

    for (int i = 0; i < a.size(); i++) {
        a[i] = s[i] - '0';
    }

    TSegmentTree t(a);

    while (k > 0 && result.size() < s.size()) {
        int l = result.size();
        int r = min<int>(s.size() - 1, l + k);
        auto mn = t.get(l, r);
        int i = mn.second;
        k -= (i - l);
        result.push_back(mn.first + '0');
        t.upd(i, INF64);
    }

    for (int j = 0; j < s.size(); j++) {
        auto kek = t.get(j, j);
        if (kek.first != INF64) {
            result.push_back(kek.first + '0');
        }
    }

    cout << result << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed << setprecision(10);

    // freopen("input.txt", "r", stdin);

    int cntTest = 1;
    cin >> cntTest;

    for (int i = 1; i <= cntTest; i++) {
        solve(i);
    }
}
