#include <bits/stdc++.h>

using namespace std;

#define int long long

class TDsu {
    vector<int> p;
    vector<int> sz;

    int getSet(int v) {
        return p[v] = (p[v] == v ? v : getSet(p[v]));
    }

    void makeSet(int v) {
        p[v] = v;
        sz[v] = 1;
    }

public:
    bool unionSets(int u, int v) {
        u = getSet(u);
        v = getSet(v);

        if (u == v) {
            return false;
        }

        if (sz[u] > sz[v]) {
            swap(u, v);
        }

        sz[v] += sz[u];
        p[u] = v;

        return true;
    }

    TDsu(int n) {
        p.resize(n);
        sz.resize(n);

        for (int v = 0; v < n; v++) {
            makeSet(v);
        }
    }
};

void solve(int cntTest) {
    int n; cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    vector<tuple<int, int, int>> edges;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            if (i < j) {
                edges.push_back({a[i][j], i, j});
            }
        }
    }

    sort(edges.begin(), edges.end());

    TDsu dsu(n);
    vector<vector<pair<int, int>>> g(n);

    for (auto [w, u, v] : edges) {
        bool kek = dsu.unionSets(u, v);
        
        if (kek) {
            g[v].push_back({w, u});
            g[u].push_back({w, v});
        }
    }

    function<void(int, vector<int>&, int, int)> go;
    go = [&](int v, vector<int>& a, int p, int now) -> void {
        a[v] = now;

        for (auto [w, u] : g[v]) {
            if (u != p) {
                go(u, a, v, now + w);
            }
        }
    };

    vector<vector<int>> lol(n, vector<int>(n));

    for (int v = 0; v < n; v++) {
        go(v, lol[v], -1, 0);
    }

    if (lol == a) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed << setprecision(10);

    // freopen("input.txt", "r", stdin);

    int cntTest = 1;
    // cin >> cntTest;

    for (int i = 1; i <= cntTest; i++) {
        solve(i);
    }
}
