// clang-format off
#include <iostream>
#include <vector>
#include <map>
#include <cassert>
#pragma GCC optimize("O3,Ofast")
// clang-format on

long long get_real_num(
    long long num,
    const std::vector<long long> &num_to_look,
    long long maskl,
    long long maskr,
    std::map<long long, long long> &look_to_num
) {
    long long l = num / 10;
    long long r = num % 10;
    long long lnew = num_to_look[l] & maskl;
    long long rnew = num_to_look[r] & maskr;
    if (l == 0) {
        if (look_to_num.count(rnew) == 1) {
            return look_to_num[rnew];
        }
        return 100;
    } else {
        if (lnew == 0 && look_to_num.count(rnew) == 1) {
            return look_to_num[rnew];
        } else if (look_to_num.count(lnew) == 1 &&
                   look_to_num.count(rnew) == 1) {
            if (look_to_num[lnew] == 0) {
                return 100;
            }
            return 10 * look_to_num[lnew] + look_to_num[rnew];
        }
        return 100;
    }
    assert(false);
}

void solve() {
    std::vector<long long> num_to_look = {
        0b1110111, 0b0010010, 0b1011101, 0b1011011, 0b0111010,
        0b1101011, 0b1101111, 0b1010010, 0b1111111, 0b1111011,
    };
    std::map<long long, long long> look_to_num;
    long long maskl = 0;
    long long maskr = 0;
    for (long long i = 0; i < 10; ++i) {
        look_to_num[num_to_look[i]] = i;
    }
    for (long long i = 0; i < 7; ++i) {
        char ok1;
        std::cin >> ok1;
        maskl |= ((ok1 == '1') << (6 - i));
    }
    for (long long i = 0; i < 7; ++i) {
        char ok2;
        std::cin >> ok2;
        maskr |= ((ok2 == '1') << (6 - i));
    }

    long long k = 0;
    long long cur = 0;
    long long last = get_real_num(99, num_to_look, maskl, maskr, look_to_num);
    for (long long i = 98; i > 0; --i) {
        long long next =
            get_real_num(i, num_to_look, maskl, maskr, look_to_num);
        if (next == last + 1) {
            ++cur;
            if (k < cur) {
                k = cur;
            }
        } else {
            cur = 0;
        }
        last = next;
    }

    std::cout << k << '\n';
}

int main() {
    solve();
}
