#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <utility>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
#include <bitset>
#include <cassert>
#include <functional>
#include <numeric>

using namespace std;

#define ll long long
#define uint unsigned int
#define ld long double
#define X first
#define Y second
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define vii vector<pair<int, int>>
#define vvi vector<vector<int>>
#define INF INT_MAX
// #define int long long

map<int, set<int>> sign_to_led {
        {0, {1, 2, 3, 5, 6, 7}},
        {1, {3, 6}},
        {2, {1, 3, 4, 5, 7}},
        {3, {1, 3, 4, 6, 7}},
        {4, {2, 3, 4, 6}},
        {5, {1, 2, 4, 6, 7}},
        {6, {1, 2, 4, 5, 6, 7}},
        {7, {1, 3, 6}},
        {8, {1, 2, 3, 4, 5, 6, 7}},
        {9, {1, 2, 3, 4, 6, 7}}
};
map<set<int>, int> led_to_sign {
        {{1, 2, 3, 5, 6, 7}, 1},
        {{3, 6}, 2},
        {{1, 3, 4, 5, 7}, 3},
        {{1, 3, 4, 6, 7}, 4},
        {{2, 3, 4, 6}, 5},
        {{1, 2, 4, 6, 7}, 6},
        {{1, 2, 4, 5, 6, 7}, 7},
        {{1, 3, 6}, 8},
        {{1, 2, 3, 4, 5, 6, 7}, 9},
        {{1, 2, 3, 4, 6, 7}, 10}
};

bool check(int sign, const set<int> &broken) {
    auto &leds = sign_to_led[sign];
    for (auto i: broken)
        if (leds.find(i) != leds.end())
            return false;
    return true;
}

set<int> fst, snd;

int convert(int y) {
    int a = y / 10;
    int b = y % 10;

    set<int> f = sign_to_led[a], s = sign_to_led[b];
    for (auto i: fst)
        f.erase(i);
    for (auto i: snd)
        s.erase(i);

    int A = led_to_sign[f] - 1;
    int B = led_to_sign[s] - 1;

    if (a == 0) {
        return B;
    }
    if (A == -1 || B == -1)
        return -1;
    return A * 10 + B;
}

int solve() {
    vector<int> numbers(100);
    for (int i = 0; i < 100; ++i)
        numbers[i] = convert(i);
    int ans = 0;
    int cur = 1;
    for (int i = 2; i < 100; ++i) {
        if (numbers[i] != -1 && numbers[i - 1] != -1 && numbers[i] == numbers[i - 1] - 1)
            ++cur;
        else {
            ans = max(ans, cur);
            cur = 1;
        }
    }
    return ans - 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int N = 7;
    for (int i = 1; i <= N; ++i) {
        char c;
        cin >> c;
        if (c == '0')
            fst.insert(i);
    }
    for (int i = 1; i <= N; ++i) {
        char c;
        cin >> c;
        if (c == '0')
            snd.insert(i);
    }

    cout << solve();

    return 0;
}
