#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <compare>
#include <complex>
#include <cstddef>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <limits>
#include <map>
#include <math.h>
#include <numeric>
#include <queue>
#include <random>
#include <regex>
#include <sstream>
#include <stack>
#include <string>
#include <string_view>
#include <thread>
#include <unistd.h>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>
// #include "json.hpp" // lib for json, dont forget to coment on contests
// #include <curl/curl.h> // lib for curl, dont forget to coment on contests
// #include <bit>
// #include "optimization.h"

// using json = nlohmann::json; // namespace for json, dont forget to coment on
// contests
using namespace std;
using namespace __gnu_pbds;
// #define int long long
#define ld long double

// #define FAST_ALLOCATOR_MEMORY 1e8
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

typedef tree<pair<int, int>, null_type, less<>, rb_tree_tag,
             tree_order_statistics_node_update>
    ordered_set;

const int INF = 1e18 + 7;
const int inf = 1e9 + 7;
const int MOD1 = 1e9 + 9;
const int P = 31;
const int P1 = 43;
const int MOD = 1e9 + 7;
const ld PI = acosl(-1);
const ld EPS = 1e-9;

const int MAX_BITSET = 123;

struct Dsu {
    vector<int> pr;

    Dsu(int n) : pr(n) { iota(pr.begin(), pr.end(), 0); }

    int get(int x) {
        if (pr[x] == x) {
            return x;
        }

        return pr[x] = get(pr[x]);
    }

    void union_set(int x, int y) {
        x = get(x);
        y = get(y);

        pr[x] = y;
    }
};

void dfs(int s, int f, int n, vector<vector<pair<int, int>>> &mst,
         vector<vector<int>> &dists, vector<int> used, int sm = 0) {
    used[f] = 1;
    dists[s][f] = sm;

    for (const auto &i : mst[f]) {
        if (used[i.second]) {
            continue;
        }

        dfs(s, i.second, n, mst, dists, used, sm + i.first);
    }
}

void solve() {
    int n;
    cin >> n;

    struct Edge {
        int d;
        int x;
        int y;

        Edge(int nd, int nx, int ny) : d(nd), x(nx), y(ny) {}
    };

    vector<vector<int>> matrix(n, vector<int>(n));
    vector<Edge> edges;
    edges.reserve(n * n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matrix[i][j];
            edges.emplace_back(Edge(matrix[i][j], i, j));
        }
    }

    sort(edges.begin(), edges.end(), [](Edge a, Edge b) {
        if (a.d == b.d) {
            if (a.x == b.x) {
                return a.y < b.y;
            }
            return a.x < b.x;
        }
        return a.d < b.d;
    });

    Dsu dsu(n);

    vector<vector<pair<int, int>>> mst(n);

    for (const auto &edge : edges) {
        if (dsu.get(edge.x) != dsu.get(edge.y)) {
            mst[edge.x].emplace_back(edge.d, edge.y);
            mst[edge.y].emplace_back(edge.d, edge.x);
            dsu.union_set(edge.x, edge.y);
        }
    }

    vector<vector<int>> dists(n, vector<int>(n));

    vector<int> used(n);
    for (int i = 0; i < n; i++) {
        fill(used.begin(), used.end(), 0);
        dfs(i, i, n, mst, dists, used);
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (dists[i][j] != matrix[i][j]) {
                cout << "No" << '\n';
                return;
            }
        }
    }

    cout << "Yes" << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    int t = 1;
    // cin >> t;
    //      t = readInt();
    while (t--) {
        solve();
        // solve1();
    }

    // while (!isEof()) {
    //     solve();
    // }

    return 0;
}