﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>  

using namespace std;

#define int long long

unsigned long long randU()
{
	unsigned long long res = rand();
	for (int i = 0;i < 4; i++)
		res = (res << 15) + rand();
	return res;
}


template<typename T>
void shuffle(vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		swap(v[i], v[randU() % v.size()]);
}

template<typename T>
class SparceTable
{
private:
	vector<vector<T>> table;
	T(*function)(const T& a, const T& b);
public:
	SparceTable() {}
	SparceTable(vector<T>& v, T(*f)(const T& a, const T& b)) : function(f)
	{
		build(v, f);
	}
	void build(vector<T>& v, T(*f)(const T& a, const T& b))
	{
		function = f;
		table.resize(log2(v.size()) + 1);
		for (int i = 0; i < v.size(); i++)
			table[0].push_back(v[i]);
		for (int j = 1; j < table.size(); j++)
			for (int i = 0; i <= v.size() - (1 << j); i++)
				table[j].push_back(function(table[j - 1][i], table[j - 1][i + (1 << (j - 1))]));
	}
	T get(int l, int r)
	{
		int ind = log2(r - l);
		return function(table[ind][l], table[ind][r - (1 << ind)]);
	}
};

template<typename T>
T fmin(const T& a, const T& b)
{
	return min(a, b);
}

void _69()
{
	string a;
	cin >> a;
	if (a == "{}")
	{
		cout << 0 << '\n';
		return;
	}
	int c = 0;
	int m = 0;
	for (auto& i : a)
	{
		if (i == '{')
			c++;
		else if (i == '}')
			c--;
		m = max(m, c);
	}
	cout << m - 1 << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int t = 1;
	//cin >> t;
	while (t--)
		_69();
}