#include <iostream>
#include <vector>
#include <string>
#include <limits.h>
#include <algorithm>

using namespace std;

#define int long long


class Korn {
private:
    int C = 317;
    int l = 0;
    vector<vector<char> > m;
    vector<int> pcm;
    int getroughminpos(vector<char>& v, int r) {
        int res = 0;
        for (int i = 1; i < r; i++)
            if (v[i] < v[res])
                res = i;
        return res;
    }

    void erase(vector<char>& v, int ind) {
        for (int i = ind; i < v.size() - 1; i++)
            swap(v[i], v[i + 1]);
        v.pop_back();
    }

public:
    Korn(vector<char>& v, int c) : C(c) {
        m.resize(v.size() / C + 5);
        l = v.size();
        for (int i = 0; i < v.size(); i++)
            m[i / C].push_back(v[i]);
        pcm.resize(m.size());
        for (int i = 0; i < pcm.size(); i++) {
            pcm[i] = 0;
            for (int j = 0; j < m[i].size(); j++)
                if (m[i][j] < m[i][pcm[i]])
                    pcm[i] = j;
        }
    }

    pair<char, int> getminpos(int r) {
        pair<char, int> res = { '9' + 1, 1e9 };
        int sum = 0;
        for (int i = 0; i < m.size(); i++) {
            if (m[i].size() == 0)
                continue;
            if (sum + m[i].size() > r) {
                int ind = getroughminpos(m[i], r - sum);
                res = min(res, { m[i][ind], sum + ind });
                return res;
            }
            else if (sum + m[i].size() == r) {
                int ind = getroughminpos(m[i], m[i].size());
                res = min(res, { m[i][ind], sum + ind });
                return res;
            }
            else {
                res = min(res, { m[i][pcm[i]], sum + pcm[i] });
                sum += m[i].size();
            }
        }
        return res;
    }

    void erase(int ind) {
        int i = 0;
        l--;
        while (ind >= m[i].size()) {
            ind -= m[i].size();
            i++;
        }
        erase(m[i], ind);
        pcm[i] = getroughminpos(m[i], m[i].size());
    }

    int size() {
        return l;
    }

    void print(string& a) {
        for (auto& i : m)
            for (auto& j : i)
                a.push_back(j);
    }
};

string _69$(string a, int k) {
    if (!k)
        return a;
    vector<char> b;
    for (auto& i : a)
        b.push_back(i);
    Korn korn(b, 369);
    string res;
    while (k > 0 && korn.size()) {
        auto c = korn.getminpos(min(k + 1, korn.size()));
        res.push_back(c.first);
        korn.erase(c.second);
        k -= c.second;
    }
    korn.print(res);
    return res;
}

typedef long long ll;
typedef unsigned long long ull;

string solution(string s, int k) {
    ll n = s.length();

    for (int i = 0; i < n; ++i) {
        if (k <= 0) break;

        int minIndex = i;
        for (int j = i + 1; j < min(n, i + k + 1); ++j) {
            if (s[j] < s[minIndex]) {
                minIndex = j;
            }
        }

        if (minIndex != i) {
            int moves = minIndex - i;

            char minChar = s[minIndex];
            for (int j = minIndex; j > i; --j) {
                s[j] = s[j - 1];
            }
            s[i] = minChar;
            k -= moves;
        }
    }

    return s;
}

void test() {
    int size = 5, k = rand();
    string a;
    for (int i = 0; i < size; i++)
        a.push_back(rand() % 10 + '0');
    string c = _69$(a, k), r = solution(a, k);
    if (c != r) {
        cout << a << ' ' << k << '\n' << c << '\n' << r << '\n' << '\n' << _69$(a, k) << '\n';
        exit(0);
    }
    else
        cout << "OK\n";
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        string a;
        int k;
        cin >> a >> k;

        cout << _69$(a, k) << '\n';
    }
    return 0;
}
