﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>  

using namespace std;

#define int long long

unsigned long long randU()
{
	unsigned long long res = rand();
	for (int i = 0;i < 4; i++)
		res = (res << 15) + rand();
	return res;
}


template<typename T>
void shuffle(vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		swap(v[i], v[randU() % v.size()]);
}

template<typename T>
class SparceTable
{
private:
	vector<vector<T>> table;
	T(*function)(const T& a, const T& b);
public:
	SparceTable() {}
	SparceTable(vector<T>& v, T(*f)(const T& a, const T& b)) : function(f)
	{
		build(v, f);
	}
	void build(vector<T>& v, T(*f)(const T& a, const T& b))
	{
		function = f;
		table.resize(log2(v.size()) + 1);
		for (int i = 0; i < v.size(); i++)
			table[0].push_back(v[i]);
		for (int j = 1; j < table.size(); j++)
			for (int i = 0; i <= v.size() - (1 << j); i++)
				table[j].push_back(function(table[j - 1][i], table[j - 1][i + (1 << (j - 1))]));
	}
	T get(int l, int r)
	{
		int ind = log2(r - l);
		return function(table[ind][l], table[ind][r - (1 << ind)]);
	}
};

template<typename T>
T fmin(const T& a, const T& b)
{
	return min(a, b);
}

void _69()
{
	string a;
	cin >> a;
	if (a == "{}")
	{
		cout << 0 << '\n';
		return;
	}
	int c = 0;
	int m = 0;
	for (auto& i : a)
	{
		if (i == '{')
			c++;
		else if (i == '}')
			c--;
		m = max(m, c);
	}
	cout << m - 1 << '\n';
}

void dfs(int v, vector<vector<int>>& matr, vector<int>& d, vector<bool>& used, int cd = 0)
{
	if (used[v])
		return;
	used[v] = true;
	d[v] = cd;
	for (auto& i : matr[v])
	{
		if (used[i])
			continue;
		dfs(i, matr, d, used, cd + 1);
	}
}

class ST
{
private:
	int size;
	vector<int> t;
	int gcd(int a, int b)
	{
		a = llabs(a);
		b = llabs(b);
		while (a && b)
		{
			a %= b;
			swap(a, b);
		}
		return a + b;
	}
	int get(int l, int r, int ql, int qr, int ind)
	{
		if (l >= qr || ql >= r)
			return 0;
		if (l >= ql && r <= qr)
			return t[ind];
		int m = (l + r) / 2;
		return gcd(get(l, m, ql, qr, ind * 2), get(m, r, ql, qr, ind * 2 + 1));
	}
public:
	ST(vector<int>& v)
	{
		for (size = 1; size < v.size(); size <<= 1);
		t.resize(size * 2, 0);
		for (int i = 0; i < v.size(); i++)
			t[i + size] = v[i];
		for (int i = size - 1; i; i--)
			t[i] = gcd(t[i * 2], t[i * 2 + 1]);
	}
	int get(int l, int r)
	{
		int a = get(0, size, l, r, 1);
		if (a)
			return a;
		return 69;
	}
};

signed main()
{
	int size;
	cin >> size;
	vector<int> v(size);
	for (auto& i : v)
		cin >> i;
	vector<int> d(size);
	d[0] = 0;
	for (int i = 1; i < size; i++)
		d[i] = v[i] - v[i - 1];
	ST t(d);
	int s, f;
	cin >> s >> f;
	s--;
	f--;
	for (int i = min(s, f); i < max(s, f); i++)
	{
		if (abs(v[i] - v[i + 1]) == 1)
		{
			cout << "Impossible\n";
			return 0;
		}
	}
	while (s < f)
	{
		int l = s, r = f + 2;
		while (r - l > 1)
		{
			int m = (l + r) / 2;
			if (t.get(s + 1, m) != 1)
				l = m;
			else
				r = m;
		}
		cout << "Kaban-" << t.get(s + 1, l) << ' ' << s + 1 << ' ' << l << '\n';
		s = l - 1;
	}
	reverse(v.begin(), v.end());
	d[0] = 0;
	for (int i = 1; i < size; i++)
		d[i] = v[i] - v[i - 1];
	t = ST(d);
	s = size - 1 - s;
	f = size - 1 - f;
	while (s < f)
	{
		int l = s, r = f + 2;
		while (r - l > 1)
		{
			int m = (l + r) / 2;
			if (t.get(s + 1, m) != 1)
				l = m;
			else
				r = m;
		}
		cout << "Kaban-" << t.get(s + 1, l) << ' ' << size - s << ' ' << size - l + 1 << '\n';
		s = l - 1;
	}

}