#include <bits/stdc++.h>

//namespace std {
//    std::ifstream input_file("rmq.in");
//    std::ofstream out_file("rmq.out");
//
//#define cin input_file
//#define cout out_file
//}

namespace tools {

    template<typename T>
    using vec = std::vector<T>;
    template<typename T>
    using mat = std::vector<std::vector<T>>;
    using str = std::string;
    using i64 = long long int;
    using u64 = unsigned long long int;
    using f64 = long double;

    static void fastIO() {
        std::ios_base::sync_with_stdio(false);
        std::cout.tie(nullptr);
        std::cin.tie(nullptr);
        std::cout.precision(12);
        std::fixed(std::cout);
    }

    template<typename T>
    auto& operator>>(std::istream& in, std::vector<T>& a) {
        for (T& elem: a) in >> elem; return in;
    }

    template<typename T>
    auto& operator<<(std::ostream& out, std::vector<T> const& a) {
        for (T const& elem: a) out << elem << ' '; return out;
    }


    std::mt19937_64 rn(std::chrono::steady_clock::now().time_since_epoch().count());
//    std::mt19937_64 rn(4);

} // namespace tools

using namespace tools;
//using namespace std;
using std::cin, std::cout, std::endl;

#define endl '\n'

void solver();

int32_t main() {
    fastIO();

    int T = 1;
//    cin >> T;

    while (T--) {
        solver();
    }
}

class DSU {
    vec<int> body;
    vec<int> rang;

public:
    DSU(int n) {
        body = vec<int>(n);
        rang = vec<int>(n, 0);

        for (int i = 0; i < n; ++i) {
            body[i] = i;
        }
    }

    int get(int i) {
        return body[i] = (i == body[i] ? i : get(body[i]));
    }

    bool get(int a, int b) {
        return get(a) == get(b);
    }

    void unite(int a, int b) {
        a = get(a); b = get(b);
        if (rang[a] == rang[b]) {
            rang[a]++;
        }
        if (rang[a] > rang[b]) {
            body[b] = a;
        } else {
            body[a] = b;
        }
    }
};

struct edge {
    i64 cost;
    int i;
    int j;

    bool operator<(const edge& other) const {
        return (cost < other.cost) || (cost == other.cost && i < other.i) || (cost == other.cost && i == other.i && j < other.j);
    }

};

void solver() {
    int n; cin >> n;
    vec<int> G(n * n, 0);
    vec<edge> ed;
    ed.reserve(n * (n - 1) / 2);
    DSU dsu(n);

#define ind(i, j) n * i + j

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> G[ind(i, j)];
            if (i > j) {
                ed.push_back({G[ind(i, j)], i, j});
            }
        }
    }

    vec<vec<std::pair<i64, int>>> nG(n);
    std::sort(ed.begin(), ed.end());

    for (auto [cost, i, j]: ed) {
        if (!dsu.get(i, j)) {
            dsu.unite(i, j);
            nG[i].emplace_back(cost, j);
            nG[j].emplace_back(cost, i);


        }
    }





}
