#include <iostream>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#define ll long long
#define ull unsigned long long

constexpr ll MAX_N = 131072;
ll* input_array;
std::pair<ll , ull> segment_tree[MAX_N * 4];

void build_tree(ll i, ll left, ll right) {
    if (right == left)
        segment_tree[i] = { input_array[right], right };
    else {
        ll mid = (right + left) / 2;
        build_tree(i * 2, left, mid);
        build_tree(i * 2 + 1, mid + 1, right);
        if (segment_tree[i * 2].first <= segment_tree[i * 2 + 1].first) {
            segment_tree[i] = segment_tree[i * 2];
        }
        else {
            segment_tree[i] = segment_tree[i * 2 + 1];
        }
    }
}

void update_tree(ll i, ll left, ll right, ll update_index, ll value) {
    if (right == left)
        segment_tree[i] = { value, right };
    else {
        ll mid = (right + left) / 2;
        if (update_index <= mid)
            update_tree(i * 2, left, mid, update_index, value);
        else
            update_tree(i * 2 + 1, mid + 1, right, update_index, value);


        if (segment_tree[i * 2].first <= segment_tree[i * 2 + 1].first) {
            segment_tree[i] = segment_tree[i * 2];
        }
        else {
            segment_tree[i] = segment_tree[i * 2 + 1];
        }
    }
}

ll get(ll v, ll tl, ll tr, ll pos) {
    if (tl == tr)
        return segment_tree[v].first;
    ll tm = (tl + tr) / 2;
    if (pos <= tm)
        return get(v * 2, tl, tm, pos);
    else
        return get(v * 2 + 1, tm + 1, tr, pos);
    return 0;
}

std::pair<ll,ull> minrange(ll i, ll left, ll right, ll input_left, ll input_right) {
    if (input_left > input_right)
        return { 10,1000007 };
    if (left == input_left && right == input_right)
        return segment_tree[i];
    ll mid = (left + right) / 2;
    auto left_son = minrange(i * 2, left, mid, input_left, std::min(mid, input_right));
    auto right_son = minrange(i * 2 + 1, mid + 1, right, std::max(mid + 1, input_left), input_right);
    if (left_son.first <= right_son.first) {
        return left_son;
    }
    else {
        return right_son;
    }
}
int compare(const void* a, const void* b)
{
    const char* x = (char*)a;
    const char* y = (char*)b;

    if (*x > *y)
        return 1;
    else if (*x < *y)
        return -1;

    return 0;
}

int main() {
    std::cin.tie(0);
    std::ios_base::sync_with_stdio(false);


    ll t;
    std::cin >> t;
    input_array = new ll[MAX_N]{};
    for (int ti = 0; ti < t; ti++) {

        ull k = 0;
        ll n = 0;
        char buf[131072]{};
        std::cin >> buf;
        std::cin >> k;
        n = std::strlen(buf);
        for (int i = 0; i < n; i++) {
            input_array[i] = buf[i] - '0';
        }


        build_tree(1, 0, n - 1);

        auto min = minrange(1, 0, n - 1, 1, n - 1);
        ull i = 0;
        auto l = get(1, 0, n - 1, 3);

        while (k > 0 && i < n) {
            while (get(1, 0, n - 1, i) <= min.first && i < min.second) i++;

            auto j = (ull)i;
            if(min.second >= k) j = std::max((ull)i, min.second - k);
            ll cycles = min.second - j;



            for (int a = j; a < min.second; a++) {
                auto pl = get(1, 0, n - 1, a);
                auto pl2 = get(1, 0, n - 1, min.second);
                update_tree(1, 0, n - 1, min.second, pl);
                update_tree(1, 0, n - 1, a, pl2);
            }

            k -= (cycles);
            i++;
            min = minrange(1, 0, n - 1, i + 1, n - 1);

        }
        for (int i = 0; i < n; i++) {
            std::cout << get(1, 0, n - 1, i);

        }
        std::cout << '\n';
    }
}
