#include <bits/stdc++.h>

//namespace std {
//    std::ifstream input_file("rmq.in");
//    std::ofstream out_file("rmq.out");
//
//#define cin input_file
//#define cout out_file
//}

namespace tools {

    template<typename T>
    using vec = std::vector<T>;
    template<typename T>
    using mat = std::vector<std::vector<T>>;
    using str = std::string;
    using i64 = long long int;
    using u64 = unsigned long long int;
    using f64 = long double;

    static void fastIO() {
        std::ios_base::sync_with_stdio(false);
        std::cout.tie(nullptr);
        std::cin.tie(nullptr);
        std::cout.precision(12);
        std::fixed(std::cout);
    }

    template<typename T>
    auto& operator>>(std::istream& in, std::vector<T>& a) {
        for (T& elem: a) in >> elem; return in;
    }

    template<typename T>
    auto& operator<<(std::ostream& out, std::vector<T> const& a) {
        for (T const& elem: a) out << elem << ' '; return out;
    }


    std::mt19937_64 rn(std::chrono::steady_clock::now().time_since_epoch().count());
//    std::mt19937_64 rn(4);

} // namespace tools

using namespace tools;
//using namespace std;
using std::cin, std::cout, std::endl;

#define endl '\n'

void solver();

int32_t main() {
    fastIO();

    int T = 1;
//    cin >> T;

    while (T--) {
        solver();
    }
}

class DSU {
    vec<int> body;
    vec<int> rang;

public:
    DSU(int n) {
        body = vec<int>(n);
        rang = vec<int>(n, 0);

        for (int i = 0; i < n; ++i) {
            body[i] = i;
        }
    }

    int get(int i) {
        return body[i] = (i == body[i] ? i : get(body[i]));
    }

    bool get(int a, int b) {
        return get(a) == get(b);
    }

    void unite(int a, int b) {
        a = get(a); b = get(b);
        if (rang[a] == rang[b]) {
            rang[a]++;
        }
        if (rang[a] > rang[b]) {
            body[b] = a;
        } else {
            body[a] = b;
        }
    }
};

void solver() {
    int n; cin >> n;
    vec<int> G(n * n, 0);
    DSU dsu(n);

#define ind(i, j) n * i + j

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> G[ind(i, j)];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            bool all_lower = true;
            for (int k = 0; k < n; ++k) {
                i64 oth = G[ind(i, k)] + G[ind(j, k)];
                if (oth == G[ind(i, j)]) {
                    all_lower = false;
                }
                if (oth < G[ind(i, j)]) {
                    cout << "No" << endl;
                    return;
                }
            }

            if (all_lower && dsu.get(i, j)) {
                cout << "No" << endl;
                return;
            } else {
                dsu.unite(i, j);
            }
        }
    }

    cout << "Yes" << endl;



}
