#include <bits/stdc++.h>

#define max2h 20
using namespace std;
using ll = long long;
using ld = long double;
const ll inf = 1e9;

void depth_dfs(ll v, ll p, const vector<vector<ll>>& children, vector<ll>& depth) {
    if (v == 0) {
        depth.resize(children.size(), 0);
    } else {
        depth[v] = depth[p] + 1;
    }
    for (ll to : children[v]) {
        depth_dfs(to, v, children, depth);
    }
}
void build_dp(const vector<ll>& parent, vector<vector<ll>>& dp) {
    dp.resize(parent.size(), vector<ll>(max2h));
    for (ll i = 0; i < max2h; ++i) {
        for (ll j = 1; j < (ll)parent.size(); ++j) {
            if (i == 0) dp[j][i] = parent[j];
            else dp[j][i] = dp[dp[j][i - 1]][i - 1];
        }
    }
}
ll up(ll v, ll k, const vector<vector<ll>>& dp) {
    ll d = max2h;
    while (k != 0) {
        while ((1 << d) > k) --d;
        k -= (1 << d);
        v = dp[v][d];
    }
    return v;
}

ll lca(ll u, ll v, const vector<vector<ll>>& dp, const vector<ll>& depth) {
    if (depth[u] < depth[v]) swap(u, v);
    u = up(u, depth[u] - depth[v], dp);
    if (u == v) return v;
    for (ll k = max2h - 1; k >= 0; --k) {
        if (dp[u][k] != dp[v][k]) {
            u = dp[u][k];
            v = dp[v][k];
        }
    }
    return dp[u][0];
}

int main() {
    ll n;
    cin >> n;
    vector<vector<ll>> dist(n, vector<ll>(n, 0));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            cin >> dist[i][j];
        }
    }

    vector<set<pair<ll, ll>>> ancestors(n, set<pair<ll, ll>>());
    for (ll v = 1; v < n; ++v) {
        for (ll u = 1; u < n; ++u) {
            if (u == v) continue;
            if (dist[u][0] == dist[u][v] + dist[v][0]) {
                ancestors[u].insert({dist[u][v], v});
            }
        }
    }

    vector<ll> parent(n, -1);
    for (ll v = 1; v < n; ++v) {
        if (ancestors[v].size() == 0) {
            cout << "No";
            return 0;
        }
        parent[v] = (ancestors[v].begin())->second;
        if (ancestors[v].size() > 1 && (ancestors[v].begin()++)->first == dist[v][parent[v]]) {
            cout << "No";
            return 0;
        }
    }

    vector<vector<ll>> children(n, vector<ll>());
    for (ll v = 1; v < n; ++v) {
        children[parent[v]].push_back(v);
    }
    vector<bool> visited(n, false);

    vector<ll> depth;
    vector<vector<ll>> dp;
    depth_dfs(0, -1, children, depth);
    build_dp(parent, dp);

    for (ll v = 0; v < n; ++v) {
        for (ll u = 0; u < v; ++u) {
            if (dist[u][v] != dist[u][lca(u, v, dp, depth)] + dist[lca(u, v, dp, depth)][v]) {
                cout << "No";
                return 0;
            }
        }
    }
    cout << "Yes";
}
