#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

vector<bool> used;
vector<vector<int>> g;

void dfs(int v, int p) {
    used[v] = 1;
    for (auto to: g[v]) {
        if (to != p)
            dfs(to, v);
    }
}



const int N = 100000;
int a[N];
int tree[4 * N];

int op(int l, int r){
    return l + r;
}

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = op(tree[2*v+1], tree[2*v+2]);
}

int ask(int v, int l, int r, int askl, int askr) {
    if (l >= askr || r <= askl)
        return 0;
    if (askl <= l && r <= askr)
        return tree[v];
    int m = (l + r) / 2;
    return op(ask(2 * v + 1, l, m, askl, askr), ask(2 * v + 2, m, r, askl, askr));
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int q = 0;
    int m = 0;
    for(int i = 0; i < n; i++){
        int b;
        cin >> b;
        q = q ^ b;
    }
    cout << (q != 0 || n == 1 ? "Alice" : "Dmitry");
}
