#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

vector <vector <int> > g;
int t = -1;
vector <int> Fir;
vector <pair <int, int> > Q;
vector <vector <int> > S;
vector <int> Log;

int LCA(int l, int r)
{
    if(l > r)
        swap(l,r);
    int le = Log[r - l + 1];
    if(Q[S[le][l]].second < Q[S[le][r - (1 << le) + 1]].second)
        return Q[S[le][l]].first;
    else
        return Q[S[le][r - (1 << le) + 1]].first;
}

void dfs(int v, int p, int lev)
{
    ++t;
    Fir[v] = min(Fir[v], t);
    Q[t] = {v, lev};
    for (auto to : g[v])
        if(to != p)
        {
            dfs(to, v, lev + 1);
            ++t;
            Q[t] = {v, lev};
        }
}

int main() {
    int n;
    cin >> n;
    vector<vector<int>> ds(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int t;
            cin >> t;
            ds[i].emplace_back(t);
        }
    }
    vector<int> d(n);
    vector<int> p(n);
    p[0] = -1;
    vector<int> used(n);
    for (int i = 1; i < n; i++) { d[i] = 2'000'000'000; }
    for (int i = 0; i < n; i++) {
        int v = -1;
        for (int j = 0; j < n; j++) {
            if (used[j]) {
                continue;
            }
            if (v == -1 || d[v] > d[j]) {
                v = j;
            }
        }
        used[v] = 1;
        for (int j = 0; j < n; j++) {
            if (used[j]) { continue; }
            if (ds[v][j] < d[j]) {
                d[j] = ds[v][j];
                p[j] = v;
            }
        }
    }
    vector<vector<int>> Dedges(n);
    for (int i = 1; i < n; i++) {
        Dedges[p[i]].emplace_back(i);
    }
    vector<int> Dd(n);
    for (int i = 1; i < n; i++) { Dd[i] = 2'000'000'000; }
    vector<int> mark(n);
    queue<int> q;
    q.push(0);
    Dd[0] = 0;
    while (!q.empty()){
        int v = q.front();
        q.pop();
        for(auto to : Dedges[v]){
            Dd[to]=Dd[v]+ds[v][to];
            q.push(to);
        }
    }
   /* while (true) {
        int v = -1;
        for (int i = 0; i < n; i++) {
            if (mark[i] || Dd[i] == 2'000'000'000) { continue; }
            if (v == -1 || Dd[v] > Dd[i]) { v = i; }
        }
        if (v == -1) { break; }
        mark[v] = 1;
        for (int j = 0; j < Dedges[v].size(); j++) {
            Dd[Dedges[v][j]] = min(Dd[Dedges[v][j]], Dd[v] + ds[v][Dedges[v][j]]);
        }
    }*/

    {
        g.resize(n);
        for (int i = 1; i < n; ++i)
        {
            g[p[i]].push_back(i);
            g[i].push_back(p[i]);
        }
        Q.resize(2 * n - 1);
        Fir.resize(n, 2 * n + 2);
        dfs(0, 0, 0);
        S.resize(22, vector<int> (2 * n + 10));
        for (int i = 0; i < n * 2 - 1; ++i)
            S[0][i] = i;
        for (int l = 1; (1 << l) <= 2 * n - 1; ++l)
            for (int i = 0; i + (1 << l) - 1 < n * 2 - 1; ++i)
            {
                if(Q[S[l - 1][i]].second < Q[S[l - 1][i + (1 << (l - 1))]].second)
                    S[l][i] = S[l - 1][i];
                else
                    S[l][i] = S[l - 1][i + (1 << (l - 1))];

            }
        Log.resize(n * 2 + 11);
        Log[1] = 0;
        for (int i = 2; i < n * 2 + 10; ++i)
            Log[i] = Log[i / 2] + 1;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int v = LCA(Fir[i],Fir[j]);
            if (Dd[i] + Dd[j] - 2 * Dd[v] != ds[i][j]) {
                cout << "NO";
                return 0;
            }
        }
    }
    cout << "YES";
    return 0;
}





//int gcd(int a, int b) {
//    if(a == 0)
//        return b;
//    if (b == 0)
//        return a;
//    return gcd(b, a % b);
//}
//
//int main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
//    int n;
//    cin >> n;
//    vector<int> a(n);
//    for (int i = 0; i < n; i++)
//        cin >> a[i];
//    int s, f;
//    cin >> s >> f;
//    s--;
//    f--;
//    bool tr = 0;
//    if (s > f) {
//        tr = 1;
//        swap(s, f);
//    }
//    int q = abs(a[s+1]-a[s]);
//    vector<string> ans;
//    /*while (q != 1 && s < f){
//        int j = s;
//        while (j < s){
//            q = gcd(q, a[j + 1]);
//
//        }
//    }*/
//    for (int i = s + 1; i <= f; i++) {
//        if (a[i] - a[i - 1] == 1) {
//            cout << "Impossible";
//            return 0;
//        }
//        int t = abs(a[i] - a[i - 1]);
//        if (gcd(q, t) == 1) {
//            int q0 = q;
//            if(q0 == 0){
//                q0=a[i-1];
//            }
//            if (!tr)
//                ans.push_back("Kaban-" + to_string(q0) + " " + to_string(s + 1) + " " + to_string(i));
//            else
//                ans.push_back("Kaban-" + to_string(q0) + " " + to_string(i) + " " + to_string(s + 1));
//            q = abs(a[i] - a[i - 1]);
//            s = i - 1;
//        } else {
//            q = gcd(q, t);
//        }
//    }
//    if(q == 0)
//        q = a[f];
//    if (!tr)
//        ans.push_back("Kaban-" + to_string(q) + " " + to_string(s + 1) + " " + to_string(f+1));
//    else
//        ans.push_back("Kaban-" + to_string(q) + " " + to_string(f+1) + " " + to_string(s + 1));
//    if(tr){
//        for(int i = ans.size()-1; i>=0;i--){
//            cout << ans[i] << '\n';
//        }
//    }
//    else
//        for(auto i : ans)
//            cout << i << '\n';
//    /*int t;
//    cin >> t;
//    while (t--) {
//        string s;
//        long long k;
//        cin >> s >> k;
//    }*/
//}