#include <iostream>
#include <vector>
#include <queue>
#include <unordered_map>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

string find_route(int n, vector<int>& a, int s, int f) {
    s--;
    f--;

    queue<int> q;
    unordered_map<int, pair<int, int>> parents;
    vector<bool> visited(n, false);

    if (a[s] == a[f]) {
        return "Kaban-" + to_string(a[s] + 1) + ' ' + to_string(s + 1) + ' ' + to_string(f + 1);
    }

    q.push(s);
    visited[s] = true;

    while (!q.empty()) {
        int current = q.front();
        q.pop();

        if (current == f) {
            break;
        }

        for (int neighbor = current + 1; neighbor < n; neighbor++) {
            if (visited[neighbor]) continue;

            int common_m = abs(a[neighbor] - a[current]);
            if (common_m == 0) continue;

            for (int m = 2; m <= common_m; m++) {
                if (common_m % m == 0) {
                    bool valid = true;
                    for (int k = current; k <= neighbor; k++) {
                        if (a[k] % m != a[current] % m) {
                            valid = false;
                            break;
                        }
                    }
                    if (valid) {
                        parents[neighbor] = { current, m };
                        visited[neighbor] = true;
                        q.push(neighbor);
                        break;
                    }
                }
            }
        }

        for (int neighbor = current - 1; neighbor >= 0; neighbor--) {
            if (visited[neighbor]) continue;

            int common_m = abs(a[neighbor] - a[current]);
            if (common_m == 0) continue;

            for (int m = 2; m <= common_m; m++) {
                if (common_m % m == 0) {
                    bool valid = true;
                    for (int k = neighbor; k <= current; k++) {
                        if (a[k] % m != a[current] % m) {
                            valid = false;
                            break;
                        }
                    }
                    if (valid) {
                        parents[neighbor] = { current, m };
                        visited[neighbor] = true;
                        q.push(neighbor);
                        break;
                    }
                }
            }
        }
    }

    if (parents.find(f) == parents.end()) {
        return "Impossible";
    }

    vector<string> route;
    int current = f;
    while (current != -1) {
        auto it = parents.find(current);
        if (it != parents.end()) {
            int prev = it->second.first;
            int m = it->second.second;
            if (prev != -1) {
                route.push_back("Kaban-" + to_string(m) + " " + to_string(prev + 1) + " " + to_string(current + 1));
            }
            current = prev;
        } else {
            break;
        }
    }

    reverse(route.begin(), route.end());
    string result;
    for (const auto& str : route) {
        result += str + "\n";
    }
    return result;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int s, f;
    cin >> s >> f;


    string result = find_route(n, a, s, f);
    cout << result;

    return 0;
}
