#include <vector>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <iostream>
#include <string>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>
#include <algorithm>
#include <functional>
#include <queue>
#include <numeric>
#include <cassert>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define x first
#define y second

#define FAST_ALLOCATOR_MEMORY (400 * 1024 * 1024)

#ifdef FAST_ALLOCATOR_MEMORY
	int allocator_pos = 0;
	char allocator_memory[(int)FAST_ALLOCATOR_MEMORY];
	void * operator new (size_t n) {
		// fprintf(stderr, "n=%ld\n", n);
		char *res = allocator_memory + allocator_pos;
		assert(n <= (size_t)((int)FAST_ALLOCATOR_MEMORY - allocator_pos));
		allocator_pos += n;
		return (void *)res;
	}
	void operator delete (void *) noexcept { }
	void operator delete (void *, size_t) noexcept { }
	//inline void * operator new [] (size_t) { assert(0); }
	//inline void operator delete [] (void *) { assert(0); }
#endif

inline void debug_out() { std::cerr << std::endl; }

template <typename Head, typename... Tail>
inline void debug_out(Head H, Tail... T) {
  std::cerr << " " << H;
  debug_out(T...);
}

#ifdef POSPELOV
#define db(...) std::cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define db(...) 42
#endif

template<typename T> bool smin(T &a, const T &b) { bool ret = b < a; return a = (a < b ? a : b), ret; }
template<typename T> bool smax(T &a, const T &b) { bool ret = a < b; return a = (b < a ? a : b), ret; }

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;

using namespace std;

mt19937 rnd;

void pre() {
}

struct T {
  int y;
  int sz;
  T *l, *r;
  int min_sub;
  int num;
  int x;
  T(int x) : x(x) {
    sz = 1;
    l = r = 0;
    min_sub = x;
    num = 0;
    y = rnd();
  }
};
 
void recalc(T *t) {
  if (!t) {
    return;
  }
  t->sz = 1;
  t->min_sub = t->x;
  t->num = (t->l ? t->l->sz : 0);
  if (t->l) {
    if (smin(t->min_sub, t->l->min_sub) || t->min_sub == t->l->min_sub) {
      t->num = t->l->num;
    }
    t->sz += t->l->sz;
  }
  if (t->r) {
    if (smin(t->min_sub, t->r->min_sub)) {
      t->num = (t->l ? t->l->sz : 0) + 1 + t->r->num;
    }
    t->sz += t->r->sz;
  }
}
 
T *merge(T *l, T *r) {
  if (!l) {
    return r;
  }
  if (!r) {
    return l;
  }
  if (l->y > r->y) {
    l->r = merge(l->r, r);
    recalc(l);
    return l;
  } else {
    r->l = merge(l, r->l);
    recalc(r);
    return r;
  }
}
 
pair<T *, T *> split(T *t, int sz) {
  if (t == 0) {
    return {0, 0};
  }
  int lsz = (t->l ? t->l->sz : 0);
  if (lsz >= sz) {
    auto res = split(t->l, sz);
    t->l = res.second;
    recalc(t);
    return {res.first, t};
  } else {
    auto res = split(t->r, sz - lsz - 1);
    t->r = res.first;
    recalc(t);
    return {t, res.second};
  }
}

int solve() {
  string s;
  ll k;
  cin >> s >> k;
  int n = s.size();

  T *t = 0;
  for (int i = 0; i < n; i++) {
    t = merge(t, new T(s[i] - '0'));
  }

  for (int i = 0; i < n; i++) {
    if (k > 0) {
      int sz = min<int>(k + 1, t->sz);
      auto [l, r] = split(t, sz);
      auto meow = l->num;
      auto [l_l, l_r] = split(l, meow);
      auto [solo, l_r_r] = split(l_r, 1);
      k -= meow;
      t = merge(merge(solo, l_l), merge(l_r_r, r));
    }

    {
      auto [l, r] = split(t, 1);
      t = r;
      cout << l->x;
    }
  }
  cout << "\n";
  return 0;
}

signed main() {
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  pre();
  int t;
  t = 1;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}