#include <vector>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <iostream>
#include <string>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>
#include <algorithm>
#include <functional>
#include <queue>
#include <numeric>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define x first
#define y second

inline void debug_out() { std::cerr << std::endl; }

template <typename Head, typename... Tail>
inline void debug_out(Head H, Tail... T) {
  std::cerr << " " << H;
  debug_out(T...);
}

#ifdef POSPELOV
#define db(...) std::cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define db(...) 42
#endif

template<typename T> bool smin(T &a, const T &b) { bool ret = b < a; return a = (a < b ? a : b), ret; }
template<typename T> bool smax(T &a, const T &b) { bool ret = a < b; return a = (b < a ? a : b), ret; }

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;

using namespace std;

mt19937 rnd;

void pre() {
}

int solve() {
  int n;
  cin >> n;
  vector<vector<int>> a(n, vector<int>(n));
  for (auto &i : a) {
    for (int &j : i) {
      cin >> j;
    }
  }
  int mxd = -1;
  int s = -1;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (smax(mxd, a[i][j])) {
        s = i;
      }
    }
  }

  const int INF = (int)1e9 + 10;
  
  auto od = a[s];

  vector<int> used(n);
  vector<int> d(n, INF);
  vector<int> bst(n, -1);

  vector<vector<pair<int, int>>> g(n);

  d[s] = 0;
  for (int i = 0; i < n; i++) {
    int u = -1, mdst = INF;
    for (int j = 0; j < n; j++) {
      if (!used[j] && smin(mdst, d[j])) {
        u = j;
      }
    }
    if (u == -1) {
      break;
    }
    if (bst[u] != -1) {
      g[u].push_back({bst[u], a[u][bst[u]]});
      g[bst[u]].push_back({u, a[u][bst[u]]});
    }
    used[u] = 1;
    for (int v = 0; v < n; v++) {
      if (used[v]) {
        continue;
      }
      if (d[v] >= od[v] && od[v] == od[u] + a[u][v]) {
        d[v] = od[v];
        if (bst[v] == -1 || a[v][bst[v]] > a[v][u]) {
          bst[v] = u;
        }
      }
      if (d[v] > od[u] + a[u][v]) {
        return cout << "No\n", 0;
      }
    }
  }

  auto dfs = [&](auto self, vector<int> &d, int u)->void {
    for (auto [v, w] : g[u]) {
      if (d[v] != INF) {
        continue;
      }
      d[v] = d[u] + w;
      self(self, d, v);
    }
  };

  for (int i = 0; i < n; i++) {
    vector<int> dsts(n, INF);
    dsts[i] = 0;
    dfs(dfs, dsts, i);
    if (a[i] != dsts) {
      return cout << "No\n", 0;
    }
  }

  cout << "Yes\n";

  return 0;
}

signed main() {
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  pre();
  int t;
  t = 1;
  // cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}