#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <map>
#include <stdint.h>
using namespace std;

uint32_t mask1;
uint32_t mask2;
uint32_t maskkk;

std::map<uint32_t, uint32_t> st;

uint32_t count_mask(std::string s) {
    uint32_t mask = 0;
    for (size_t i = 0; i < 7; i++) {
        if (s[i] == '1') {
            mask |= (1 << i);
        }
    }
    return mask;
}

std::string a[10] = {
    "1110111",
    "0010010",
    "1011101",
    "1011011",
    "0111010",
    "1101011",
    "1101111",
    "1010010",
    "1111111",
    "1111011"
};

uint32_t get_k_1(uint32_t i, uint32_t mask) {
    if (i == 0) {
        return 0;
    }
    uint32_t ans = count_mask(a[i]);
    return mask & ans;
}

uint32_t get_k(uint32_t i, uint32_t mask) {
    uint32_t ans = count_mask(a[i]);
    return mask & ans;
}

uint32_t get(uint32_t i) {
    uint32_t k1 = get_k_1(i / 10, mask1);
    uint32_t k2 = get_k(i % 10, mask2);
    if (st.find(k1) != st.end() && st.find(k2) != st.end()) {
        return st[k1] * 10 + st[k2];
    } else {
        return 100;
    }
}

bool is_possible(uint32_t i, uint32_t j) {
    uint32_t k1 = get_k_1(i / 10, mask1);
    uint32_t k2 = get_k(i % 10, mask2);
    uint32_t kj1 = get_k_1(j / 10, maskkk);
    uint32_t kj2 = get_k(j % 10, maskkk);
    if (k1 != kj1 || k2 != kj2) {
        return false;
    }
    return st.find(k1) != st.end() && st.find(k2) != st.end();
}

signed main() {
    for (size_t i = 0; i < 10; i++) {
        st.emplace(count_mask(a[i]), i);
    }
    maskkk = count_mask(a[8]);
    std::string s, t;
    cin >> s >> t;
    mask1 = count_mask(s);
    mask2 = count_mask(t);

    int max_ans = 0;
    for (uint32_t i = 0; i < 99; i++) {
        int ans = 0;
        int cur = get(i);
        if (cur > 99) {
            continue;
        }
        for (uint32_t j = i + 1; j < min(99u, i + i); j++) {
            if (!is_possible(i - (j - i), cur + (j - i))) {
                ans = j - i - 1;
                if (ans > max_ans) {
                    max_ans = ans;
                }
                break;
            }
        }
    }
    std::cout << max_ans << std::endl;
}
