#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>

using namespace std;

#define int long long
int a[1001][1001];
int lca[1001][1001];
std::vector<int> dist;
std::vector<int> lvl;
std::vector<int> par;
std::vector<pair<int, std::pair<int, int> > > d;
std::vector<vector<std::pair<int, int> > > g;
int n;

void calc_dist(int v) {
    for (size_t i = 0; i < g[v].size(); i++) {
        int k = g[v][i].first;
        if (dist[k] != -1) {
            continue;
        }
        dist[k] = dist[v] + g[v][i].second;
        lvl[k] = lvl[v] + 1;
        par[k] = v;
        calc_dist(k);
    }
}

int calc_lca(int u, int v) {
    while(lvl[u] > lvl[v]) {
        u = par[u];
    }
    while(lvl[v] > lvl[u]) {
        v = par[v];
    }
    while(u != v) {
        v = par[v];
        u = par[u];
    }
    return v;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    par.resize(n);
    g.resize(n);
    lvl.resize(n);
    dist.resize(n, -1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            d.emplace_back(a[i][j], std::make_pair(i, j));
        }
    }
    sort(d.begin(), d.end());
    vector<int> id(n);
    for (size_t i = 0; i < n; i++) {
        id[i] = i;
    }

    for (size_t i = 0; i < d.size(); i++) {
        int first = d[i].second.first;
        int sec = d[i].second.second;
        if (id[first] == id[sec]) {
            continue;
        }
        g[first].emplace_back(sec, d[i].first);
        g[sec].emplace_back(first, d[i].first);
        for (size_t i = 0; i < n; i++) {
            if (id[i] == id[sec]) {
                id[i] = id[first];
            }
        }
    }
    dist[0] = 0;
    lvl[0] = 0;
    par[0] = -1;
    calc_dist(0);
    for (size_t i = 0; i < n; i++) {
        for (size_t j = 0; j < n; j++) {
            int t = calc_lca(i, j);
            if (dist[i] + dist[j] - 2 * dist[t] != a[i][j]) {
                std::cout << "No" << std::endl;
                return 0;
            }
        }
    }
    std::cout << "Yes" << std::endl;

}
