#include <bits/stdc++.h>


// #define __INTERACTIVE_TASK_
// #define __OPT_PRAGMAS__
#if (!defined(__LOCAL_CLANGD_CPP__)) && (!defined(__LOCAL_DEBUG__)) && defined(__OPT_PRAGMAS__)
#	pragma GCC optimize("O3")
#	pragma GCC optimize("unroll-loops")
#	pragma GCC target("avx2,avx,sse4,sse4.1,sse4.2,bmi,bmi2,lzcnt,popcnt")
#endif

#ifndef __LOCAL_ANY_CPP__
#	define __local_run_(code)
#	define __prod_run_(code) \
		do {              \
			code;     \
		} while (0);
#	define __local_stmt_(stmt)
#	define __prod_stmt_(stmt) stmt
#else
#	define __local_run_(code) \
		do {               \
			code;      \
		} while (0);
#	define __prod_run_(code)
#	define __local_stmt_(stmt) stmt
#	define __prod_stmt_(stmt)
#endif


using namespace std;

using ll = long long;
using ull = unsigned long long;
using iii = __int128_t;
using uiii = __uint128_t;
using if32 = int_fast32_t;
using uf32 = uint_fast32_t;
// #define int ll

using vll = vector<ll>;
using vull = vector<ull>;

#define citers(container) (container).begin(), (container).end()

template <typename T> static inline ostream & cvout(const T & farg) { return cout << farg; }

template <typename T, typename... Args>
static inline ostream & cvout(const T & farg, const Args &... args)
{
	cout << farg;
	return cvout(args...);
}

static inline ostream & cvoutnl [[maybe_unused]] ()
{
#if defined(__INTERACTIVE_TASK_) || defined(__LOCAL_DEBUG__)
	return cout << endl;
#else
	return cout << '\n';
#endif
}

template <typename T, typename... Args>
static inline ostream & cvoutnl(const T & farg, const Args &... args)
{
	cout << farg;
	return cvoutnl(args...);
}

template <typename T> static inline istream & cvin(T & farg) { return cin >> farg; }

template <typename T, typename... Args> static inline istream & cvin(T & farg, Args &... args)
{
	cin >> farg;
	return cvin(args...);
}

static inline void _io_speedup [[maybe_unused]] ()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

static inline void _reopen_stdinout [[maybe_unused]] (const char * in, const char * out)
{
	freopen(in, "r", stdin);
	freopen(out, "w", stdout);
}


ll n;
vector<vector<ll>> graph;


struct dsu
{
	vector<ll> p, sz;

	inline dsu(ll n) : p(n), sz(n, 1)
	{
		for (ll i = 0; i < n; ++i) p[i] = i;
	}

	inline ll get(ll v)
	{
		if (p[v] == v) return v;
		return p[v] = get(p[v]);
	}

	inline void unite(ll v, ll u)
	{
		v = get(v);
		u = get(u);
		if (sz[v] > sz[u]) swap(v, u);
		sz[u] += sz[v];
		p[v] = u;
	}
};


struct edge
{
	ll v, u, w;
	constexpr edge(ll v, ll u, ll w) : v(v), u(u), w(w) {}
	constexpr bool operator<(const edge & o) { return w < o.w; }
};

struct edge_to
{
	ll u, w;
	constexpr edge_to(ll u, ll w) : u(u), w(w) {}
};


vector<edge> edges;
vector<vector<edge_to>> tree;
vector<vector<ll>> tree_graph;


void dijkstra(ll start)
{
	tree_graph[start][start] = 0;
	priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> q;
	q.emplace(0, start);
	while (!q.empty())
	{
		auto [cur_len, v] = q.top();
		q.pop();
		if (cur_len > tree_graph[start][v]) continue;
		for (auto [u, w] : tree[v])
		{
			if (tree_graph[start][u] > tree_graph[start][v] + w)
			{
				tree_graph[start][u] = tree_graph[start][v] + w;
				q.emplace(tree_graph[start][u], u);
			}
		}
	}
}


signed main()
{
	_io_speedup();
	// _reopen_stdinout("input.txt", "output.txt");

	ll n;
	cvin(n);
	graph.assign(n, vector<ll>(n));
	edges.reserve((n * n - n) / 2);
	for (ll i = 0; i < n; ++i)
	{
		for (ll j = 0; j < n; ++j) cvin(graph[i][j]);
	}
	for (ll i = 0; i < n; ++i)
	{
		for (ll j = i + 1; j < n; ++j) edges.emplace_back(i, j, graph[i][j]);
	}
	sort(citers(edges));

	dsu d(n);
	for (auto [v, u, w] : edges)
	{
		if (d.get(v) != d.get(u)) d.unite(v, u);
	}

	tree.assign(n, vector<edge_to>());
	for (ll i = 0; i < n; ++i)
	{
		for (ll j = i + 1; j < n; ++j)
		{
			if (d.get(i) == d.get(j))
			{
				tree[i].emplace_back(j, graph[i][j]);
				tree[j].emplace_back(i, graph[i][j]);
			}
		}
	}

	tree_graph.assign(n, vector<ll>(n, numeric_limits<ll>::max()));
	for (ll i = 0; i < n; ++i) dijkstra(i);

	// for (ll i = 0; i < n; ++i)
	// {
	// 	for (ll j = 0; j < n; ++j) cvout(tree_graph[i][j], ' ');
	// 	cvoutnl();
	// }

	if (graph == tree_graph)
		cvoutnl("Yes");
	else
		cvoutnl("No");
	return 0;
}