import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayDeque;
import java.util.Deque;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        int t = Integer.parseInt(bufferedReader.readLine());
        StringBuilder ans = new StringBuilder();

        for (int i = 0; i < t; i++) {
            String[] line = bufferedReader.readLine().split(" ");
            char[] chars = line[0].toCharArray();
            int n = chars.length;
            long k = Long.parseLong(line[1]);

            for (int j = 0; j < n && k > 0; j++) {
                Deque<Integer> deque = new ArrayDeque<>();

                for (int m = j; m < n && m - j <= k; m++) {
                    while (!deque.isEmpty() && chars[deque.peekLast()] > chars[m]) {
                        deque.pollLast();
                    }
                    deque.addLast(m);
                }

                int minIndex = deque.peekFirst();
                long movesNeeded = minIndex - j;

                if (k >= movesNeeded) {
                    char minChar = chars[minIndex];
                    System.arraycopy(chars, j, chars, j + 1, (int) movesNeeded);
                    chars[j] = minChar;
                    k -= movesNeeded;
                }
            }

            ans.append(new String(chars)).append("\n");
        }

        System.out.print(ans);
    }
}
