import java.util.Scanner;

public class WoodenMatrixChecker {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int[][] matrix = new int[n][n];

        // Read the matrix
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                matrix[i][j] = scanner.nextInt();
            }
        }

        // Check if the matrix is wooden
        boolean isWooden = isWoodenMatrix(matrix, n);
        System.out.println(isWooden ? "Yes" : "No");
    }

    private static boolean isWoodenMatrix(int[][] matrix, int n) {
        // Check triangle inequalities for all triplets (i, j, k)
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < n; k++) {
                    if (i != j && j != k && i != k) {
                        if (matrix[i][j] + matrix[j][k] < matrix[i][k] ||
                                matrix[i][k] + matrix[k][j] < matrix[i][j] ||
                                matrix[j][i] + matrix[i][k] < matrix[j][k]) {
                            return false;
                        }
                    }
                }
            }
        }
        return true;
    }
}
