"""def is_wooden_matrix(matrix, n):
    for i in range(n):
        for j in range(n):
            if matrix[i][j] != matrix[j][i]:
                return False  # Матрица не симметрична
            if (i == j and matrix[i][j] != 0) or (i != j and matrix[i][j] <= 0):
                return False  # На диагонали должны стоять нули, остальные элементы - положительные

    # Проверка условий неравенства треугольника
    for i in range(n):
        for j in range(n):
            for k in range(n):
                if matrix[i][j] > matrix[i][k] + matrix[k][j]:
                    return False  # Не выполняется принцип треугольника

    return True

n = int(input().strip())
matrix = [list(map(int, input().strip().split())) for _ in range(n)]

if is_wooden_matrix(matrix, n):
    print("Yes")
else:
    print("No")
"""


def is_wooden_matrix(matrix, n):
    # Проверка симметрии и положительности
    for i in range(n):
        if matrix[i][i] != 0:
            return False  # На главной диагонали должны стоять нули

        for j in range(n):
            if matrix[i][j] < 0 or matrix[i][j] != matrix[j][i]:
                return False  # Негативные элементы или несимметрично

    # Применим алгоритм Флойда-Уоршелла для проверки треугольного неравенства
    dist = [[matrix[i][j] for j in range(n)] for i in range(n)]

    for k in range(n):
        for i in range(n):
            for j in range(n):
                if dist[i][j] > dist[i][k] + dist[k][j]:
                    return False  # Не выполняется неравенство треугольника

    return True


n = int(input().strip())
matrix = [list(map(int, input().strip().split())) for _ in range(n)]

if is_wooden_matrix(matrix, n):
    print("Yes")
else:
    print("No")
