#include <iostream>
#include <vector>

using namespace std;

const int MOD = 998244353;

bool add_with_mod(int a, int b) {
    return (a + b) % MOD;
}

string determine_winner(vector<int>& stones) {
    int xor_sum = 0;
    for (int stone : stones) {
        xor_sum ^= stone;
    }
    
    return xor_sum != 0 ? "Alice" : "Dmitry";
}

void check_input(int n, vector<int>& stones) {
    if (n < 1 || n > 100000 || find(stones.begin(), stones.end(), 0) != stones.end()) {
        throw runtime_error("Invalid input: n should be in range [1, 100000] and stones should not contain zeros");
    }
}

int main() {
    int n;
    cin >> n;
    
    vector<int> stones(n);
    for (int i = 0; i < n; ++i) {
        cin >> stones[i];
    }
    
    check_input(n, stones);
    
    if (n == 1) {
        cout << (stones[0] % 2 ? "Dmitry" : "Alice") << endl;
    } else if (sum(stones) != n && n != 1) {
        cout << determine_winner(stones) << endl;
    } else {
        cout << "Alice" << endl;
    }
    
    return 0;
}
