#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector<string> minimizeNumbers(const vector<pair<string, long long>>& testCases) {
    vector<string> results;

    for (const auto& testCase : testCases) {
        string s = testCase.first;
        long long k = testCase.second;
        int n = s.size();

        for (int i = 0; i < n; ++i) {
            
            long long limit = min(i + k, static_cast<long long>(n - 1));

            
            char minDigit = '9' + 1;
            int minIndex = -1;

            for (int j = i; j <= limit; ++j) {
                if (s[j] < minDigit) {
                    minDigit = s[j];
                    minIndex = j;
                }
            }

            
            if (minIndex != -1 && minIndex != i) {
                for (int j = minIndex; j > i; --j) {
                    swap(s[j], s[j - 1]);
                    k--; 
                }
            }

            if (k <= 0) {
                break;
            }
        }

        results.push_back(s);
    }

    return results;
}

int main() {
    int t;
    cin >> t;
    vector<pair<string, long long>> testCases(t);

    for (int i = 0; i < t; ++i) {
        string s;
        long long k;
        cin >> s >> k;
        testCases[i] = {s, k};
    }

    vector<string> results = minimizeNumbers(testCases);

    for (const string& result : results) {
        cout << result << endl; 
    }

    return 0;
}
