def ordinal_to_n(ordinal):
    # Удаляем внешние фигурные скобки и пробелы
    if ordinal == '{}':
        return 0
    
    # Убираем внешние фигурные скобки
    assert ordinal[0] == '{' and ordinal[-1] == '}'
    ordinal = ordinal[1:-1]
    
    # Разделяем элементы множества
    elements = []
    bracket_count = 0
    current_element = []
    
    for char in ordinal:
        if char == '{':
            if bracket_count > 0:
                current_element.append(char)
            bracket_count += 1
        elif char == '}':
            bracket_count -= 1
            if bracket_count > 0:
                current_element.append(char)
            elif bracket_count == 0:
                elements.append('{' + ''.join(current_element) + '}')
                current_element = []
        elif char == ',':
            if bracket_count == 0:
                continue
            else:
                current_element.append(char)
        else:
            current_element.append(char)
    
    # Определяем максимальный индекс
    indices = []
    for elem in elements:
        indices.append(ordinal_to_n(elem))
    
    # Возвращаем максимальный элемент + 1
    return max(indices) + 1

input_data = input().strip()
result = ordinal_to_n(input_data)

print(result)
